﻿// autor: alexey-dmitrienko@ya.ru

var getScriptLibrary = function( scriptArgs ){
//	scriptArgs = {
//		scriptFile: File
//		name: '', 
//		version: Number, 
//		autor: '', 
//		mail: '', 
//		sites: [ '','' ](URLs), 
//		release: Number (year), 
//		supportApp: [ 'InDesign5', 'Photoshop10', 'Illustrator13', 'InDesign6', 'Photoshop11', 'Illustrator14' ], 
//		supportFS: [ 'Windows', 'Macintosh' ] ,
//		prefsInit: Boolean,
//		consol: Boolean, init output messages to consol
//		log: Boolean, init output messages to log-file
//		logWithoutStart: Boolean\
//		workingDirectory: Folder (Optional)
//		targetengine: Bool (Default - false)
//		notShowAlert: Bool
//		userPrefsInScriptFolder: Bool
//		}
	if( !scriptArgs ) scriptArgs = {};
	var lib = getLib();
	lib.file = scriptArgs.scriptFile || lib.getThisFile();
	if( !lib.file )
		throw new Error( 'Error: current script file not defined' );
	lib.name = scriptArgs.name || lib.getNameOnly( lib.file );
	lib.setTargetengine( scriptArgs.targetengine );
	// log
	lib.logInit = scriptArgs.log;
	lib.logWithoutStart = scriptArgs.logWithoutStart;
	lib.logFILE = new File( lib.file.parent.absoluteURI + '/log.txt' );
	lib.LOG();
	// переводим supportApp в объект
	var _supportApp_ = lib.supportApp;
	lib.supportApp = {};
	for( var i =0; i < _supportApp_.length; i++ ){
		try{
		var parse = /^(.*?)([\d\.]+)?$/.exec(_supportApp_[i]);
		if( parse && parse[1] ){
			var version = parse[2] ? parseFloat(parse[2]) : 0;
			if( lib.supportApp[parse[1]] )
				lib.supportApp[parse[1]] = Math.min( lib.supportApp[parse[1]], version );
			else lib.supportApp[parse[1]] = version;
			}
		}catch(err){}
		}
	// prefs init
	lib.workingDirectory = scriptArgs.workingDirectory;
	if( scriptArgs.prefsInit )
		lib.prefs_Init();
	// consol init
	if( scriptArgs.consol ){
		if( !lib.notShowAler ){
			var mess = new Window('dialog');
			mess.add('statictext', undefined, 'CONSOL' );
			mess.addEventListener('focus', function(e){$.sleep(300);mess.close();});
			mess.center();
			mess.show();
			}
		lib.consolInit = true;
		lib.consol( '========\r========' );
		}
	return lib;
	function getLib(){
		var scriptLIB;
		scriptLIB = {
		libraryVersion: 1.75, // версия библиотеки script
		extensions: {},//объект для регистрации подгруженных расширений
		version: scriptArgs.version || 1,
		autor: scriptArgs.autor || 'Alexey Dmitrienko',
		mail: scriptArgs.mail || 'alexey-dmitrienko@ya.ru',
		sites: scriptArgs.sites || [],
		release: scriptArgs.release || new Date().getFullYear(),
		supportApp: scriptArgs.supportApp || [ // пустой массив - поддержка без ограничений, затем он будет переведен в объект {<appName>: <minVersion>}
			// 'InDesign5', 'Photoshop10', 'Illustrator13', 
			],
		supportFS: scriptArgs.supportFS || [ // пустой массив - поддержка без ограничений
			// 'Windows', 'Macintosh' 
			],
		targetengine: false,
		setTargetengine: function( bool ){
			if( !arguments.length ) return;
			if( bool && lib.getAppName('photoshop') )
				return;
			this.targetengine = bool ? true : false;
			},
		notShowAlert: scriptArgs.notShowAlert,
		//============= Consol =============================
		consolInit: false, // вывод в консоль отключен
		consol: function(){ // arguments
			if( !this.consolInit || !arguments.length )
				return;
			var str = '';
			for( var i = 0; i < arguments.length; i++ ){
				if( arguments[i] == undefined || arguments[i] == null )
					str += ' ' + arguments[i];
				else
					switch( arguments[i].constructor ){
						case String:
						case Boolean:
						case Number:
						str += ' ' + arguments[i];
						break;
						default:
						str += ' ' + arguments[i].toSource();
						}
				}
			$.writeln( str );
			},
		//============= Log ==============================
		logInit: false, // вывод в log-файл отключен
		logFILE: false, // основной файл для вывода лога, переменная заполнится при инициализации библиотеки
		logFiles: [],
		addLogFile: function( file ){
			if( file && file instanceof File )
				this.logFiles.push( file );
			},
		logSTRING: '',
		LOG: function( str, write ){ // write = true
			try{
			if( !this.logInit )
				return;
			if( !this.logStarted ){
				this.logStarted = new Date();
				if( !this.logWithoutStart ){
					this.logSTRING = '===============================================\n';
					this.logSTRING += '[' + this.getFormattedDateTime( this.logStarted ) + '] ' + "Start log for "+this.fullName() + " (" + this.getDisplayName(this.file) +")";
					}
				}
			if( str ){
				str = this.errorToString( str );
				this.logSTRING += (this.logSTRING?'\n':'') + '[' + this.getFormattedDateTime( this.logStarted ) + '] ' + str;
				}
			if( write && this.logSTRING ){
				this.fileWriteLine( this.logFILE, this.logSTRING, {encoding: "utf-8"} );
				for( var i = 0; i < this.logFiles.length; i++ )
					if( this.logFiles[i].absoluteURI != this.logFILE.absoluteURI )
						this.fileWriteLine( this.logFiles[i], this.logSTRING, {encoding: "utf-8"} );
				this.logSTRING = "";
				}
			}catch(err){
				if( !this.logWriteError ){
					this.logWriteError = true;
					this.alertError(err);
					}
				};
			},
		logWriteError: false,
		//============= Script =============================
		file: false,
		getThisFile: function(){ try{ var res = app.activeScript || new File($.fileName); if( !res || res.constructor != File ) throw "error" else return res }catch(err){ return new File(err.fileName) } },
		fullName: function(){return this.name+' v.'+this.version},
		notShowErrorOnThisSession: false,
		alertError: function( errorObject, message ){
			if( errorObject.toString() == "Script finished" ) // если ошибка вызвана функцией exitScript() для завершения работы повторяем ошибку
				throw new Error( "Script finished" );
			try{
			var Str = errorObject+'\r';
			Str+='string: '+errorObject.line+'\r';
			if( message )
				Str+= 'Custom message: ' + message;
			this.LOG( Str, true ); // записывем с сохранением, поскольку ошибка может остановить работу скрипта
			this.consol( Str );
			// window
			if( this.notShowErrorOnThisSession || this.notShowAlert )
				return;
			Str+= '\r'+this.fullName();
			var LIB = this;
			var win = new Window("dialog", this.localize('Error'), undefined, );
			win.margins = 5;
			with(win){
				if( Str.split(/\r/).length > 20 ){
					win.eText = add( "edittext", undefined, Str, {multiline: 'true', } );
					win.eText.preferredSize = [400,150];
					}
				else{
					win.eText = add( "statictext", undefined, Str, {multiline: 'true', } );
					win.eText.justify = "left";
					win.eText.preferredSize = [400,150];
					}
				win.eText.maximumSize = [450,200];
				win.group = add( "group", undefined, undefined );
				win.group.alignment = ['fill', 'top'];
				win.group.orientation = 'row';
				with(win.group){
					win.group.cBox = add( "checkbox", undefined,  this.localize('Not show Error on this session') );
					win.group.cBox.alignment = ['left', 'center'];
					win.group.cBox.graphics.font = ScriptUI.newFont(win.group.cBox.graphics.font.name, win.group.cBox.graphics.font.style, 10);
					win.group.Exit = add( "button", undefined, 'Exit' );
					win.group.Exit.alignment = ['right', 'top'];
					win.group.Ok = add( "button", undefined, 'Ok' );
					win.group.Ok.alignment = ['right', 'top'];
					}
				}
			if( this.targetengine ) // пока не работает как надо
				win.group.Exit.enabled = false;
			else{
				win.group.Exit.onClick = function(){
					this.window.close();
					LIB.exitScript();
					}
				}
			win.group.Ok.onClick = function(){
				if( win.group.cBox.value )
					LIB.notShowErrorOnThisSession = true;
				this.window.close();
				}
			win.center();
			win.show();
			}catch(err){ if(!this.notShowErrorOnThisSession) this.alert(err) }
			},
		systemCheck: function(){
			var support = true; // default support
			var thisApp = this.appName+this.appVersion;
			var reg = new RegExp( this.appName, 'ig' );
			for( var name in this.supportApp ){
				support = false; // если объект содержит записи - включаем проверку
				if( reg.test(name) && (!this.supportApp[name] || this.appVersion >= this.supportApp[name] ) ){
					support = true;
					break;
					}
				}
			if( support && this.supportFS.length )
				for(var i=0;i<this.supportFS.length;i++){
					if(File.fs == this.supportFS[i]){
						support = true;
						break;
						}
					support = false;
					}
			if(support)
				return true;
			if( !this.notShowErrorOnThisSession )
				this.alert( this.localize('This version of a program is not supported') + ':\r'+this.fullName() + '\r\r======================\r'+(this.fullInfo?this.fullInfo():''), this.localize('Error'), true );
			return false;
			},
		exitScript: function( message ){
			message = message || "";
			if( message )
				this.alert( message );
			
			if( this.exitScriptWithFunction && this.exitScriptWithFunction.constructor == Function ){
				try{
					this.exitScriptWithFunction();
					}catch(err){
						this.LOG( err );
						}
				}
			this.LOG( '', true );
			this.saveScriptPrefs();
			if( this.getAppName('indesign') )
				exit(0);
			else
				throw new Error( "Script finished" );
			},
		errorToString: function( err ){
			if( err && err.constructor == Error )
				return 'Error: ' + err + ' \rline: ' + err.line;
			return err;
			},
		alert: function( message, title, errorIcon ){ // message: string[, title: string][, errorIcon: bool=false])
			title = title || this.fullName();
			if( message == undefined )
				return;
			var error = message && message.constructor == Error;
			message = this.errorToString( message );
			this.LOG( message, error );
			if( !this.notShowAlert )
				alert( message, title, (errorIcon || error) );
			},
		//============= ExtendedScript =============================
		isNumber: function( value ){// возвращает true / false, value = Number or String
			var constructorName = this.constructorName( value );
			if( constructorName == 'Number' )
				return true;
			else if( value && constructorName == 'String' )
				return  ( /^\s*?[-+]*?(\d+(\.\d+)*?|(\.\d+)*?)\s*?$/.test(value) );
			return false;
			},
		constructorName: function( value, constructorName ){// возвращает String: имя конструктора ('undefined' | 'null' | constructor.name) , если указан constructorName и он не совпадает с конструктором - возвращает ''
			if( constructorName && constructorName.constructor != String )
				constructorName = undefined;
			if( value == undefined ){
				if( constructorName ) 
					return /undefined/i.test(constructorName) ? 'undefined' : '';
				return 'undefined';
				}
			if( value == null ){
				if( constructorName ) 
					return /null/i.test(constructorName) ? 'null' : '';
				return 'null';
				}
			if( constructorName ) 
				return RegExp(value.constructor.name, 'i').test(constructorName) ? value.constructor.name : '';
			return value.constructor.name;
			},
		getWithPrefix: function( num, targetNum ){ // добавляет к числу префикс, возвращает строку. targetNum - число. под размер которого будет добавлен префикс
			if( this.isNumber(num) )
				num = +num;
			else
				return num;
			var level = targetNum ? Math.floor(targetNum).toString().length : 1; // округляем в меньшую сторону, переводим в строку и получаем её длинну. По умолчанию level = 1
			var res = num.toString();
			var length = Math.floor(num).toString().length; // округляем в меньшую сторону, переводим в строку и получаем её длинну
			while( length++ < level )
				res = '0' + res;
			return res;
			},
		getMonth: function( index, locale ){
			try{
			locale = locale || this.language;
			if( locale == 'ru' )
				return ["Январь", "Февраль", "Март", "Апрель", "Май", "Июнь", "Июль", "Август", "Сентябрь", "Октябрь", "Ноябрь", "Декабрь"][index];
			return ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"][index];
			}catch(err){ return "[getMonth error: index = "+index+"]" }
			},
		getFormattedDateTime: function( date ) {
			date = date && date.constructor == Date ? date : new Date();
			// Gives us: Wed Jul 08 2009 14:05:44 GMT-0700
			// return: Jul 08 2009 14:05:44
			return date.toString().split(" ").slice(1,-1).join(" ");
			},
		//============= Messages =============================
		language: ( $.locale == 'ru_RU' ) ? 'ru' : 'en',
		localize: function( string ){
			return string ? ( this.messages[this.language][string] || string ) : '';
			},
		messages: {
			en: {},
			ru: {
				"Processing": 'Обработка',
				"Warning!": 'Внимание!',
				"Continue?": 'Продолжить?',
				"Preferences": 'Настройки',
				"Report": 'Отчет',
				"Error": 'Ошибка',
				"Do not show Error on this session": 'Больше не показывать',
				"This version of a program is not supported": 'Эта версия программы не поддерживается',
				"Error of data": 'Ошибка данных',
				"File not found": 'Файл не найден',
				"Folder not found": 'Папка не найдена',
				"Error writing file": 'Ошибка записи файла',
				"For MacOS: \ryou yourself must create alias in the folder:\r": 'Для MacOS: \rвы самостоятельно должны создать ярлык в папке:\r',
				"Progress": 'Выполнение',
				"Save as": 'Сохранить как',
//				"Error rename file": 'Ошибка переименования файла',
//				"Error deleting file": 'Ошибка удаления файла',
//				"Error load file": 'Ошибка загрузки данных',
				},
			},
		//============= preferences =============================
		checkVersion: function( defaultPrefObject, loadPrefObject, checkOnly ){ // проверяет загруженный объект настроек на соответствие дефолтовому, возвращает проверенный объект
			// checkOnly - Boolean - только проверка на соответствие, возвращает Boolean
			try{
			if( !loadPrefObject || loadPrefObject.constructor != defaultPrefObject.constructor ){
				if( checkOnly )
					return false;
				return defaultPrefObject;
				}
			var result;
			if( defaultPrefObject.constructor == Object )
				for( var i in defaultPrefObject ){
					if( !loadPrefObject.hasOwnProperty(i) || loadPrefObject[i].constructor != defaultPrefObject[i].constructor ){
						if( checkOnly )
							return false;
						 loadPrefObject[i] = defaultPrefObject[i];
						 }
					else if( defaultPrefObject[i].constructor == Object ){
						result = this.checkVersion( defaultPrefObject[i], loadPrefObject[i] );
						if( checkOnly && !result )
							return false;
						}
					}
			if( checkOnly )
				return true ;
			return loadPrefObject;
			}catch(err){ this.alertError(err); return defaultPrefObject }
			},
		// prefs_Init включает подгрузку и сохраниение настроек. Если используется расширение JSON - инициализировать библиотеку следует с флагом log = false, и после подгрузки расширения JSON вызвать prefs_Init
		prefs_Init: function(){
			if( this.savePrefsStatus ) // если подгрузка уже произошла - прерываем
				return;
			this.prefs = { // по умолчанию
				libraryVersion: this.libraryVersion,
				name: this.name,
				version: this.version,
				}
			if( !this.libraryVersion || !this.name || !this.version )
				return;
			var prefs = this.prefRead();
			if( prefs && prefs.constructor == Object && prefs.name && prefs.name == this.name ){
				if( prefs.libraryVersion && prefs.libraryVersion == this.libraryVersion )
					this.prefs = prefs;
				else if( prefs.user ) // извлекаем только пользовательские настройки, которые будут проверяться при несовпадении версий не библиотекой, а самим скриптом
					this.prefs = {libraryVersion: prefs.libraryVersion, name: prefs.name, version: prefs.version, user: prefs.user};
				}
			else
				this.savePrefsStatus = true; // если подгруженные данные не прошли проверку - перезаписываем их при выходе в любом случае
			// userPrefsInScriptFolder
			if( this.userPrefsInScriptFolder ){
				var userPrefsFile = new File( this.file.parent.absoluteURI + '/' + this.name + '_prefs.txt' );
				if( userPrefsFile.exists ){
					var prefsOfUser = this.prefRead( userPrefsFile );
					if( prefsOfUser && prefsOfUser.constructor == Object )
						this.prefsOfUser = prefsOfUser;
					}
				}
			},
		prefs: {},
		prefsOfUser: {},
		userPrefsInScriptFolder: scriptArgs.userPrefsInScriptFolder,
		savePrefsStatus: false, // нужно-ли сохранять настройки
		saveScriptPrefs: function(){
			if( this.savePrefsStatus ){
				// обновляем версию настроек
				this.prefs.libraryVersion = this.libraryVersion;
				this.prefs.name = this.name;
				this.prefs.version = this.version;
				
				this.prefSave( this.prefs );
				// userPrefsInScriptFolder
				if( this.userPrefsInScriptFolder ){
					var userPrefsFile = new File( this.file.parent.absoluteURI + '/' + this.name + '_prefs.txt' );
					var prefsOfUser = this.prefsOfUser.toSource() != '({})' ? this.prefsOfUser : ( this.workPrefs('user') ? this.workPrefs('user') : false );
					if( !userPrefsFile.exists && !prefsOfUser ){
						}
					else
						this.prefSave( prefsOfUser, userPrefsFile );
					}
				}
			},
		// если value не указан - возвращает значение по адресу path (путь в объект, разделеный точками) или ''
		// открытая ф-ция, через нее все записывается только в слот user
		userPrefs: function( path, value ){
			if( this.userPrefsInScriptFolder ){
				if( value )
					this.savePrefsStatus = true;
				return this.xpath( this.prefsOfUser, path, value );
				}
			else
				return this.workPrefs( 'user.'+path, value );
			},
		// только для внутренних служб библиотеки и расширений
		workPrefs: function( path, value ){
			if( !path )
				return;
			if( value )
				this.savePrefsStatus = true;
			return this.xpath( this.prefs, path, value );
			},
		// ЗАКРЫТЫЕ
		prefSave: function( prefObject, file, encode ){
			var result = true;
			var str = this.objectToSource( prefObject );
			if( file && file.constructor == File )
				result = this.fileWrite( file, str, {encode: encode, encoding: "utf-8"} );
			else
				result = this.fileWrite( this.getPrefFile(), str, {encode: encode, encoding: "utf-8"} );
			},
		prefRead: function( file, decode ){ // return Object
			var res;
			file = file && file.constructor == File ? file : this.getPrefFile();
			res =  file.exists ? this.fileRead( file, {decode: decode} ) : '';
			res = this.sourceToObject( res );
			if( res.constructor == Error ){
				var mess = 'Error object initialisation from file:\r' + file.fsName;
				mess += '\r\r' +'Error message:\r' + res;
				this.alert( mess );
				res = {};
				}
			return res;
			},
		getPrefFolder: function(){
			return this.folderCreate( new Folder(this.getWorkingDirectory().absoluteURI + '/' + this.name) );
			},
		workingDirectory: false,
		getWorkingDirectory: function(){
			if( this.workingDirectory && this.constructorName(this.workingDirectory, 'folder') )
				return this.workingDirectory;
			return new Folder( Folder.userData.absoluteURI + '/Adobe/Scripts' );
			},
		getPrefFile: function(){
			var prefFolder = this.getPrefFolder();
			if( !prefFolder )
				return false;
//			return File(this.getPrefFolder().absoluteURI+'/preferrences_v.'+this.adaptForFileName(this.version)+'_'+this.appName+this.appVersion+'.txt');
			return new File(prefFolder.absoluteURI+'/preferrences_v.'+this.version.toString().split('.')[0]+'_'+this.appName+this.appVersion+'.txt'); // файл настроек меняется только на уровне версий скрипта(т.е. подверсии используют один файл настроек)
			},
		resourcesFolder: function(){
			return this.folderCreate( new Folder(this.getPrefFolder().absoluteURI + '/resources') );
			},
		objectToSource: function( object ){
//			return '';
			if( this.JSON )
				return this.JSON.objectToSource( object );
			if( object == undefined || object == null || !Object.isValid(object) || object instanceof Array )
				return '{}';
//			return encodeURI(uneval(object));
			return uneval( object );
			},
		sourceToObject: function( string ){
			if( /^\s*?$/.test(string) )
				return {};
			if( this.JSON )
				return this.JSON.sourceToObject( string );
			if( !string )
				return {};
//			var source = decodeURI(string).replace(/[\n\r]/g,'\\n').replace(/[\t]/g,'\\t');
			try{
			var res = eval( '('+ string +')' );
			return res && Object.isValid(res) && res.constructor == Object ? res : {};
			}catch(err){
				return err;
				
				this.alertError( err );
				return {};
				}
			},
		xpath: function( object, path, value ){
			if( !object || object.constructor != Object || !path || path.constructor != String )
				return '';
			path = path.replace(/[\.\/]+/g,'.').replace(/^\./,'').replace(/\.$/,'');
			var link = object;
			// не указан value - возвращаем значение
			if( value == undefined ){
				try{
					try{ path = '["' + path.replace(/"/g,'\\"').replace(/\./g,'"]["') + '"]'; }catch(err){ this.alertError(err) }
					return eval( "link"+path+" == undefined ? '' : link"+path+";" );
					}catch(err){ return '' }
				}
			// иначе - записываем и возвращаем значение
			var keys = path.split('.');
			for( var i = 0; i < keys.length-1; i++ ){
				if( !link[keys[i]] || link[keys[i]].constructor != Object )
					link[keys[i]] = {};
				link = link[keys[i]];
				}
			link[keys[keys.length-1]] = value;
			return value;
			},
		//============= file system =============================
		folderCreate: function( folder ){ // folder = Folder or String, return Folder / false
			if( !folder )
				return false;
			if( this.constructorName(folder, 'folder') ){
				}
			else if( this.constructorName(folder, 'string') )
				folder = new Folder( folder );
			else if( this.constructorName(folder, 'file') )
				folder = folder.parent;
			else return false;
			if( !folder.exists ){
				// функция взята из: BobsScriptLibrary
				var oFolder = new Folder( folder.absoluteURI ); // make a new folder object (copy) to play with
				var stk = new Array();
				while( !oFolder.exists ){ // we know this first one will not exist
					stk.push( oFolder ); // so push this folder onto the stack
					oFolder = new Folder( oFolder.path ); // and then check to see if the parent folder exists, if so, stop this loop
					}
				stk2 = new Array(); // this is to remove created folders if one of the subsequent folder creations fails - leave nothing behind
				while ( stk.length > 0 ){ // while there's still stuff in the stack
					oFolder = stk.pop(); // pop off the last one, create it, push it onto the error recovery stack if it works, if it doesn't unwind what we've done
					if( oFolder.create() )
						stk2.push( oFolder );
					else{
						while ( stk2.length > 0 )
							stk2.pop.remove();
						this.alertError( err );
						return false;
						} 
					}
				}
			return folder;
			},
		folderClear: function( folder ){ // return false / true
			var flag = true;
			try{
			var files = folder.getFiles();
			if( files.length )
				for( var i = files.length-1; i > -1; i-- ){
					if( files[i] instanceof Folder )
						flag = this.folderClear( files[i] );
					files[i].remove();
					}
			}catch(err){ flag = false; }
			finally{ return flag }
			},
		fileRead: function( file, opts ){ // opts = { decode: Bool }
			if( !file || !this.constructorName(file, 'file') )
				return false;
			opts = opts && opts.constructor == Object ? opts : {};
			if(!file.exists){
				if( !this.notShowErrorOnThisSession ) 
					this.alert( 'fileRead:\n' + this.localize('File not found') + ':\n\n'+file.fsName, this.localize('Error'), true );
				return false;
				}
			var result = false;
			try{
			file.open( 'r' );
			var result = file.read();
			result = opts.decode ? decodeURI( result ) : result;
			}catch( err ){ 
				this.alertError( err ); 
				result = false; 
				}
			finally{
			file.close();
			}
			return result;
			},
		fileWrite: function( file, string, opts ){ // opts = { encode: Bool, encoding: String }
			if( !file || !this.constructorName(file, 'file') )
				return false;
			opts = opts && opts.constructor == Object ? opts : {};
			var result = false;
			var Err = '';
			string = opts.encode ? encodeURI( string ) : string;
			try{
			if( !file.parent.exists )
				throw ( this.localize('Folder not found') + ": " + file.parent.fsName );
			file.open("w");
			if( opts.encoding && opts.encoding.constructor == String )
				file.encoding = opts.encoding;
			result = file.write( new String(string) );
			if( File.fs == 'Macintosh' )
				result = true;// в MacOS проверить запись не получается - при положит. записи тоже возвращает false,  сравнение записываемой строки и рез-т чтения после записи тоже возвр. false
			}catch( err ){ 
				Err = err;
				result = false; 
				}
			finally{
				file.close();
				if( !result )
					if( !this.notShowErrorOnThisSession ) 
						this.alert( this.localize('Error writing file') + "!\n\nFile:\n" + file.fsName + (Err ? '\r\rSystem message:\r' + Err +'\rline: '+Err.line : ''));
				}
			return result;
			},
		fileWriteLine: function( file, string, opts ){
			if( !file || !this.constructorName(file, 'file') )
				return false;
			opts = opts && opts.constructor == Object ? opts : {};
			var result = false;
			var Err = '';
			string =  opts.encode ? encodeURI( string ) : string;
			try{
			if( !file.parent.exists )
				throw ( this.localize('Folder not found') + ": " + file.parent.fsName );
			file.open('a');
			if( opts.encoding && opts.encoding.constructor == String )
				file.encoding = opts.encoding;
			result = file.writeln( new String(string) );
			if( File.fs == 'Macintosh' )
				result = true;// в MacOS проверить запись не получается - при положит. записи тоже возвращает false,  сравнение записываемой строки и рез-т чтения после записи тоже возвр. false
			}catch( err ){ 
				Err = err;
				result = false; 
				}
			finally{
				file.close();
				if( !result )
					if( !this.notShowErrorOnThisSession ) 
						this.alert( this.localize('Error writing file') + "!\n\nFile:\n" + file.fsName + (Err ? '\r\rSystem message:\r' + Err +'\rline: '+Err.line : ''));
				}
			return result;
			},
		adaptForFileName: function(str){
			return str.toString().replace(/[\r\n\t\\\/:*?"<>|]+/g, '_');
			},
		adaptFsNameForSave: function(fsName){
			return fsName.replace(/\\/g, '/').replace(/\'/g, '\\\'');
			},
		getDisplayName: function(fsObject){
			return fsObject.fsName.split(/[\\\/]/).reverse()[0];
			// функция не использует обратный слеш, 
			// js-код с обратным слешем не проходит через Bridge()
			// return decodeURI( fsObject.absoluteURI ).split('/').reverse()[0]; 
			},
		getNameOnly: function(fsObject){
			return fsObject instanceof Folder ? this.getDisplayName( fsObject ) : this.getDisplayName( fsObject ).split('.').slice(0,-1).join('.');
			},
		getExpansion: function( fsObject ){
			return fsObject instanceof Folder ? '' : this.getDisplayName( fsObject ).split('.').reverse()[0].toLowerCase();
			},
		getFileAlias: function(folder, file, create){
			try{
			var aliases = folder.getFiles(function(file){return file.alias});
			var fileLink = file.absoluteURI;
			for(var i = 0; i < aliases.length; i++)
				if(aliases[i].resolve().absoluteURI == fileLink)
					return aliases[i];
			if(create){
				if(!folder.exists)
					folder.create();
				if(File.fs == 'Macintosh'){
					if( !this.notShowErrorOnThisSession ) 
						this.alert( this.localize('For MacOS: \ryou yourself must create alias in the folder:\r') + folder.fsName);
					return false;
					}
				var alias = new File(folder.absoluteURI + '/'  + this.getDisplayName(file));
				alias.createAlias(file);
				return alias;
				}
			return false;
			}catch(err){this.alertError(err)};
			},
		moveFile: function( FILE, FOLDER ){
			try{
			if( !FOLDER )
				return;
			var folder = this.folderCreate( FOLDER );
			if( !folder )
				throw new Error( 'script.moveFile function error: Folder not found: ' + FOLDER.toString() );
			if( FILE.copy(folder.absoluteURI +"/" + FILE.name) ){
				FILE.remove();
				return true;
				}
			}catch(err){this.alertError(err)};
			},
		getLastCreatedFile: function( folder, fileName, fileExtension ){ // возвращает самый новый файл среди найденных
			// folder: Folder or path
			// fileName: String. Часть имени файла (с начала).
			// fileExtension: String
			try{
			folder = new Folder(folder);
			if( !folder.exists ) return false;
			fileExtension = fileExtension ? '\.'+ fileExtension.replace(/^\./,'') : '';
			// последняя версия определяется по дате создания
			var files = folder.getFiles(function(thisFile) { return ( RegExp('^'+fileName+'.*?'+fileExtension+'$', '').test(thisFile.displayName) ) });
			files.sort( function(a,b){return (a.created > b.created)?1:0} );
			return files.length ? files[files.length-1] : false;
			}catch(err){this.alertError( err ); return false;}
			},
		//============= application data =============================
		appName: app.name.replace('Adobe ',''),
		getAppName: function( str ){ var name = app.name.split(' ').reverse()[0].toLowerCase(); return arguments.length ? (RegExp(name,'ig').test(arguments[0])?name:false) : name; },// если указан str - возвращает результат поиска в строке имени программы
		appVersion: parseFloat( app.version ),
		appVersionCS: function(){
			switch( this.appName ){
				case 'InDesign':
				return this.appVersion - 2;
				case 'Photoshop':
				return this.appVersion - 7;
				case 'Illustrator':
				return this.appVersion - 10;
				default:
				return 0;
				}
			},
		getStartupFolder: function(){
			var folder = new Folder((app.filePath || app.path) + ((this.appName == 'InDesign')?'/Scripts':'') + '/Startup Scripts');
			if(!folder.exists)
				folder.create();
			return folder;
			},
		getInDesignIcon: function( iconCataloquePath ){
			if( iconCataloquePath && this.getAppName('indesign') && this.appVersionCS() >= 5 ){
				var path = app.filePath + '/Plug-Ins/' + iconCataloquePath;
				if( new File(path).exists )
					return ScriptUI.newImage( path );
				return false;
				}
			},
		//============= scriptUI =============================
		images: [],
		writeImage: function(codeStr, name){
			var folder = this.resourcesFolder();
			if(!folder.exists)
				folder.create();
			var pngFile = new File(folder.absoluteURI + '/' + name + '.png');
			if(!pngFile.exists){
				pngFile.encoding = "BINARY";
				if(!this.fileWrite(pngFile, codeStr)){
					this.images[name] = false;
					return false;
					}
				}
			this.images[name] = ScriptUI.newImage(pngFile.absoluteURI);
			return this.images[name];
			},
		getUiObjectIndex: function(uiObject){
			try{
			for(var i = 0; i < uiObject.parent.children.length; i++)
				if(uiObject.parent.children[i] == uiObject)
					return i;
			}catch(err){this.alertError(err)};
			},
		resizeWindow: function( window, sizeIndex, value ){//sizeIndex: 0 - hor, 1 - vert
			try{
			var size = [0,0];
			size[sizeIndex] = value;
			var location = [window.location[0], window.location[1]];
			var bounds = [window.bounds[0], window.bounds[1], window.bounds[2], window.bounds[3]];
			window.location = location;
			window.bounds = [bounds[0], bounds[1], bounds[2]+size[0], bounds[3]+size[1]];
			window.location = location;
			}catch(err){ this.alertError( err ); }
			},
		confirm: function( tittle, message, multiline ){ // return undefined / false / true
			var result = undefined;
			var win = new Window( 'dialog', tittle );
			win.alignChildren = 'right';
			win.margins = 5;
			win.spacing = 5;
			with(win){
				if( message )
					win.Text = add('statictext', undefined, message, {multiline:multiline});
				win.Grp = add('group');
				win.Grp.orientation = 'row';
				win.Grp.spacing = 5;
				with(win.Grp){
					win.Grp.Cancel = add('button', undefined, 'Cancel');
					win.Grp.no = add('button', undefined, 'No');
					win.Grp.ok = add('button', undefined, 'OK');
					}
				}
			win.Grp.Cancel.onClick = function(){
				this.window.close();
				}
			win.Grp.no.onClick = function(){
				result = false;
				this.window.close();
				}
			win.Grp.ok.onClick = function(){
				result = true;
				this.window.close();
				}
			win.defaultElement = win.Grp.ok;
			win.center();
			win.show();
			return result;
			},
		getReportWindow: function( reportText, tittle, reportName, width ){//ОКНО ВЫВОДА РЕЗУЛЬТАТОВ
			tittle = tittle || '';
			width = width || 400;
			var _height = new String( reportText ).split('\r').length;
			var resizeable = this.hasOwnProperty('addDynamicObject');
			if( _height == 1 ) _height = 22;
			else _height = ( _height < 20 ) ? 15*_height : 300;
			var winReport = new Window( 'dialog', tittle, undefined, {resizeable: resizeable} );
			winReport.alignChildren = 'left';
			winReport.margins = 5;
			winReport.spacing = 10;
			with(winReport){
				if( reportName ){
					winReport.Name = add('statictext', undefined, reportName, {multiline:true});
					winReport.Name.preferredSize = [ width, winReport.Name.preferredSize[1] ];
					}
				winReport.Text = add('edittext', undefined, reportText, {multiline:true, readonly: ( File.fs == 'Windows' )});
				winReport.Text.alignment = ["fill", "fill"];
				winReport.Text.preferredSize = [ width, _height ];
				
				winReport.ok = add('button', undefined, 'OK');
				winReport.ok.alignment = 'center';
				};
			winReport.ok.onClick = function(){
				this.window.close();
				}
			//====================== RESIZE
			if( resizeable ){
				script.addDynamicObject( { obj: winReport.Text, moveCoefs: false, resizeCoefs: [1,1], isSeparator: false, windowKeyRestore: script.name+'_ReportWindow' } );
				script.addDynamicObject( { obj: winReport.ok, moveCoefs: ['center',1], resizeCoefs: false, isSeparator: false } );
				if( winReport.Name )
					script.addDynamicObject( { obj: winReport.Name, moveCoefs: false, resizeCoefs: [1,0], isSeparator: false } );
				}
			else{
				winReport.Text.minimumSize = [ width, _height ];
				winReport.ok.minimumSize = winReport.ok.maximumSize = [100, 22 ];
				
				winReport.onResizing = function() {this.layout.resize()}
				winReport.onShow = function(){
					this.layout.layout();
					this.minimumSize = this.preferredSize;
					}
				}

			winReport.center();
			winReport.show();
			},
		getProgressBar: function( container, maxValue, size, location, reverse ){//возвращает progressbar с ф-цией setValue( [num] )
			size = size || [200, 8];
			location = location || [0,0];
			if( File.fs == '_Macintosh' ){ // отключено
				var pBar = container.add('group', [location[0], location[1], location[0]+size[0], location[1]+size[1]]);
				pBar.visible = false;
				pBar.graphics.backgroundColor =
				pBar.graphics.disabledBackgroundColor = // в окне, у которого нет фокуса - ничего не обновляется, disabledBackgroundColor не помогает
					pBar.graphics.newBrush(pBar.graphics.BrushType.SOLID_COLOR, [0/255, 0/255, 255/255, 1]);
				pBar.step = pBar.size[0]/maxValue;
				pBar.value = 0;
				pBar.setValue = function( num ){
					num = num || 1;
					if( !this.value || this.value >= maxValue ){
						this.size = [0, this.size[1]];
						this.visible = true;
						this.value = 0;
						}
					this.value += num;
					this.size = [this.step*this.value, this.size[1]];
					}
				return pBar;
				}
			if( reverse ){
				var pBar = container.add('progressbar', [location[0], location[1], location[0]+size[0], location[1]+size[1]], maxValue, maxValue);
				pBar.setValue = function( num ){
					num = num || 1;
					if( this.value >= maxValue ) this.value = maxValue;
					this.value -= num;
					};
				return pBar;
				}
			var pBar = container.add('progressbar', [location[0], location[1], location[0]+size[0], location[1]+size[1]], 0, maxValue);
			pBar.setValue = function( num ){
				num = num || 1;
				if( (this.value + num) > maxValue ){
					num = (maxValue - this.value) || 1;
					this.value = 0;
					}
				this.value += num;
				};
			return pBar;
			},
		getProgressWindow: function( maxValue, title, reverse ){//return palette{ setValue: function( [num] ) }
			var LIB = this;
			title = title || this.localize('Progress');
			var myProgressPanel = new Window('palette', title);
			myProgressPanel.progressBar = this.getProgressBar( myProgressPanel, maxValue, undefined, undefined, reverse );
			myProgressPanel.setValue = function( num ){
				this.progressBar.setValue( num );
				}
			myProgressPanel.addProgressBar = function( maxValue, reverse ){
				var pBar = LIB.getProgressBar( this, maxValue, undefined, undefined, reverse ); // with 
				pBar.removeBar = function(){
					var win = this.window;
					win.remove( this );
					win.layout.layout( true );
					}
				this.layout.layout( true );
				return pBar;// return  ProgressBar with functs setValue(num) and removeBar()
				}
			myProgressPanel.center();
			return myProgressPanel;
			},
		addGroupListener: function( prefs ){ // prefs = {objs: Array of UIObjects, listener: function( event ), onChangingMode: Bool }
			if( !prefs || !prefs.objs || !prefs.objs || !prefs.listener || prefs.listener.constructor != Function )
				return;
			if( prefs.objs.constructor != Array )
				prefs.objs = [prefs.objs];
			for( var i = 0; i <prefs.objs.length; i++ ){
				if( prefs.objs[i].hasOwnProperty('margins') ){// обработчики для содержимого контейнеров
					if( prefs.onChangingMode )
						prefs.objs[i].addEventListener( 'changing', prefs.listener );
					else{
						prefs.objs[i].addEventListener( 'click', prefs.listener );
						prefs.objs[i].addEventListener( 'change', prefs.listener );
						}
					continue;
					}
				switch( prefs.objs[i].type ){
					case "dropdownlist":
					case "listbox":
					case "treeview":
					case "edittext":
					case "scrollbar":
					case "slider":
						if( prefs.onChangingMode )
							prefs.objs[i].addEventListener( 'changing', prefs.listener );
						else
							prefs.objs[i].addEventListener( 'change', prefs.listener );
					break;
					case "checkbox":
					case "radiobutton":
					case "button":
					case "iconbutton":
						prefs.objs[i].addEventListener( 'click', prefs.listener );
					}
				}
			},
		}
		return scriptLIB;
		};
	}
function extension_scriptInfo( scriptLibrary ){
	if( scriptLibrary && scriptLibrary instanceof Object && scriptLibrary.libraryVersion ){}
	else return;
	var name = 'scriptInfo';
	var version = 1.3;
	var script = scriptLibrary;
	script.extensions[name] = {version: version};
	//=================================
	script.messages.en.info = 'Info';
	script.messages.en.script = 'Script';
	script.messages.en.help = 'Help';
	script.messages.en.system = 'System';
	script.messages.ru.info = 'Информация';
	script.messages.ru.script = 'Скрипт';
	script.messages.ru.help = 'Помощь';
	script.messages.ru.system = 'Система';
	script.supportInfo = function(){
		try{
		var arr_supApps = [];
		for( var name in this.supportApp )
			arr_supApps.push( name + (this.supportApp[name] ? ' ' + this.supportApp[name] + ' and late' : '') );
		var supportFS = this.supportFS.length ? this.supportApp.length : ['Windows','Macintosh'];
		return arr_supApps.join(' / ') + ' // ' + supportFS.join('/');
		}catch(err){this.alertError(err)}
		}
	script.fullInfo = function(){
		return this.fullName()+'\r'+
			'for '+this.supportInfo()+'\r\r'+
			'script of '+this.autor+', '+this.release+'\r'+
			this.mail+'\r'+
			this.sites.join('\r');
		}
	script.getWinInfo = function( addInfo, help ){ // addInfo - additional information about the script
		try{
		addInfo = addInfo ? '\r\r'+addInfo : '';
		help = help || '';
		var thisSite = ( !this.sites || !(this.sites instanceof Array) || this.sites.length == 0 ) ? false : this.sites[0];
		var addScriptInfo = function( container ){
			var item;
			with(container){
				item = add('statictext', undefined, container.window.core.fullInfo() + addInfo , {multiline: true});
				
				var buts = add('group');
				buts.orientation = 'row';
				buts.alignment = 'right';
				buts.margins = [0,10,0,10];
				if( thisSite ){
					var site = buts.add('button', undefined, thisSite);
					site.onClick = function(){
						this.window.core.connectToSite();
						this.window.close();
						}
					}
				}
			}
		var addHelpInfo = function( container ){
			var item = container.add('statictext', undefined, help, {multiline: true, scrolling: true });
			item.preferredSize = [350,300];
			}
		var addSystemInfo = function( container ){
			container.add('statictext', undefined, container.window.core.getSystemInfo(), {multiline: true});
			var item = container.add( "button", undefined, 'working directory' );
			item.alignment = ['left', 'top'];
			item.onClick = function(){
			var dir = script.getWorkingDirectory();
			if( dir )
				dir.execute();
			}
			}
		var winInfo = new Window( 'dialog', this.localize('info') );
		winInfo.core = this;
		winInfo.preferredSize = [400,10];
		winInfo.alignChildren = 'fill';
		winInfo.margins = 5;
		winInfo.spacing = 5;
		if(this.appVersionCS() > 3){//CS4 и старше
			with(winInfo){
				winInfo.tPnl = add('tabbedpanel');
				with(winInfo.tPnl){
					winInfo.tPnl.script = add( 'tab', undefined, this.localize('script') );
					winInfo.tPnl.script.orientation = 'column';
					winInfo.tPnl.script.alignChildren = 'fill';
					addScriptInfo( winInfo.tPnl.script );
					
					if( help ){
						winInfo.tPnl.help = add( 'tab', undefined, this.localize('help') );
						winInfo.tPnl.help.orientation = 'column';
						winInfo.tPnl.help.alignChildren = 'fill';
						addHelpInfo( winInfo.tPnl.help );
						}
					
					winInfo.tPnl.system = add( 'tab', undefined, this.localize('system') );
					winInfo.tPnl.system.orientation = 'column';
					winInfo.tPnl.system.alignChildren = 'fill';
					addSystemInfo( winInfo.tPnl.system );
					}
				}
			}
		else{//CS3
			addScriptInfo( winInfo );
			winInfo.tPnl = winInfo.add( 'panel', undefined, this.localize('system') );
			winInfo.tPnl.alignChildren = 'fill';
			addHelpInfo( winInfo.tPnl );
			addSystemInfo( winInfo.tPnl );
			}
		winInfo.ok = winInfo.add('button', undefined, "OK");
		winInfo.ok.alignment = 'center';
		winInfo.ok.onClick = function(){
			this.window.close();
			}
		winInfo.center();
		winInfo.show();
		}catch(err){this.alertError(err)};
		}
	script.getSystemInfo = function(){
		var str = '';
		try{
		str+=$.os+'\r';
		str+=this.appName+' '+this.appVersion+'\r';
		str+='Language: '+$.locale+'\r';
		str+='ScriptUI: '+ScriptUI.version+'\r';
		str+= '\r' + 'scriptLibrary: '+this.libraryVersion+'\r'
		if( $.fileName && File($.fileName).exists )
			str+= '('+File($.fileName).fsName+')'+'\r';
		if( this.extensions.toSource() != '({})' ){
			str += 'scriptExtensions:\r';
			for( var name in this.extensions )
				str += '   ' + name + ': ' + this.extensions[name].version + (this.extensions[name].description ? ' ('+this.extensions[name].description+')':'') + '\r';
			}
		return str;
		}catch(err){ return str }
		}
	script.connectToSite = function(){
		if( !this.sites || !(this.sites instanceof Array) || this.sites.length == 0 )
			return;
		var thisSite = this.sites[0];
		var urlFile = File(Folder.temp.absoluteURI + '/'+this.adaptForFileName(thisSite)+'.url');
		if(!urlFile.exists)
			this.fileWrite( urlFile, '[DEFAULT]\rBASEURL=http://'+thisSite+'/\r[InternetShortcut]\rURL=http://'+thisSite+'/' );
		try{
			urlFile.execute();
			} catch(err) {this.alertError(err)}
		}
	}
var extension_customDraw = function( scriptLibrary ){
	if( scriptLibrary && scriptLibrary instanceof Object && scriptLibrary.libraryVersion ){}
	else return;
	var name = 'customDraw';
	var version = 1.21;
	var script = scriptLibrary;
	script.extensions[name] = {version: version};
	//=================================
	script.getCustomDraw = function( uiObject, args ){// uiObject = uiObject || array of uiObjects; args = { text: 'myButton', font: 'Tahoma', style: 'Bold', size: 12, textRGB: [0,0,0], bgRGB: [0,0,0] } - добавление текста в uiObject (напр., для добавления текста в iconbutton) и раскраска элемента
		if( uiObject.constructor == Array ){
			for(var i = 0; i < uiObject.length; i++)
				script.getCustomDraw( uiObject[i], args );
//				arguments.callee( uiObject[i], args );
			return;
			}
		try{
		if( !args )//обнуление, убирает ранее установленное форм-ние (текст и цвет)
			args = {}
		var str = '';
		str += 'uiObject.onDraw = function(){';
		str += 'this.graphics.drawOSControl();';
		if(args.text){
			args.textRGB = args.textRGB || [0,0,0];//по умолчанию - Black
			this.addFont( uiObject, args );
			str += 'var textSize = this.graphics.measureString( \''+args.text+'\' );';
			str += 'var x = Math.max(0, (this.size[0] - textSize[0])/2);';
			str += 'var y = Math.max(0, (this.size[1] - textSize[1])/2);';
			str += 'this.graphics.drawString( \''+args.text+'\', this.graphics.newPen( this.graphics.PenType.SOLID_COLOR, ['+args.textRGB[0]+'/255, '+args.textRGB[1]+'/255, '+args.textRGB[2]+'/255, 1], 1 ), x, y);';
			}
		if(args.bgRGB){
			str += 'this.graphics.rectPath( 0, 0, this.size[0], this.size[1] );\
			this.graphics.fillPath( this.graphics.newBrush( this.graphics.BrushType.SOLID_COLOR, ['+args.bgRGB[0]+'/255, '+args.bgRGB[1]+'/255, '+args.bgRGB[2]+'/255, 0.5] ) );'
			}
		str += '};';
		eval( str );
		//активируем изменения
		uiObject.enabled = !uiObject.enabled;
		uiObject.enabled = !uiObject.enabled;
		}catch(err){this.alertError(err)};
		}
	script.addFont = function( uiObject, args ){// args = arguments or uiObject, return uiobject.graphics.font or false. Code of arguments: { font: 'Tahoma', style: 'Bold', size: 12 }, (style: Regular, Bold, Italic, Bolditalic)
		if( args ){
			try{
			if( args.font || args.style || args.size ){
				args.font = args.font || uiObject.graphics.font.name;
				args.style = args.style || uiObject.graphics.font.style;
				args.size = args.size || uiObject.graphics.font.size;
				return uiObject.graphics.font = ScriptUI.newFont(args.font, args.style, args.size);
				}
			else//если через args передан uiobject
				return uiObject.graphics.font = args.graphics.font;
			}catch(err){}
			}
		try{ return uiObject.graphics.font }catch(err){ return false }
		}
	script.addColor = function( uiObject, type, RGB, opacity ){//type: 0 = backgroundColor, 1 = foregroundColor (fontColor), RGB - Array or uiobject or ScriptUIBrush/Pen. Return uiObject.graphics.[type]Color or false
		opacity = opacity && opacity <= 1 ? opacity : 1;
		if( RGB ){
			try{
			if( !type )
				return uiObject.graphics.backgroundColor = 
					RGB instanceof Array ? 
						uiObject.graphics.newBrush(uiObject.graphics.BrushType.SOLID_COLOR, [RGB[0]/255, RGB[1]/255, RGB[2]/255, opacity]) :
/*						RGB instanceof ScriptUIBrush ? 
							RGB : 
							RGB.graphics.backgroundColor ?
								RGB.graphics.backgroundColor : */
								uiObject.graphics.backgroundColor;
			else
				return uiObject.graphics.foregroundColor = 
					RGB instanceof Array ? 
						uiObject.graphics.newPen(uiObject.graphics.PenType.SOLID_COLOR, [RGB[0]/255, RGB[1]/255, RGB[2]/255, opacity], 2) :
/*						RGB instanceof ScriptUIPen ? 
							RGB : 
							RGB.graphics.foregroundColor ? 
								RGB.graphics.foregroundColor : */
								uiObject.graphics.foregroundColor;
			}catch(err){}
			}
		//если не указан RGB - просто возвращаем color объекта
		try{ 
			if( !type )
				return uiObject.graphics.backgroundColor;
			else
				return uiObject.graphics.foregroundColor;
			}catch(err){ return false }
		}
	script.getRGB = function( uiObject, type ){//type: 0 = backgroundColor, 1 = foregroundColor (fontColor)
		var color = this.addColor( uiObject, type );
		if( color )
			return [Math.round(color[0]*255), Math.round(color[1]*255), Math.round(color[2]*255)];
		}
	}
var extension_resizeableWindow = function( scriptLibrary ){
	if( scriptLibrary && scriptLibrary instanceof Object && scriptLibrary.libraryVersion ){}
	else return;
	var name = 'resizeableWindow';
	var version = 2.44;
	var script = scriptLibrary;
	script.extensions[name] = {version: version};
	//=================================
	script.addDynamicObject = function( args ){
		/*
		args: { 
			obj: uiObject or Array
			moveCoefs: [horizontal, vertical], 
			resizeCoefs: [horizontal, vertical], 
			isSeparator: false/0/1 ( 0 - on width, 1 - on height, added function obj.properties.moveSeparator(resize[value,value]) ),
			keyRestore: String,  - only for separator
			window: Window object (Optional) - если не указан obj
			windowMinSize: bool/[bool,bool]/[num,num],
			windowResizeDirections: [horizontal, vertical], (Optional, default: [true,true]),
			windowKeyRestore: String
			}
		*/
		try{
		var obj = args.obj;
		var moveCoefs = args.moveCoefs;
		var resizeCoefs = args.resizeCoefs;
		var keyRestore = args.keyRestore;
		if( this.constructorName(args.isSeparator, 'number') ){
			if( obj.type == 'tabbedpanel' || obj.type == 'tab' )
				args.isSeparator = false;
			else if( !this.extensions['mouseMove'] ){
				args.isSeparator = false;
				this.alert( 'extension_'+name+': extension_mouseMove not found');
				}
			}
		else
			args.isSeparator = false;
		
		var windowMinSize = args.windowMinSize;
		var windowResizeDirections = args.windowResizeDirections || [true, true];
		var windowKeyRestore = args.windowKeyRestore;
		
		
		var script = this;
		if( obj )
			var win = ( obj instanceof Array ) ? obj[0].window : obj.window;
		else if( args.window && args.window.constructor == Window )
			var win = args.window;
		else{
			this.alert( 'addDynamicObject error: window is undefined' );
			return;
			}
/*		if( !win.properties || !win.properties.resizeable ){
			if( win.properties && win.properties.Error ) return;//повторные сообщения не показываем
			this.alert( 'Error: window.properties.resizeable = false' );
			return win.properties ? win.properties.Error = true : win.properties = {Error:true};
			} */
		if( !win.properties || !win.properties.initStatus ){
			if( !win.properties )
				win.properties = {};
			win.properties.initStatus = true;
			win.properties.Objs = [];
			var initFunction = function( event ){
				try{
				var win =  event.target;
				win.removeEventListener('show', initFunction);
				win.properties.Size = [win.size[0],  win.size[1]];
				// для resizeDynamicObject
				if(  win.properties.SizeWatchString )
					win.properties.watch( 'Size', new Function( '',  win.properties.SizeWatchString) );
				for( var i = 0; i <  win.properties.Objs.length; i++ ){
					 win.properties.Objs[i].properties.Location = [ win.properties.Objs[i].location[0], win.properties.Objs[i].location[1]];
					 win.properties.Objs[i].properties.Size = [ win.properties.Objs[i].size[0],  win.properties.Objs[i].size[1]];
					// для resizeDynamicObject
					if(  win.properties.Objs[i].properties.SizeWatchString )
						 win.properties.Objs[i].properties.watch( 'Size', new Function( '',  win.properties.Objs[i].properties.SizeWatchString) );
					}
				win.onResize = new Function( '',  win.properties.functString );
				//===================
				// подгрузка resize и move
				if( !win.keyRestore )
					return;
				var base = script.extensions[name].initialDataBase[win.keyRestore];
				// запоминаем
				for( var i = 0; i < base.length; i++ ){
					if( base[i].size )
						base[i].size = [base[i].object.size[0], base[i].object.size[1]];
					if( base[i].location )
						base[i].location = [base[i].object.location[0], base[i].object.location[1]];
					}
				//подгружаем
				var link = name + '.restoreBase.' + win.keyRestore;
				if(  script.workPrefs(name+'.version') == version && script.workPrefs(link) ){
					link += '.';
					var restore;
					for( var i = 0; i < base.length; i++ ){
						restore = script.workPrefs( link + base[i].key );
						if( restore ){
							if( restore.resize && base[i].size )
								script.resizeDynamicObject( base[i].object, restore.resize[0], restore.resize[1] );
							if( restore.location && base[i].location )
								base[i].object.location = restore.location;
							if( restore.move && base[i].location )
								base[i].object.properties.moveSeparator( [restore.move[0], restore.move[1]] );
							}
						}
					}
				win.addEventListener('close', saveWindowPrefs);
				function saveWindowPrefs(e){
					script.workPrefs(name+'.version', version);
					var link = name + '.restoreBase.' + win.keyRestore;
					script.workPrefs(link, false); // удаляем старые настройки
					link += '.';
					// сохраняем
					for( var i = 0; i < base.length; i++ ){
						if( base[i].size && base[i].object.size.toString() != base[i].size.toString() )
							script.workPrefs(link+base[i].key+'.resize', [base[i].object.size[0]-base[i].size[0], base[i].object.size[1]-base[i].size[1]])
						if( base[i].object.location.toString() != base[i].location.toString() ){
							if( i == 0 ) // location для window
								script.workPrefs(link+base[i].key+'.location', [base[i].object.location[0], base[i].object.location[1]]);
							else
								script.workPrefs(link+base[i].key+'.move', [base[i].object.location[0]-base[i].location[0], base[i].object.location[1]-base[i].location[1]]);
							}
						}
					}
				}catch(err){script.alert(err) }
				}
			win.addEventListener('show', initFunction);
			}
		
		if( obj instanceof Array )
			for( var i = 0; i < obj.length; i++ )
				addDynamics( obj[i] );
		else
			addDynamics( obj );
		//=========================================================
		// PRIVATE FUNCTS
		//=========================================================
		function addDynamics( obj ){
			// добавляем в базу
			if( args.windowKeyRestore ){
				obj.window.keyRestore = args.windowKeyRestore;
				if( !script.extensions[name].initialDataBase )
					script.extensions[name].initialDataBase = {};
				script.extensions[name].initialDataBase[args.windowKeyRestore] = [{object: obj.window, key: args.windowKeyRestore, size:true, location:true}];
				}
			if( obj.window.keyRestore && args.keyRestore && script.constructorName(args.isSeparator, 'number') )
				script.extensions[name].initialDataBase[obj.window.keyRestore].push( {object: obj, key: args.keyRestore, isSeparator: args.isSeparator, location:true} );
			
			if( !obj.properties ) obj.properties = {Size:true, Location:true};
			var win = obj.window;
			win.properties.Objs[win.properties.Objs.length] = obj;//регистрируем объект
			var parent = obj.parent;
			if( !parent.properties )
				parent.properties = {};
			if( !parent.properties.functString ){
				parent.properties.functString = '';
				if( parent == win )
					win.properties.functString = getStringForDynamicWindow();
				parent.properties.functString += 'var resize = [this.size[0]-this.properties.Size[0], this.size[1]-this.properties.Size[1]];';
				}
			var index = script.getUiObjectIndex(obj);
			var sObj = 'this.children['+index+']';
			var sThisObj = 'this.This.children['+index+']';
			if( moveCoefs && ( moveCoefs[0] || moveCoefs[1] ) ){
				var thisLocations = [
					sObj + '.properties.Location[0]' + ( moveCoefs[0] ? '+resize[0]' + (moveCoefs[0]==1?'':'*'+moveCoefs[0]) : '' ),
					sObj + '.properties.Location[1]' + ( moveCoefs[1] ? '+resize[1]' + (moveCoefs[1]==1?'':'*'+moveCoefs[1]) : '' )
					];
				if( moveCoefs[0] == 'center' ) thisLocations[0] = '(this.size[0]-'+sObj+'.size[0])/2';
				if( moveCoefs[1] == 'center' ) thisLocations[1] = '(this.size[1]-'+sObj+'.size[1])/2';
				parent.properties.functString += sObj + '.location = [' + thisLocations.join(',') + '];';
				}
			if( resizeCoefs && ( resizeCoefs[0] || resizeCoefs[1] ) ){
				parent.properties.functString += 
					sObj+'.size = ['+
						sObj + '.properties.Size[0]' + ( resizeCoefs[0] ? '+resize[0]' + (resizeCoefs[0]==1?'':'*'+resizeCoefs[0]) : '' ) + ',' +
						sObj + '.properties.Size[1]' + ( resizeCoefs[1] ? '+resize[1]' + (resizeCoefs[1]==1?'':'*'+resizeCoefs[1]) : '') +
					'];';
				// для resizeDynamicObject
				if( !parent.properties.SizeWatchString ){
					parent.properties.This = parent;
					parent.properties.SizeWatchString = 'var resize = [arguments[2][0]-arguments[1][0], arguments[2][1]-arguments[1][1]];';// arguments = [name, old, new]
					}
				parent.properties.SizeWatchString += 
					sThisObj+'.properties.Size = ['+
						sThisObj + '.properties.Size[0]' + ( resizeCoefs[0] ? '+resize[0]' + (resizeCoefs[0]==1?'':'*'+resizeCoefs[0]) : '' ) + ',' +
						sThisObj + '.properties.Size[1]' + ( resizeCoefs[1] ? '+resize[1]' + (resizeCoefs[1]==1?'':'*'+resizeCoefs[1]) : '') +
					'];';
				}
			if( moveCoefs && ( moveCoefs[0] || moveCoefs[1] ) ){ // в версии 2.2 этот блок был в конце предыдущего блока "if( !parent.properties.SizeWatchString ){", но были проблемы с динамическим перемещением
				var thisLocations = [
					sThisObj + '.properties.Location[0]' + ( moveCoefs[0] ? '+resize[0]' + (moveCoefs[0]==1?'':'*'+moveCoefs[0]) : '' ),
					sThisObj + '.properties.Location[1]' + ( moveCoefs[1] ? '+resize[1]' + (moveCoefs[1]==1?'':'*'+moveCoefs[1]) : '' )
					];
	//			if( moveCoefs[0] == 'center' ) thisLocations[0] = '(this.size[0]-'+sObj+'.size[0])/2';
	//			if( moveCoefs[1] == 'center' ) thisLocations[1] = '(this.size[1]-'+sObj+'.size[1])/2';
				parent.properties.SizeWatchString += sThisObj + '.properties.Location = [' + thisLocations.join(',') + '];';
				}
			parent.properties.functString += sObj+'.size = ' + sObj+'.size;';// повторно вызываем событие против запаздывания
			parent.watch( 'size', new Function( '', parent.properties.functString) );//обработчик добавляется во все контейнеры, в т.ч. и в window
			//======== isSeparator ============
			if( args.isSeparator.constructor == Number && index && index < obj.parent.children.length-1 ){
				var preObj = obj.parent.children[index-1];
				var nextObj = obj.parent.children[index+1];
				var dynamicSeparation = function( resize ){
					if( !resize || !resize[args.isSeparator] )
						return;
					if( preObj.size[args.isSeparator] < 20 )
						resize[args.isSeparator] = 20-preObj.size[args.isSeparator];
					else if( nextObj.size[args.isSeparator] < 20 ) 
						resize[args.isSeparator] = nextObj.size[args.isSeparator]-20;
					script.resizeDynamicObject( preObj, resize[0], resize[1] );//obj, onWidth, onHeight
					script.moveDynamicObject( obj, resize[0], resize[1] );//obj, onWidth, onHeight
					script.moveDynamicObject( nextObj, resize[0], resize[1] );//obj, onWidth, onHeight
					script.resizeDynamicObject(nextObj, -resize[0], -resize[1] );//obj, onWidth, onHeight
					}
				if( args.isSeparator )
					script.addMouseMove( { target: obj, direction: [0,1],  withFunct: dynamicSeparation, notMoveTarget: true } ); 
				else
					script.addMouseMove( { target: obj, direction: [1,0],  withFunct: dynamicSeparation, notMoveTarget: true } );
				obj.properties.moveSeparator = dynamicSeparation;
				}
			}
		function getStringForDynamicWindow(){
			if( windowMinSize ){// преобразуем windowMinSize
				if( windowMinSize.constructor != Array ) 
					windowMinSize = ['this.properties.Size[0]', 'this.properties.Size[1]'];
				else{
					windowMinSize = [
						windowMinSize[0] ? (windowMinSize[0] === true ? 'this.properties.Size[0]' : windowMinSize[0]) : false, 
						windowMinSize[1] ? (windowMinSize[1] === true ? 'this.properties.Size[1]' : windowMinSize[1]) : false
						];
					}
				}
			if( windowResizeDirections || windowMinSize ){
				var width = 'this.bounds[2]';//ширина
				if( windowResizeDirections && !windowResizeDirections[0] )
					width = 'this.bounds[0]+this.properties.Size[0]';
				else if( windowMinSize && windowMinSize[0] )
					width = 'this.bounds[0]+(this.size[0] < '+windowMinSize[0]+' ? '+windowMinSize[0]+' : this.size[0])';
				var height = 'this.bounds[3]';//ширина
				if( windowResizeDirections && !windowResizeDirections[1] )
					height = 'this.bounds[1]+this.properties.Size[1]';
				else if( windowMinSize && windowMinSize[1] )
					height = 'this.bounds[1]+(this.size[1] < '+windowMinSize[1]+' ? '+windowMinSize[1]+' : this.size[1])';
				return 'this.bounds = [this.bounds[0],this.bounds[1],'+width+','+height+'];';
				}
			return '';
			}
		
		}catch(err){ this.alertError(err) }
		}
	script.resizeDynamicObject = function( obj, onWidth, onHeight ){
		try{
			if( onWidth ){
				if( obj == obj.window ){
					this.resizeWindow( obj, 0, onWidth );// ( window, sizeIndex, value ){//sizeIndex: 0 - hor, 1 - vert
					obj.size = obj.size; // вызываем watch
//					obj.onResize();
					}
				else{
					var oldWidth = obj.size[0];
					obj.size = [obj.size[0]+onWidth, obj.size[1]];
					obj.size = obj.size; // вызываем watch
					obj.properties.Size = [obj.properties.Size[0]+(obj.size[0]-oldWidth), obj.properties.Size[1]];
					}
				}
			}catch(e){}
		try{
			if( onHeight ){
				if( obj == obj.window ){
					this.resizeWindow( obj, 1, onHeight );// ( window, sizeIndex, value ){//sizeIndex: 0 - hor, 1 - vert
					obj.size = obj.size; // вызываем watch
//					obj.onResize();
					}
				else{
					var oldHeight = obj.size[1];
					obj.size = [obj.size[0], obj.size[1]+onHeight];
					obj.size = obj.size; // вызываем watch
					obj.properties.Size = [obj.properties.Size[0], obj.properties.Size[1]+(obj.size[1]-oldHeight)];
					}
				}
			}catch(e){}
        }
	script.moveDynamicObject = function( obj, onWidth, onHeight ){
		try{
			if( obj == obj.window )
				return;
			if( onWidth ){
				var oldWidth = obj.location[0];
				obj.location = [obj.location[0]+onWidth, obj.location[1]];
				obj.properties.Location = [obj.properties.Location[0]+(obj.location[0]-oldWidth), obj.properties.Location[1]];
				}
			}catch(e){}
		try{
			if( onHeight ){
				var oldHeight = obj.location[1];
				obj.location = [obj.location[0], obj.location[1]+onHeight];
				obj.properties.Location = [obj.properties.Location[0], obj.properties.Location[1]+(obj.location[1]-oldHeight)];
				}
			}catch(e){}
        }
	}
var extension_mouseMove = function( scriptLibrary ){
	if( scriptLibrary && scriptLibrary instanceof Object && scriptLibrary.libraryVersion ){}
	else return;
	var name = 'mouseMove';
	var version = 1.1;
	var script = scriptLibrary;
	script.extensions[name] = {version: version};
	//=================================
	script.addMouseMove = function( args ){ // args = { target: uiObject, direction: [bool, bool] (Optional),  withFunct: Function( move=Array[num.num] ), notMoveTarget: Bool }
		if( !args || !args.target )
			return;
		var target = args.target;
		var direction = ( args.direction && args.direction.constructor == Array) ? args.direction : [1,1];
		var withFunct = args.withFunct && args.withFunct.constructor == Function ? args.withFunct : false;
		var notMoveTarget = args.notMoveTarget;
		
		var mousZero, move, indent, workSpace;
		var moveObject = getMoveObjectFunct();
		var window = target.window;
		target.addEventListener( 'mousedown', initMoveEvent );
		function initMoveEvent( e ){
			if( e.button != 0 ) // only left button
				return;
			if( e.target != target ) return;
			mousZero = [e.screenX, e.screenY];
			move = [0,0];
			indent = 15;
			if( target.parent == window )
				workSpace = [
					window.bounds[0]+indent, 
					window.bounds[1]+indent, 
					window.bounds[2]-indent, 
					window.bounds[3]-indent
					];
			else
				workSpace = [
					window.bounds[0]+target.parent.windowBounds[0]+indent, 
					window.bounds[1]+target.parent.windowBounds[1]+indent, 
					window.bounds[0]+target.parent.windowBounds[2]-indent, 
					window.bounds[1]+target.parent.windowBounds[3]-indent
					];
			window.addEventListener( 'mousemove', moveObject );
			window.addEventListener( 'mouseup', removeMoveObject );
	//		window.addEventListener( 'mouseout', removeMoveObject );
			};
		function removeMoveObject(){
			window.removeEventListener( 'mousemove', moveObject);
			window.removeEventListener( 'mouseup', removeMoveObject );
	//		window.removeEventListener( 'mouseout', removeMoveObject );
			};
		function getMoveObjectFunct(){
			var string = '';
			string += 'if( e.screenX < workSpace[0] || e.screenY < workSpace[1] || e.screenX > workSpace[2] || e.screenY > workSpace[3] ) removeMoveObject() else {';
			string += 'move = ['+(direction[0]?'e.screenX-mousZero[0]':0)+','+(direction[1]?'e.screenY-mousZero[1]':0)+'];';
			string += 'mousZero = [e.screenX, e.screenY];';
			if( !notMoveTarget )
				string += 'target.location = [target.location[0]+move[0], target.location[1]+move[1]];';
			if( withFunct && withFunct.constructor == Function )
				string += 'withFunct( move );';
			string += '}';
			return new Function( 'e', string );
			};
		}
	}
var extension_contextMenu = function( scriptLibrary ){
	if( scriptLibrary && scriptLibrary instanceof Object && scriptLibrary.libraryVersion ){}
	else return;
	var name = 'contextMenu';
	var version = 1.32;
	var script = scriptLibrary;
	if( script.appVersionCS() < 4 )
			return script.alert( 'This version of program no support: '+script.appName+' CS'+ script.appVersionCS(), 'extension_contextMenu', true );
	script.extensions[name] = {version: version};
	
	script.alwaysActiveContextMenuItem = function(){ return true };
	script.deactivateContextMenuItem = function(){ return false };
	script.separatorMenuItem = {}; // separator with line
	//=================================
	script.addContextMenu = function( opts ){
		// opts = { target: uiObject, menuItems: Array of menuItems, palette: bool (only for targetengine 'session' and Windows), preAction: function(EVENT, optionsObject){return false/true}, preViewAction(EVENT, listbox) }, optionsObject = {title:"", titleImage: ScriptUIImage}
		// menuItems = { name: "", action: function( EVENT, listItem ), activation: function(EVENT){return true/false} or true, notCloseMenu: bool, image: ScriptUIImage }
		// listbox контекстного меню имеет методы:
		// setTextToItem( listItem. text )
		// getItemByInitName( initName ), где initName - первоначальное имя элемента (т.е. в момент создания меню).
		if( !opts )
			return;
		var uiObject = opts.target;
		var items = opts.menuItems;
		var paletteType = ( (opts.palette || this.targetengine) && File.fs == 'Windows');
		var preAction = opts.preAction && opts.preAction.constructor == Function ? opts.preAction : function(){return true};
		var preViewAction = opts.preViewAction && opts.preViewAction.constructor == Function ? opts.preViewAction : function(){};
		if( !items || items.constructor != Array )
			return;
		var names = [];
		var activation;
		var imagesStatus; // присутствует ли графика
		var line = "____________"; // separator
		for( var i = 0; i < items.length; i++ )
			if (items[i].name && line.length < items[i].name.length ) line = items[i].name;
		line = line.replace(/./g,'_');
		var elements = { "":{ activation: script.deactivateContextMenuItem }};
		elements[line] = { activation: script.deactivateContextMenuItem };
		var elementsByID = {};
		for( var i = 0; i < items.length; i++ ){
			if( items[i].constructor != Object ) continue;
			if( items[i] == script.separatorMenuItem ){
				names.push( line );
				continue;
				}
			if( !items[i].name ){
				names.push( "" );
				continue;
				}
			names.push( items[i].name );
			if( !items[i].action || items[i].action.constructor != Function ){
				elements[items[i].name] = { activation: script.deactivateContextMenuItem };
				continue;
				}
			if( !items[i].activation )
				activation = script.deactivateContextMenuItem;
			else if( items[i].activation===true )
				activation = script.alwaysActiveContextMenuItem;
			else if( items[i].activation.constructor == Function )
				activation =  items[i].activation;
			else
				activation = script.deactivateContextMenuItem;
			elements[items[i].name] = {
				action: items[i].action,
				activation: activation,
				notCloseMenu: items[i].notCloseMenu ? true : false
				}
			if( items[i].image && items[i].image.constructor == ScriptUIImage ){
				elements[items[i].name].image = items[i].image;
				imagesStatus = true;
				}
			}
		if( !paletteType ){
			elements[line] = { activation: script.deactivateContextMenuItem };
			elements["Close menu"] = { action: function(){}, activation: script.alwaysActiveContextMenuItem };
/*			if( imagesStatus ){
				var icon = script.getInDesignIcon( 'Workgroup/(Workgroup UI Resources)/idrc_PNGA/4518.idrc' );
				if( icon )
					elements.Close.image = icon;
				}*/
			names = names.concat( [line,"Close menu"] );
			}
		uiObject.addEventListener( "mousedown", contextMenu );
		
		function contextMenu(e){
			if( e.button != 2 ) // only right button
				return;
			var options = {title:""};
			if( !preAction(e, options) )
				return;
			var EVENT = {};
			for( var i in e )
				EVENT[i] = e[i];
			e.preventDefault();
			e.target.active = true;// переводим фокус на цель
			var CM = new Window (paletteType?"palette":"dialog", undefined, undefined, {borderless: (File.fs=='Windows')});
			if( paletteType ){
				CM.addEventListener( "blur", function(){CM.close(); delete CM} );
				}
			CM.margins = 0;
			CM.opacity = 0.8;
			
			var thisNames = options.title ? [options.title,""].concat( names ) : names;
			var STR = options.title && (line.length < options.title.length) ? options.title.replace(/./g,'_') : line;
			var width = CM.graphics.measureString(STR)[0]+(File.fs=='Windows'?10:50);
			var itemHeight = 18;
			if( imagesStatus ){
				CM.lBox = CM.add('listbox', undefined, undefined, {numberOfColumns: 2, showHeaders: false, columnWidths: [25, width]});
				var item;
				for( var i = 0; i < thisNames.length; i++ ){
					item = CM.lBox.add('item', '');
					if( elements[thisNames[i]] && elements[thisNames[i]].image ){
						item.image = elements[thisNames[i]].image;
//						if( item.image.size[1] > itemHeight )
//							itemHeight = item.image.size[1];
						}
					item.subItems[0].text = thisNames[i];
					try{ CM.lBox.items[i].enabled = elements[thisNames[i]] && elements[thisNames[i]].activation(EVENT) ? true : false }catch(err){ script.alertError(err); CM.lBox.items[i].enabled = false }
					CM.lBox.items[i].ID = thisNames[i];
					}
				width += 30;
				}
			else{
				CM.lBox = CM.add('listbox', undefined, undefined, {items: thisNames});
				for( var i = 0; i < thisNames.length; i++ ){
					try{ CM.lBox.items[i].enabled = elements[thisNames[i]] && elements[thisNames[i]].activation(EVENT) ? true : false }catch(err){ script.alertError(err); CM.lBox.items[i].enabled = false }
					CM.lBox.items[i].ID = thisNames[i];
					}
				}
			CM.lBox.itemSize = [undefined, itemHeight];
			CM.lBox.preferredSize = [ width, thisNames.length*itemHeight+10+(File.fs=='Windows'?0:20)];
			CM.lBox.onChange = function(){
				var listItem;
				var element = elements[this.selection.ID];
				//var element = imagesStatus ? elements[this.selection.subItems[0].text] : elements[this.selection.text];
				var action = element.action;
				if( !element.notCloseMenu ){
					this.window.close();
					if( paletteType )
						delete CM;
					}
				else{
					listItem = this.selection;
					this.selection = null;
					}
				try{ action(EVENT, listItem) }catch(err){script.alertError(err)}
				}
			if( script.addMouseMove ){
				script.addMouseMove( { target: CM.lBox, direction: [true, true],  withFunct: function(move){CM.location = [CM.location[0]+move[0], CM.location[1]+move[1]]}, notMoveTarget: true } );
				}
			// = preViewAction =
			CM.lBox.setTextToItem = function( listItem, text ){
				if( !text || !listItem || listItem.parent != this )
					return;
				 if( imagesStatus ) 
					listItem.subItems[0].text = text;
				else
					listItem.text = text;
				}
			CM.lBox.getItemByInitName = function( initName ){
				for( var i = 0; i < this.items.length; i++ ){
					if( this.items[i].ID == initName )
						return this.items[i];
					}
				}
			preViewAction( e, CM.lBox );
			// ==
			CM.location = [
				$.screens[0].right < e.screenX+CM.lBox.preferredSize[0] ? e.screenX - CM.lBox.preferredSize[0] : e.screenX, 
				$.screens[0].bottom < e.screenY+CM.lBox.preferredSize[1] ? e.screenY - CM.lBox.preferredSize[1] : e.screenY, 
				];
			CM.active = true;
			CM.show();
			}
		}
	}
var extension_JSON = function( scriptLibrary ){ // Подерживаемые типы данных: Array, Boolean, Date, Error, File, Folder, Function, Number, Object, RegExp, String, XML
	if( scriptLibrary && scriptLibrary instanceof Object && scriptLibrary.libraryVersion ){}
	else return;
	var name = 'JSON';
	var version = 1.21;
	var script = scriptLibrary;
	script.extensions[name] = {version: version};
	//=================================
	var JSON = script.JSON = {};
	JSON.objectToSource = function( object ){
		if( object == undefined || object == null || !Object.isValid(object) || object instanceof Array )
			return '{}';
		return this.getSource( object );
		}
	JSON.getSource = function( value ){
		if( value == undefined )
			return 'undefined';
		else if( value == null )
			return 'null'; 
		else
			switch( value.constructor ){
				case Boolean:
				case Number:
					return value.toString(); 
				case String:
					return '\"' + encodeURI(value) + '\"'; 
				case Array:
					var res = '';
					for (var i = 0; i < value.length; i++)
						res += (i?',':'') + this.getSource(value[i]);
//							res += (i?',':'') + arguments.callee(value[i]);
					return '['+res+']';
				case Object:
					var res = '';
					var flag = '';
					for (var i in value ){
						if( !i || value[i] == undefined ) continue;
						res += flag + '"' + encodeURI(i) + '": ' + this.getSource(value[i]);
//							res += flag + '"' + encodeURI(i) + '": ' + arguments.callee(value[i]);
						flag = ',';
						}
					return '{'+res+'}';
				case File:
					return 'File(\"'+value.absoluteURI+'\")';
				case Folder:
					return 'Folder(\"'+value.absoluteURI+'\")';
				default://Date, ...
					return value.toSource(); 
				}
		}
	JSON.checkJSONString = function( jsonString ){
		return jsonString && jsonString.constructor == String && 
		( /\=\(/g.test( jsonString
			.replace(/[\s;]/g,' ') // переводим все пробельные символы и 'точка с запятой' в пробел
			.replace(/\\["']/g,'') // удаляем все вложеные кавычки
			.replace(/"[^"]*"/g,'') // удаляем все строки в двойных кавычках
			.replace(/'[^']*'/g,'') // удаляем все строки в одинарных кавычках
			.replace(/^\s*\(+/,'') // удаляем скобки в начале строки, если есть
			.replace(/[^.a-zA-Z\d_](Array|Boolean|Date|Error|File|Folder|Function|Number|Object|RegExp|String|XML|:|,|\[)\s*\(/g,'') // удаляем все поддерживаемые конструкторы, а так же объявления объектов (после двоеточия и запятой, в начале массива)
			.replace(/\s/g,'') // теперь удаляем все пробелы
			.replace(/(function\(.*?\)\{).*?\}/g,'$1}') // удаляем все внутри контейнеров функций
			.replace(/[^.a-zA-Z\d_]function\(/g,'') // и удаляем объявления функций
			) == false )
		? true : false;
		}
	JSON.sourceToObject = function( string ){
		var res;
		if( !string )
			return {};
		if( !this.checkJSONString(string) ){
			this.alert( 'JSON error: uncorrect data:\r\r' + string );
			return {};
			}
		try{
			res = eval( '('+ string +')' );
			}catch(err){
				script.alertError( err );
			}
		finally{
			if( !res || !Object.isValid(res) || res.constructor != Object )
				res = {};
			}
		return this.restoreObject( res );
		}
	JSON.restoreObject = function( object ){
		if( !object )
			return;
		if( object.constructor == Array ){
			for (var i = 0; i < object.length; i++)
				if( object[i] )
					switch( object[i].constructor ){
						case String:
							object[i] = decodeURI(object[i]);
						break;
						case Object:
						case Array:
							object[i] = this.restoreObject(object[i]);
//								arguments.callee(object[i]);
						}
				return object;
			}
		else if( object.constructor == Object ){
			var newObject = {};
			for(var i in object )
				switch( object[i].constructor ){
					case String:
						newObject[decodeURI(i)] = decodeURI(object[i]); 
					break;
					case Object:
					case Array:
						newObject[decodeURI(i)] = this.restoreObject(object[i]);
//							newObject[decodeURI(i)] = arguments.callee(object[i]);
					break;
					default:
						newObject[decodeURI(i)] = object[i];
					}
			return newObject;
			}
		};
	// this.alert('Error: checkSource not initialized'); 
	}
var extension_colorPicker = function( scriptLibrary ){
	if( scriptLibrary && scriptLibrary instanceof Object && scriptLibrary.libraryVersion ){}
	else return;
	var name = 'colorPicker';
	var version = 1.2;
	var script = scriptLibrary;
	script.extensions[name] = {version: version};
	//=================================
	script.getColorPicker = function( selectRGBArray ){ // return selected color (RGB  array)
		try{
		var selectHexRGB = -1;
		if( selectRGBArray && selectRGBArray.constructor == Array && selectRGBArray.toString() != '0,0,0' ){
			selectHexRGB = RGBtoHex( selectRGBArray[0], selectRGBArray[1], selectRGBArray[2] );
			selectHexRGB = parseInt( eval('0x'+selectHexRGB), 10 ); // переводим 16 в 10
			}
		var result = $.colorPicker( selectHexRGB );
		if( result == -1 )
			return;
		else if( result == 0 )
			return [0,0,0];
		else
			return HexToRGB( result.toString() );
		
		function RGBtoHex(R,G,B){
			// http://www.javascripter.net/faq/rgbtohex.htm
			return toHex(R)+toHex(G)+toHex(B);
			function toHex(N) {
				 if (N==null) return "00";
				 N=parseInt(N); if (N==0 || isNaN(N)) return "00";
				 N=Math.max(0,N); N=Math.min(N,255);
				 return "0123456789ABCDEF".charAt((N-N%16)/16)
					  + "0123456789ABCDEF".charAt(N%16);
				}
			}
		function HexToRGB( hexValue ){
			// http://forums.adobe.com/thread/718725?tstart=30
			// НЕПРАВИЛЬНО РАБОТАЕТ
/*			return [ (parseInt(hexValue,16) >> 16) & 0xff,
				(parseInt(hexValue,16) >> 8) & 0xff,
				parseInt(hexValue,16) & 0xff ];*/
			// http://stackoverflow.com/questions/3723846/convert-from-hex-color-to-rgb-struct-in-c
			return [ ((hexValue >> 16) & 0xFF),
				((hexValue >> 8) & 0xFF),
				((hexValue) & 0xFF) ];
			}
		}catch(err){ script.alertError( err ) }
		};
	}
