﻿#targetengine "ScriptUIBuilder"

// alexey-dmitrienko@ya.ru

// INITIALIZE
var scriptFile = null;
// include library and extentions
try{
	// проверяем присутствие библиотеки
	var libIncluded = false;
	try{ libIncluded = getScriptLibrary ? true : false }catch(err){} // при отладке - деактивировать
	// если библиотека  не внедрена - подгружаем
	if( !libIncluded ){
		var libFile = false;
		var scriptFile = function(){ try{ var res = app.activeScript || new File($.fileName); if( !res || res.constructor != File ) throw "error" else return res }catch(err){ return new File(err.fileName) } }();
		if( scriptFile && scriptFile.exists ){
			libFile = getLastVersion( scriptFile.parent, 'scriptLib', 'jsx' );
			if( !libFile ){
				var folder = scriptFile.parent;
				while( true ){
					if( !folder ){
						libFile = false;
						break;
						}
					libFile = getLastVersion( folder.absoluteURI + '/scriptLib', 'scriptLib', 'jsx' );
					if( libFile )
						break;
					folder = folder.parent;
					}
				}
			}
		if( libFile )
			eval("//@include \'" + libFile.absoluteURI + "\';")
		else throw new Error('Error: scriptLib.txt not found');
		}
	//===============
	function getLastVersion( folder, fileName, fileExtension ){ // возвращает файл последней версии
		// folder: Folder or path
		try{
		folder = new Folder(folder);
		if( !folder.exists ) return false;
		fileExtension = fileExtension ? '\.'+ fileExtension : '';
		// последняя версия определяется по дате создания
		var files = folder.getFiles(function(thisFile) { return ( RegExp('^'+fileName+'.*?'+fileExtension+'$', '').test(thisFile.displayName) ) });
		files.sort( function(a,b){return (a.created > b.created)?1:0} );
		return files.length ? files[files.length-1] : false;
		}catch(err){return false}
		}
	}catch(err){ 
		alert( err + '\rline ' + err.line); 
		exit(); 
		}
var script = getScriptLibrary( {
	scriptFile: scriptFile, 
	name: 'ScriptUIBuilder', 
	version: 2.43, 
	release: 2015, 
	supportApp: [ 'InDesign6', 'Photoshop11', 'Illustrator14' ], 
	targetengine: true
	} ); // 'ExtendScript Toolkit3'
//======================================
extension_JSON( script ); // подгружаем проверку JSON
//======================================
extension_scriptInfo( script );
extension_resizeableWindow( script );
extension_mouseMove( script );
extension_customDraw( script );
extension_contextMenu( script );
extension_colorPicker( script );
//images
script.writeImage(
	"\u0089PNG\r\n\x1A\n\x00\x00\x00\rIHDR\x00\x00\x00\x01\x00\x00\x00\x01\b\x02\x00\x00\x01\u00E7pcH\x00\x00\x00\x19tEXtSoftware\x00Adobe ImageReadyq\u00C9e<\x00\x00\x00\fIDATx\u00DAc\u00FA\u00FF\u00FF?\x00\x06\x06\x03\x00\u00F7\u0098\u00DEN\x00\x00\x00\x00IEND\u00AEB`\u0082", 
	'zero'
	);
//=========== СЛУЖЕБНЫЕ ФУНКЦИИ ====================
var WORKS = {
	folderCurrent: function( fsObject ){//назначение папки по умолчанию
		Folder.current = fsObject ? (fsObject instanceof Folder ? fsObject : fsObject.parent) : Folder.desktop;
		},
	openingError: [],
	fileExists: function( link ){//проверка линков на image при загрузке проекта
		if( link == undefined || !link )//если линк не определен
			return false;
		if( !File(link).exists ){//если он не существует
			var thisError = 'File is not found:\r'+link+'\r';
			var marker = true;
			if( this.openingError.length > 0 )
				for( var i =0; i < this.openingError.length; i++ )
					if( this.openingError[i] == thisError ){
						marker = false;
						break;
						}
			if( marker )
				openingError.push( thisError );
			return false;
			}
		return true;
		},
	testFontNameObject: false, // uiObject, добавляется в init
	testFontName: function( name ){
		if( !this.testFontNameObject ){
			alert( 'WORKS.testFontName(): error: WORKS.testFontNameObject = ' + this.testFontNameObject.constructor.name );
			return false;
			}
		if( /^\s*?$/.test(name) )
			return false;
		try{
			this.testFontNameObject.graphics.font = ScriptUI.newFont(name, 'Regular', 12);
			return true;
			}
		catch(error){}
		},
	}


var CORRECTS = {
	dataCorrect: function(thisData){//запрет на отрицательное значение
		if(!thisData||+thisData<0)
			return 0;
		return thisData;
		},
	dataCorrectEnter: function( text ){//общая ф-ция коррекции ввода цифр
		if( /^\d+$/.test(text) == false )
			return text.replace(/[^\d]/g,'');
		return text;
		},
	dataCorrectEnter_forInterface: function(e){//общая ф-ция коррекции ввода цифр для интерфейса, функция назначается непосредственно ui-объекту
//		var _this = e ? e.target : this;
		var _this = arguments[0] ? arguments[0].target : this;
		if( /^\d+$/.test(_this.text) == false )
			_this.text = _this.text.replace(/[^\d]/g,'');
		},
	dataRound: function( text ){//округление
		if( +text < 0 ) return text;
		var thisData = +( /^(\d+)?(\d)$/.exec(text)[2] );
		if( thisData == 0 )
			return text;
		var thisData2 = 10-thisData;
		return (thisData>4) ? thisData2+ (+text) : (+text)-thisData;
		},
	varCorrect: function(text){//коррекция var
		if(/^(\s+)?$/.test(text))
			return '';
		return text.replace(/^(\d)/,'_$1');
		},
	varCorrectChanging_forInterface: function(){//общая ф-ция коррекции ввода имени переменной для интерфейса, функция назначается непосредственно ui-объекту: function(text){//коррекция var
		var _this = arguments[0] ? arguments[0].target : this;
		if( /[^a-zA-Z\d_]/g.test(_this.text) == true )
			_this.text = _this.text.replace(/[^a-zA-Z\d_]/g,'');
		},
	correctForCode: function( text ){//коррекция всего введенного текста для вывода кода, для obj.text, obj.Name и obj.Help
		return text.replace(/([\\\'\"])/g,'\\$1').replace(/[\r\n]/g,'\\r');
		},
	dataCorrectColor: function( thisData ){//удежание в диапазоне от 0 до 255
		if(!thisData||+thisData<0)
			return 0;
		if(+thisData>255)
			return 255;
		return thisData;
		},
	}

//=========== УСТАНОВКИ ПО УМОЛЧАНИЮ ====================
var SUPPORT = {
	panel: { alignChildren: 1, alignment: 1, children: 1, enabled: 1, helpTip: 1, image: 0, itemSize: 0, indent: 1, location: 1, margins: 1, orientation: 1, parent: 1, properties: 1, size: 1, spacing: 1, text: 1, justify: 0, titleLayout: 0, type: 1, visible: 1, Name: 1, readonly: 0, scrolling: 0, multiline: 0, multiselect: 0, borderStyle: 1, style: 0, toggle: 0, itemHeight: 0, ShortcutKey: 0, NextImages: 0, items: 0, Var: 'panel', textVar: 1, backgroundColor: 1, foregroundColor: 1, font: 1, change: 0, click: 0, },
	tabbedpanel: { alignChildren: 1, alignment: 1, children: 1, enabled: 1, helpTip: 1, image: 0, itemSize: 0, indent: 1, location: 1, margins: 1, orientation: 1, parent: 1, properties: 1, size: 1, spacing: 1, text: 1, justify: 0, titleLayout: 1, type: 1, visible: 1, Name: 1, readonly: 0, scrolling: 0, multiline: 0, multiselect: 0, borderStyle: 0, style: 0, toggle: 0, itemHeight: 0, ShortcutKey: 0, NextImages: 0, items: 0, Var: 'tPanel', textVar: 1, backgroundColor: 1, foregroundColor: 1, font: 1, change: 0, click: 0, },
	tab: { alignChildren: 1, alignment: 1, children: 1, enabled: 1, helpTip: 1, image: 0, itemSize: 0, indent: 0, location: 1, margins: 1, orientation: 1, parent: 1, properties: 1, size: 1, spacing: 1, text: 1, justify: 0, titleLayout: 0, type: 1, visible: 1, Name: 1, readonly: 0, scrolling: 0, multiline: 0, multiselect: 0, borderStyle: 0, style: 0, toggle: 0, itemHeight: 0, ShortcutKey: 0, NextImages: 0, items: 0, Var: 'tab', textVar: 1, backgroundColor: 1, foregroundColor: 1, font: 1, change: 0, click: 0, },
	group: { alignChildren: 1, alignment: 1, children: 1, enabled: 1, helpTip: 1, image: 0, itemSize: 0, indent: 1, location: 1, margins: 1, orientation: 1, parent: 1, properties: 1, size: 1, spacing: 1, text: 0, justify: 0, titleLayout: 0, type: 1, visible: 1, Name: 1, readonly: 0, scrolling: 0, multiline: 0, multiselect: 0, borderStyle: 0, style: 0, toggle: 0, itemHeight: 0, ShortcutKey: 0, NextImages: 0, items: 0, Var: 'group', textVar: 0, backgroundColor: 1, foregroundColor: 1, font: 0, change: 0, click: 0, },

	button: { alignChildren: 0, alignment: 1, children: 0, enabled: 1, helpTip: 1, image: 0, itemSize: 0, indent: 1, location: 1, margins: 0, orientation: 0, parent: 1, properties: 1, size: 1, spacing: 0, text: 1, justify: 0, titleLayout: 0, type: 1, visible: 1, Name: 1, readonly: 0, scrolling: 0, multiline: 0, multiselect: 0, borderStyle: 0, style: 0, toggle: 0, itemHeight: 0, ShortcutKey: 1, NextImages: 0, items: 0, Var: 'but', textVar: 1, backgroundColor: 0, foregroundColor: 1, font: 1, change: 0, click: 1, },
	checkbox: { alignChildren: 0, alignment: 1, children: 0, enabled: 1, helpTip: 1, image: 0, itemSize: 0, indent: 1, location: 1, margins: 0, orientation: 0, parent: 1, properties: 1, size: 1, spacing: 0, text: 1, justify: 0, titleLayout: 0, type: 1, visible: 1, Name: 1, readonly: 0, scrolling: 0, multiline: 0, multiselect: 0, borderStyle: 0, style: 0, toggle: 0, itemHeight: 0, ShortcutKey: 1, NextImages: 0, items: 0, Var: 'cBox', textVar: 1, backgroundColor: 0, foregroundColor: 1, font: 1, change: 0, click: 1, },
	dropdownlist: { alignChildren: 0, alignment: 1, children: 0, enabled: 1, helpTip: 1, image: 0, itemSize: 0, indent: 1, location: 1, margins: 0, orientation: 0, parent: 1, properties: 1, size: 1, spacing: 0, text: 0, justify: 0, titleLayout: 1, type: 1, visible: 1, Name: 1, readonly: 0, scrolling: 0, multiline: 0, multiselect: 0, borderStyle: 0, style: 0, toggle: 0, itemHeight: 0, ShortcutKey: 1, NextImages: 0,items: 1, Var: 'ddList', textVar: 1, backgroundColor: 0, foregroundColor: 1, font: 1, change: 1, click: 0, },
	edittext: { alignChildren: 0, alignment: 1, children: 0, enabled: 1, helpTip: 1, image: 0, itemSize: 0, indent: 1, location: 1, margins: 0, orientation: 0, parent: 1, properties: 1, size: 1, spacing: 0, text: 1, justify: 0, titleLayout: 0, type: 1, visible: 1, Name: 1, readonly: 1, scrolling: 0, multiline: 1, multiselect: 0, borderStyle: 0, style: 0, toggle: 0, itemHeight: 0, ShortcutKey: 1, NextImages: 0, items: 0, Var: 'eText', textVar: 1, backgroundColor: 0, foregroundColor: 1, font: 1, change: 1, click: 0, },
	flashplayer: { alignChildren: 0, alignment: 1, children: 0, enabled: 1, helpTip: 1, image: 0, itemSize: 0, indent: 1, location: 1, margins: 0, orientation: 0, parent: 1, properties: 1, size: 1, spacing: 0, text: 0, justify: 0, titleLayout: 1, type: 1, visible: 1, Name: 1, readonly: 0, scrolling: 0, multiline: 0, multiselect: 0, borderStyle: 0, style: 0, toggle: 0, itemHeight: 0, ShortcutKey: 1, NextImages: 0, items: 0, Var: 'player', textVar: 0, backgroundColor: 0, foregroundColor: 0, font: 0, change: 0, click: 0, },
	iconbutton: { alignChildren: 0, alignment: 1, children: 0, enabled: 1, helpTip: 1, image: { png: true }, itemSize: 0, indent: 1, location: 1, margins: 0, orientation: 0, parent: 1, properties: 1, size: 1, spacing: 0, text: 0, justify: 0, titleLayout: 1, type: 1, visible: 1, Name: 1, readonly: 0, scrolling: 0, multiline: 0, multiselect: 0, borderStyle: 0, style: 1, toggle: 1, itemHeight: 0, ShortcutKey: 1, NextImages: 0, items: 0, Var: 'iconBut', textVar: 0, backgroundColor: 0, foregroundColor: 0, font: 0, change: 0, click: 1, },
	image: { alignChildren: 0, alignment: 1, children: 0, enabled: 1, helpTip: 1, image: { png: true, jpg: true }, itemSize: 0, indent: 1, location: 1, margins: 0, orientation: 0, parent: 1, properties: 1, size: 1, spacing: 0, text: 0, justify: 0, titleLayout: 1, type: 1, visible: 1, Name: 1, readonly: 0, scrolling: 0, multiline: 0, multiselect: 0, borderStyle: 0, style: 0, toggle: 0, itemHeight: 0, ShortcutKey: 1, NextImages: 0, items: 0, Var: 'image', textVar: 0, backgroundColor: 0, foregroundColor: 0, font: 0, change: 0, click: 0, },
	listbox: { alignChildren: 0, alignment: 1, children: 0, enabled: 1, helpTip: 1, image: 0, itemSize: 0, indent: 1, location: 1, margins: 0, orientation: 0, parent: 1, properties: 1, size: 1, spacing: 0, text: 0, justify: 0, titleLayout: 0, type: 1, visible: 1, Name: 1, readonly: 0, scrolling: 0, multiline: 0, multiselect: 1, borderStyle: 0, style: 0, toggle: 0, itemHeight: 1, ShortcutKey: 1, NextImages: 0, items: 1, Var: 'listBox', textVar: 0, backgroundColor: 0, foregroundColor: 1, font: 1, change: 1, click: 0, },
	progressbar: { alignChildren: 0, alignment: 1, children: 0, enabled: 1, helpTip: 1, image: 0, itemSize: 0, indent: 1, location: 1, margins: 0, orientation: 0, parent: 1, properties: 1, size: 1, spacing: 0, text: 1, justify: 0, titleLayout: 0, type: 1, visible: 1, Name: 1, readonly: 0, scrolling: 0, multiline: 0, multiselect: 0, borderStyle: 0, style: 0, toggle: 0, itemHeight: 0, ShortcutKey: 0, NextImages: 0, items: 0, Var: 'pBar', textVar: 1, backgroundColor: 0, foregroundColor: 0, font: 0, change: 0, click: 0, },
	radiobutton: { alignChildren: 0, alignment: 1, children: 0, enabled: 1, helpTip: 1, image: 0, itemSize: 0, indent: 1, location: 1, margins: 0, orientation: 0, parent: 1, properties: 1, size: 1, spacing: 0, text: 1, justify: 0, titleLayout: 0, type: 1, visible: 1, Name: 1, readonly: 0, scrolling: 0, multiline: 0, multiselect: 0, borderStyle: 0, style: 0, toggle: 0, itemHeight: 0, ShortcutKey: 1, NextImages: 0, items: 0, Var: 'rBut', textVar: 1, backgroundColor: 0, foregroundColor: 1, font: 1, change: 0, click: 1, },
	scrollbar: { alignChildren: 0, alignment: 1, children: 0, enabled: 1, helpTip: 1, image: 0, itemSize: 0, indent: 1, location: 1, margins: 0, orientation: 0, parent: 1, properties: 1, size: 1, spacing: 0, text: 0, justify: 0, titleLayout: 0, type: 1, visible: 1, Name: 1, readonly: 0, scrolling: 0, multiline: 0, multiselect: 0, borderStyle: 0, style: 0, toggle: 0, itemHeight: 0, ShortcutKey: 1, NextImages: 0, items: 0, Var: 'sBar', textVar: 0, backgroundColor: 0, foregroundColor: 0, font: 0, change: 1, click: 0, },
	slider: { alignChildren: 0, alignment: 1, children: 0, enabled: 1, helpTip: 1, image: 0, itemSize: 0, indent: 1, location: 1, margins: 0, orientation: 0, parent: 1, properties: 1, size: 1, spacing: 0, text: 0, justify: 0, titleLayout: 0, type: 1, visible: 1, Name: 1, readonly: 0, scrolling: 0, multiline: 0, multiselect: 0, borderStyle: 0, style: 0, toggle: 0, itemHeight: 0, ShortcutKey: 1, NextImages: 0, items: 0, Var: 'slider', textVar: 0, backgroundColor: 0, foregroundColor: 0, font: 0, change: 1, click: 0, },
	statictext: { alignChildren: 0, alignment: 1, children: 0, enabled: 1, helpTip: 1, image: 0, itemSize: 0, indent: 1, location: 1, margins: 0, orientation: 0, parent: 1, properties: 1, size: 1, spacing: 0, text: 1, justify: 'left', titleLayout: 0, type: 1, visible: 1, Name: 1, readonly: 0, scrolling: 1, multiline: 1, multiselect: 0, borderStyle: 0, style: 0, toggle: 0, itemHeight: 0, ShortcutKey: 1, NextImages: 0, items: 0, Var: 'sText', textVar: 1, backgroundColor: 0, foregroundColor: 1, font: 1, change: 0, click: 0, },
	treeview: { alignChildren: 0, alignment: 1, children: 0, enabled: 1, helpTip: 1, image: 0, itemSize: 0, indent: 1, location: 1, margins: 0, orientation: 0, parent: 1, properties: 1, size: 1, spacing: 0, text: 0, justify: 0, titleLayout: 0, type: 1, visible: 1, Name: 1, readonly: 0, scrolling: 0, multiline: 0, multiselect: 0, borderStyle: 0, style: 0, toggle: 0, itemHeight: 1, ShortcutKey: 1, NextImages: 0, items: 1, Var: 'tView', textVar: 0, backgroundColor: 0, foregroundColor: 0, font: 1, change: 1, click: 0, },
	}


var SUPPORT_LAYOUT = {
	panel: {alignChildren: true, alignment: true, characters: false, indent: true, margins: true, maximumSize: true, minimumSize: true, orientation: true, preferredSize: true, spacing: true, title: true, titleLayout: true}, // title и  titleLayout  - поддержка только в режиме tabbedpanel
	group: {alignChildren: true, alignment: true, characters: false, indent: true, margins: true, maximumSize: true, minimumSize: true, orientation: true, preferredSize: true, spacing: true, title: true, titleLayout: true}, // title и  titleLayout  - поддержка только в режиме tabbedpanel
	
	tabbedpanel: {alignChildren: false, alignment: true, characters: false, indent: true, margins: false, indent: true, margins: false, maximumSize: true, minimumSize: true, orientation: false, preferredSize: true, spacing: false, title: true, titleLayout: true},
	tab: {alignChildren: true, alignment: true, characters: false, indent: false, margins: true, maximumSize: false, minimumSize: false, orientation: true, preferredSize: false, spacing: true, title: false, titleLayout: false},

	button: {alignChildren: false, alignment: true, characters: true, indent: true, margins: false, maximumSize: true, minimumSize: true, orientation: false, preferredSize: true, spacing: false, title: false, titleLayout: false},
	checkbox: {alignChildren: false, alignment: true, characters: true, indent: true, margins: false, maximumSize: true, minimumSize: true, orientation: false, preferredSize: true, spacing: false, title: false, titleLayout: false},
	dropdownlist: {alignChildren: false, alignment: true, characters: true, indent: true, margins: false, maximumSize: true, minimumSize: true, orientation: false, preferredSize: true, spacing: false, title: true, titleLayout: true},
	edittext: {alignChildren: false, alignment: true, characters: true, indent: true, margins: false, maximumSize: true, minimumSize: true, orientation: false, preferredSize: true, spacing: false, title: false, titleLayout: false},
	flashplayer: {alignChildren: false, alignment: true, characters: false, indent: true, margins: false, maximumSize: true, minimumSize: true, orientation: false, preferredSize: true, spacing: false, title: true, titleLayout: true},
	iconbutton: {alignChildren: false, alignment: true, characters: false, indent: true, margins: false, maximumSize: true, minimumSize: true, orientation: false, preferredSize: true, spacing: false, title: true, titleLayout: true},
	image: {alignChildren: false, alignment: true, characters: false, indent: true, margins: false, maximumSize: true, minimumSize: true, orientation: false, preferredSize: true, spacing: false, title: true, titleLayout: true},
	listbox: {alignChildren: false, alignment: true, characters: false, indent: true, margins: false, maximumSize: true, minimumSize: true, orientation: false, preferredSize: true, spacing: false, title: false, titleLayout: false},
	progressbar: {alignChildren: false, alignment: true, characters: false, indent: true, margins: false, maximumSize: true, minimumSize: true, orientation: false, preferredSize: true, spacing: false, title: false, titleLayout: false},
	radiobutton: {alignChildren: false, alignment: true, characters: true, indent: true, margins: false, maximumSize: true, minimumSize: true, orientation: false, preferredSize: true, spacing: false, title: false, titleLayout: false},
	scrollbar: {alignChildren: false, alignment: true, characters: false, indent: true, margins: false, maximumSize: true, minimumSize: true, orientation: false, preferredSize: true, spacing: false, title: false, titleLayout: false},
	slider: {alignChildren: false, alignment: true, characters: false, indent: true, margins: false, maximumSize: true, minimumSize: true, orientation: false, preferredSize: true, spacing: false, title: false, titleLayout: false},
	statictext: {alignChildren: false, alignment: true, characters: true, indent: true, margins: false, maximumSize: true, minimumSize: true, orientation: false, preferredSize: true, spacing: false, title: false, titleLayout: false},
	treeview: {alignChildren: false, alignment: true, characters: false, indent: true, margins: false, maximumSize: true, minimumSize: true, orientation: false, preferredSize: true, spacing: false, title: false, titleLayout: false},
	}



var APP_SETTINGS; 
var AUTO_SETTINGS;
var OUTPUT_SETTINGS;
var SETTINGS = { //несохраняемые настройки
	confirmBeforeExit: true, // диалог сохранения проекта перед закрытием
	projectsCount: 5,
	explorerType: 'treeview',//тип проводника по умолчанию
	lightboxColor: [127,127,127],
	projectSize: [200,100],
	highlightColor:[255,0,0],
	Default: {
		itemSize: [undefined,18],
		itemSize_EmptyList: [undefined,20],
		properties: {
			},
		graphics: {
			backgroundColor: {
				color: File.fs=='Windows' ? [200,200,200] : [232, 232, 232]
				},
			foregroundColor: {
				color: [0, 0, 0]
				},
			font: {
				name: ScriptUI.applicationFonts.dialog.name,
				style: ScriptUI.applicationFonts.dialog.style,
				size: ScriptUI.applicationFonts.dialog.size,
				}
			},
		automationLayout: {
			alignment: ['center', 'top'],
			alignChildren: ['center', 'top'],
			titleAlignment: ['left', 'center'],
			},
		},
	accuracy: false, // работа кнопок в режиме 1 пт
	getStep: function(){
		return this.accuracy ? 1 : APP_SETTINGS.userStep;
		},
	saveAppSettings: false,// настройки изменены -->сохранять настройки при выходе
	saveAutoSettings: false,
	saveOutputSettings: false,
	saveLayoutSettings: false,
	savePreferredNames: false,
	setAppSettings: function( settings ){ // настройки авторасстановки
		if( settings ){
			APP_SETTINGS = settings;
			this.saveAppSettings = true;
			}
		else{
			this.saveAppSettings = false;
			APP_SETTINGS = {
				userStep: 5,//шаг работы кнопок размера и координат
				fonts: ['[none]','Lucida Grande','Tahoma'],
				restoreLastSession: true,
				recentProjectsList: false,
				highlightCurrentObject: true,
				modelessDialog: false,
				}
			}
		if( File.fs != 'Windows' || (script.getAppName('photoshop') && script.appVersionCS() > 4) )
			APP_SETTINGS.highlightCurrentObject = false;
		if( File.fs != 'Windows' || !script.getAppName('indesign') )
			APP_SETTINGS.modelessDialog = false;
		if( script.getAppName('photoshop') )
			APP_SETTINGS.recentProjectsList = false;
		},
	setAutoSettings: function( settings ){ // настройки авторасстановки
		if( settings ){
			AUTO_SETTINGS = settings;
			this.saveAutoSettings = true;
			return;
			}
		this.saveAutoSettings = false;
		AUTO_SETTINGS = {
			autoIndent: [5,5],//автоотступ от края родителя [по горизонтали, по вертикали]
			autoSize: {//автовысота и автоширина объектов
				button: [70,22],
				iconbutton: [70,22],
				checkbox: [70,20],
				radiobutton: [70,20],
				statictext: [70,20],
				edittext: [70,20],
				progressbar: ['fill',20],
				scrollbar: ['fill',20],
				slider: ['fill',20],
				dropdownlist: ['fill',20],
				listbox: ['fill',150],
				treeview: ['fill',150],
				panel: ['fill',150],
				group: ['fill',150],
				flashplayer: ['fill',150],
				image: ['fill',150],
				},
			}
		},
	setLayoutSettings: function( settings ){ // настройки авторасстановки
		if( settings ){
			LAYOUT_SETTINGS = settings;
			this.saveLayoutSettings = true;
			return;
			}
		this.saveAutoSettings = false;
		LAYOUT_SETTINGS = {
			autofitWindowProject: true,
			autoFitToContent: false,
			autoLocation: false,
			autoLocationWithinIndent: true, // авторасстановка в пределах действия автоотступов, аквтивна при включенном autoLocation
			autoLocation_restoreIndent: false, // восстановление значений отступов, активна при включенном autoLocationWithinIndent
			}
		},
	setOutputSettings: function( settings ){ // настройки вывода кода
		if( settings ){
			OUTPUT_SETTINGS = settings;
			this.saveOutputSettings = true;
			return;
			}
		this.saveOutputSettings = false;
		OUTPUT_SETTINGS = {//ГЕНЕРАЦИЯ КОДА
			code_varAsTree: true,//вывод в код имени переменной в виде дерева, по умолчанию
			code_createFunctions: false,//создавать контейнеры функций
			tabCode: true,//отбивать табулятором уровни
			varAdd: true,//объявлять переменные через var
			}
		},
	setPreferredNames: function( settings ){ // настройки авторасстановки
		if( settings ){
			PREFERRED_NAMES = settings;
			this.savePreferredNames = true;
			return;
			}
		this.saveAutoSettings = false;
		PREFERRED_NAMES = {};
		for( var type in SUPPORT )
			PREFERRED_NAMES[type] = SUPPORT[type].Var;
		},
	}
//=========== ДАННЫЕ ДИАЛОГА ====================
var LISTS = {
	Default: ['item','item','item'],
	types: [
		'panel',
		'group',
		'-',
		'dropdownlist',
		'listbox',
		'treeview',
		'-',
		'edittext',
		'checkbox',
		'radiobutton',
		'button',
		'iconbutton',
		'scrollbar',
		'slider',
		'-',
		'statictext',
		'progressbar',
		'flashplayer',
		'image'
		],
	dynamic_coefs: ['[none]','1/1','1/2','1/3','1/4','1/5','1/6','1/7','1/8','1/9','1/10'],
	fontStyles: ['Regular','Bold','Italic','BoldItalic'],
	fontSizes: [6,7,8,9,10,11,12,13,14,15,16,17,18,19,20],
	borderStyles: ['black','etched','gray','raised','sunken'],
	styles: ['button','toolbutton'],
	keys: ['Enter','Backspace','Delete','Left arrow','Right arrow','Up arrow','Down arrow','Pageup','Pagedown','Home','End'],
	colors: ['default','-','red','green','blue','-','white','black'],
	}
LISTS.addObjectItems = ['Add new object:','-',].concat(LISTS.types);
//=========== INI ====================
var scriptWinType;
var win;
var uiBuilderLibrary;

ini();
//=================================================================
function ini(){
	if( !script.systemCheck() )
		return;
	
	scriptWinType = script.targetengine ? 'window' : 'dialog';
	
	uiBuilderLibrary = getBuilderLibrary();
	
	script.prefs_Init();// подгружаем настройки
	//======================================
	if( script.userPrefs('APP_SETTINGS.modelessDialog') )
		script.setTargetengine( true );
	
	WORKS.folderCurrent( script.file );//по умолчанию - папка скрипта
	
	// обнуляем состояние флагов сохранения
	SETTINGS.saveAppSettings = false,// настройки изменены -->сохранять настройки при выходе
	SETTINGS.saveAutoSettings = false,// настройки изменены -->сохранять настройки при выходе
	SETTINGS.saveOutputSettings = false,// настройки изменены -->сохранять настройки при выходе
	SETTINGS.saveLayoutSettings = false,// настройки изменены -->сохранять настройки при выходе
	SETTINGS.savePreferredNames = false,// настройки изменены -->сохранять настройки при выходе
	
	// назначаем
	SETTINGS.setAppSettings( script.userPrefs('APP_SETTINGS') );
	SETTINGS.setAutoSettings( script.userPrefs('AUTO_SETTINGS') );
	SETTINGS.setLayoutSettings( script.userPrefs('LAYOUT_SETTINGS') );
	SETTINGS.setOutputSettings( script.userPrefs('OUTPUT_SETTINGS') );
	SETTINGS.setPreferredNames( script.userPrefs('PREFERRED_NAMES') );

	if( (script.getAppName('photoshop') && script.appVersionCS() >= 5) || File.fs != 'Windows' )
		SETTINGS.explorerType = 'listbox';
	
	//============== MAIN ===========================================
	win = createWin();
	win.center();
	win.show();
	}
//=================================================================
function createWin(){
	try{
	if( File.fs == 'Windows' ){
		win = new Window(scriptWinType, script.name, [0,0,983,705], {resizeable: true});
		with(win){
			win.builder = add( "group", [5,5,235,700], undefined );
			with(win.builder){
				// init: add menuItems
				win.builder.projects = add( "listbox", [0,25,230,115], undefined );
				win.builder.listsbox = add( "group", [0,120,230,670], undefined );
				// init: add lists
				win.builder.del = add( "iconbutton", [0,673,22,695], undefined );
				win.builder.moveListItem = add( "group", [178,673,230,695], undefined );
				with(win.builder.moveListItem){
					win.builder.moveListItem.up = add( "iconbutton", [3,0,25,22], undefined, {name: -1, } );
					win.builder.moveListItem.down = add( "iconbutton", [30,0,52,22], undefined, {name: 1, } );
					}
				}
			win.separator = add( "panel", [238,5,241,700], undefined );
			win.lightbox = add( "group", [243,5,743,700], undefined );
			// init: add projects
			win.obj = add( "group", [748,5,978,700], undefined );
			with(win.obj){
				win.obj.addObject = add( "dropdownlist", [0,0,230,22], undefined, {items: LISTS.addObjectItems, } );
				win.obj.but_Global = add( "button", [0,25,55,47], 'Global', {name: '_Global', } );
				win.obj.but_Local = add( "button", [55,25,110,47], 'Local', {name: '_Local', } );
				win.obj.but_Layout = add( "button", [110,25,170,47], 'Layout', {name: '_Layout', } );
				win.obj.but_Dynamic = add( "button", [170,25,230,47], 'Dynamic', {name: '_Dynamic', } );
				win.obj.Global = add( "panel", [0,50,230,525], 'Global' );
				with(win.obj.Global){
					win.obj.Global.item = add( "statictext", [5,17,55,37], 'type' );
					win.obj.Global.item.justify = "right";
					win.obj.Global.Type = add( "dropdownlist", [60,15,220,37], undefined, {name: 'Type', items: LISTS.types, } );
					win.obj.Global.item = add( "statictext", [5,47,55,67], 'var' );
					win.obj.Global.item.justify = "right";
					win.obj.Global.Var = add( "edittext", [60,46,220,66], undefined, {name: 'Var', } );
					win.obj.Global.Visible = add( "checkbox", [10,295,65,315], 'visible', {name: 'Visible', } );
					win.obj.Global.item = add( "statictext", [5,230,60,250], 'helpTip' );
					win.obj.Global.item.justify = "right";
					win.obj.Global.HelpTip = add( "edittext", [65,228,220,248], undefined, {name: 'HelpTip', } );
					win.obj.Global.item = add( "statictext", [6,261,61,281], 'name' );
					win.obj.Global.item.justify = "right";
					win.obj.Global.Name = add( "edittext", [65,260,220,280], undefined, {name: 'Name', } );
					win.obj.Global.Points = add( "group", [10,92,175,162], undefined );
					with(win.obj.Global.Points){
						win.obj.Global.Points.item = add( "statictext", [0,16,19,66], 'w\r\rh', {multiline: 'true', } );
						win.obj.Global.Points.W = add( "edittext", [19,13,69,33], undefined, {name: 'W', } );
						win.obj.Global.Points.Wround = add( "button", [68,13,85,34], '0', {name: 'Wround', } );
						win.obj.Global.Points.H = add( "edittext", [19,39,69,59], undefined, {name: 'H', } );
						win.obj.Global.Points.Hround = add( "button", [68,39,85,60], '0', {name: 'Hround', } );
						win.obj.Global.Points.Wminus = add( "button", [89,23,114,48], '<', {name: 'Wminus', } );
						win.obj.Global.Points.Wminus.shortcutKey = "Left";
						win.obj.Global.Points.Wplus = add( "button", [139,23,164,48], '>', {name: 'Wplus', } );
						win.obj.Global.Points.Wplus.shortcutKey = "Right";
						win.obj.Global.Points.Hminus = add( "button", [114,0,139,25], '^', {name: 'Hminus', } );
						win.obj.Global.Points.Hminus.shortcutKey = "Up";
						win.obj.Global.Points.Hplus = add( "button", [114,46,139,71], 'V', {name: 'Hplus', } );
						win.obj.Global.Points.Hplus.shortcutKey = "Down";
						win.obj.Global.Points.accuracy = add( "checkbox", [120,27,140,47], '', {name: 'accuracy', } );
						}
					win.obj.Global.objSizes_Str = add( "statictext", [7,175,57,193], 'size, w/h', {name: 'objSizes_Str', } );
					win.obj.Global.Size = add( "group", [5,193,187,213], undefined );
					with(win.obj.Global.Size){
						win.obj.Global.Size.W = add( "edittext", [0,0,50,20], undefined, {name: 'W', } );
						win.obj.Global.Size.Wplus = add( "button", [49,0,72,11], undefined, {name: 'Wplus', } );
						win.obj.Global.Size.Wminus = add( "button", [49,10,72,21], undefined, {name: 'Wminus', } );
						win.obj.Global.Size.Wround = add( "button", [70,0,87,21], '0', {name: 'Wround', } );
						win.obj.Global.Size.H = add( "edittext", [95,0,145,20], undefined, {name: 'H', } );
						win.obj.Global.Size.Hplus = add( "button", [144,0,167,11], undefined, {name: 'Hplus', } );
						win.obj.Global.Size.Hminus = add( "button", [144,10,167,21], undefined, {name: 'Hminus', } );
						win.obj.Global.Size.Hround = add( "button", [165,0,182,21], '0', {name: 'Hround', } );
						}
					win.obj.Global.Text = add( "panel", [5,330,220,460], 'Text' );
					with(win.obj.Global.Text){
						win.obj.Global.Text.Text = add( "edittext", [5,35,180,115], undefined, {name: 'Text', multiline: 'true', } );
						win.obj.Global.Text.STRING = add( "radiobutton", [5,13,85,33], 'string', {name: 'String', } );
						win.obj.Global.Text.Var = add( "radiobutton", [90,13,155,33], 'var', {name: 'Var', } );
						// Text_init: add Justify
						}
					}
				win.obj.Local = add( "panel", [0,50,230,525], 'Local' );
				with(win.obj.Local){
					win.obj.Local.Font = add( "group", [5,15,215,68], undefined );
					with(win.obj.Local.Font){
						win.obj.Local.Font.item = add( "statictext", [0,3,35,23], 'font' );
						win.obj.Local.Font.Name = add( "dropdownlist", [40,0,210,22], undefined, {name: 'name', items: APP_SETTINGS.fonts, } );
						win.obj.Local.Font.item = add( "statictext", [0,33,40,53], 'style' );
						win.obj.Local.Font.Style = add( "dropdownlist", [40,30,135,52], undefined, {name: 'style', items: LISTS.fontStyles, } );
						win.obj.Local.Font.Size = add( "dropdownlist", [145,30,210,52], undefined, {name: 'size', items: LISTS.fontSizes, } );
						}
					win.obj.Local.Local2 = add( "group", [5,79,165,193], undefined );
					with(win.obj.Local.Local2){
						win.obj.Local.Local2.ReadOnly = add( "checkbox", [0,0,150,20], 'readonly', {name: 'readonly', } );
						win.obj.Local.Local2.MultiSelect = add( "checkbox", [0,20,150,40], 'multiselect', {name: 'multiselect', } );
						win.obj.Local.Local2.Scrolling = add( "checkbox", [0,40,150,60], 'scrolling', {name: 'scrolling', } );
						win.obj.Local.Local2.MultiLine = add( "checkbox", [0,60,150,80], 'multiline', {name: 'multiline', } );
						win.obj.Local.Local2.Toggle = add( "checkbox", [0,80,150,100], 'toggle', {name: 'toggle', } );
						win.obj.Local.Local2.Resizeable = add( "checkbox", [0,0,150,20], 'resizeable', {name: 'resizeable', } );
						win.obj.Local.Local2.Borderless = add( "checkbox", [0,20,150,40], 'borderless', {name: 'borderless', } );
						win.obj.Local.Local2.relativeLinks = add( "checkbox", [0,40,200,60], 'relative links', {name: 'relativeLinks', } );
						}
					win.obj.Local.Key = add( "group", [5,200,215,225], undefined );
					with(win.obj.Local.Key){
						win.obj.Local.Key.item = add( "statictext", [0,3,90,23], 'shortcutKey' );
						win.obj.Local.Key.Key = add( "edittext", [90,0,185,22], undefined, {name: 'Key', } );
						win.obj.Local.Key.Keys = add( "dropdownlist", [185,0,207,22], undefined, {name: 'Keys', items: LISTS.keys, } );
						}
					win.obj.Local.Border = add( "group", [5,230,215,255], undefined );
					with(win.obj.Local.Border){
						win.obj.Local.Border.item = add( "statictext", [0,2,90,22], 'borderStyle' );
						win.obj.Local.Border.Style = add( "dropdownlist", [90,0,210,22], undefined, {name: 'borderStyle', items: LISTS.borderStyles, } );
						}
					win.obj.Local.Style = add( "group", [5,230,215,255], undefined );
					with(win.obj.Local.Style){
						win.obj.Local.Style.item = add( "statictext", [0,2,90,22], 'style' );
						win.obj.Local.Style.Style = add( "dropdownlist", [90,0,210,22], undefined, {name: 'style', items: LISTS.styles, } );
						}
					win.obj.Local.Items = add( "panel", [5,263,220,353], 'Items' );
					with(win.obj.Local.Items){
						win.obj.Local.Items.Var = add( "radiobutton", [5,10,75,30], 'var' );
						win.obj.Local.Items.editVar = add( "edittext", [75,10,205,30], undefined, {name: 'Items', } );
						win.obj.Local.Items.Arr = add( "radiobutton", [5,32,75,52], 'array' );
						win.obj.Local.Items.editArr = add( "button", [75,32,145,54], 'edit' );
						win.obj.Local.Items.item = add( "statictext", [5,57,75,77], 'itemHeight' );
						win.obj.Local.Items.ItemsH = add( "edittext", [75,55,120,75], undefined, {name: 'ItemsH', } );
						}
					win.obj.Local.Image = add( "panel", [5,360,220,435], 'Images' );
					with(win.obj.Local.Image){
						win.obj.Local.Image.Image = add( "button", [5,10,75,32], 'image..' );
						win.obj.Local.Image.Del = add( "button", [150,10,175,35], '-' );
						win.obj.Local.Image.Add = add( "button", [180,10,205,35], '+' );
						win.obj.Local.Image.Link = add( "edittext", [5,36,205,58], undefined, {readonly: 'true', } );
						}
					}
				// addLayoutAndDynamicToWin - for Windows and Macintosh
				addLayoutAndDynamicToWin( win );
				
				win.obj.Controls = add( "group", [0,530,230,695], undefined );
				with(win.obj.Controls){
					win.obj.Controls.but_moveChildren = add( "button", [0,0,110,22], 'Move children' );
					win.obj.Controls.but_autoLayout = add( "button", [120,0,230,22], 'Auto Layout' );
					win.obj.Controls.moveChildren = add( "panel", [0,25,230,165], 'Move children' );
					with(win.obj.Controls.moveChildren){
						win.obj.Controls.moveChildren.item = add( "statictext", [35,36,54,86], 'w\r\rh', {multiline: 'true', } );
						win.obj.Controls.moveChildren.W = add( "edittext", [54,33,104,53], undefined, {name: 'W', } );
						win.obj.Controls.moveChildren.Wround = add( "button", [103,33,120,54], '0', {name: 'Wround', } );
						win.obj.Controls.moveChildren.H = add( "edittext", [54,59,104,79], undefined, {name: 'H', } );
						win.obj.Controls.moveChildren.Hround = add( "button", [103,59,120,80], '0', {name: 'Hround', } );
						win.obj.Controls.moveChildren.Wminus = add( "button", [124,43,149,68], '<', {name: 'Wminus', } );
						win.obj.Controls.moveChildren.Wplus = add( "button", [174,43,199,68], '>', {name: 'Wplus', } );
						win.obj.Controls.moveChildren.Hminus = add( "button", [149,20,174,45], '^', {name: 'Hminus', } );
						win.obj.Controls.moveChildren.Hplus = add( "button", [149,66,174,91], 'V', {name: 'Hplus', } );
						win.obj.Controls.moveChildren.accuracy = add( "checkbox", [155,47,175,67], undefined, {name: 'accuracy', } );
						win.obj.Controls.moveChildren.onlyVisible = add( "checkbox", [30,96,220,116], 'only visible', {name: 'onlyVisible', } );
						}
					win.obj.Controls.autoLayout = add( "panel", [0,25,230,165], 'Auto Layout' );
					with(win.obj.Controls.autoLayout){
						win.obj.Controls.autoLayout.autofitWindowProject = add( "checkbox", [5,15,205,35], 'autofit Window project', {name: 'autofitWindowProject', } );
						win.obj.Controls.autoLayout.autoFitToContent = add( "checkbox", [5,40,205,60], 'autofit to content', {name: 'autoFitToContent', } );
						win.obj.Controls.autoLayout.autoLocation = add( "checkbox", [5,65,210,85], 'auto layouting', {name: 'autoLocation', } );
						win.obj.Controls.autoLayout.autoLocationWithinIndent = add( "checkbox", [25,85,220,105], 'within limits of auto indent', {name: 'autoLocationWithinIndent', } );
						win.obj.Controls.autoLayout.autoLocation_restoreIndent = add( "checkbox", [45,105,220,125], 'restore auto indent', {name: 'autoLocation_restoreIndent', } );
						}
					}
				}
			}
		}
	else{ // MacOS
		win = new Window(scriptWinType, script.name, [0,0,983,705], {resizeable: true});
		with(win){
			win.builder = add( "group", [5,5,235,700], undefined );
			with(win.builder){
				// init: add menuItems
//				win.builder.menu = add( "dropdownlist", [0,0,230,22], undefined, {items: LISTS.menuItems, } );
				win.builder.projects = add( "listbox", [0,25,230,115], undefined );
				win.builder.listsbox = add( "group", [0,120,230,670], undefined );
				// init: add lists
				win.builder.del = add( "iconbutton", [0,673,22,695], undefined );
				win.builder.moveListItem = add( "group", [178,673,230,695], undefined );
				with(win.builder.moveListItem){
					win.builder.moveListItem.up = add( "iconbutton", [3,0,25,22], undefined, {name: -1, } );
					win.builder.moveListItem.down = add( "iconbutton", [30,0,52,22], undefined, {name: 1, } );
					}
				}
			win.separator = add( "panel", [238,5,241,700], undefined );
			win.lightbox = add( "group", [243,5,743,700], undefined );
			// init: add projects
			win.obj = add( "group", [748,5,978,700], undefined );
			with(win.obj){
				win.obj.addObject = add( "dropdownlist", [0,0,230,22], undefined, {items: LISTS.addObjectItems, } );
				win.obj.but_Global = add( "button", [0,25,55,47], 'Global', {name: '_Global', } );
				win.obj.but_Global.graphics.font = ScriptUI.newFont(win.obj.but_Global.graphics.font.name, win.obj.but_Global.graphics.font.style, 9);
				win.obj.but_Local = add( "button", [55,25,110,47], 'Local', {name: '_Local', } );
				win.obj.but_Local.graphics.font = ScriptUI.newFont(win.obj.but_Local.graphics.font.name, win.obj.but_Local.graphics.font.style, 9);
				win.obj.but_Layout = add( "button", [110,25,170,47], 'Layout', {name: '_Layout', } );
				win.obj.but_Layout.graphics.font = ScriptUI.newFont(win.obj.but_Layout.graphics.font.name, win.obj.but_Layout.graphics.font.style, 9);
				win.obj.but_Dynamic = add( "button", [170,25,230,47], 'Dynamic', {name: '_Dynamic', } );
				win.obj.but_Dynamic.graphics.font = ScriptUI.newFont(win.obj.but_Dynamic.graphics.font.name, win.obj.but_Dynamic.graphics.font.style, 9);
				win.obj.Global = add( "panel", [0,50,230,525], 'Global' );
				with(win.obj.Global){
					win.obj.Global.item = add( "statictext", [5,17,55,37], 'type' );
					win.obj.Global.item.justify = "right";
					win.obj.Global.Type = add( "dropdownlist", [60,15,220,37], undefined, {name: 'Type', items: LISTS.types, } );
					win.obj.Global.item = add( "statictext", [5,47,55,67], 'var' );
					win.obj.Global.item.justify = "right";
					win.obj.Global.Var = add( "edittext", [60,46,220,66], undefined, {name: 'Var', } );
					win.obj.Global.Visible = add( "checkbox", [10,295,80,315], 'visible', {name: 'Visible', } );
					win.obj.Global.item = add( "statictext", [5,230,60,250], 'helpTip' );
					win.obj.Global.item.justify = "right";
					win.obj.Global.HelpTip = add( "edittext", [65,228,220,248], undefined, {name: 'HelpTip', } );
					win.obj.Global.item = add( "statictext", [6,261,61,281], 'name' );
					win.obj.Global.item.justify = "right";
					win.obj.Global.Name = add( "edittext", [65,260,220,280], undefined, {name: 'Name', } );
					win.obj.Global.Points = add( "group", [10,92,177,165], undefined );
					with(win.obj.Global.Points){
						win.obj.Global.Points.item = add( "statictext", [0,16,19,66], 'w\r\rh', {multiline: 'true', } );
						win.obj.Global.Points.W = add( "edittext", [19,13,69,33], undefined, {name: 'W', } );
						win.obj.Global.Points.Wround = add( "iconbutton", [68,13,83,33], undefined, {name: 'Wround', } );
						win.obj.Global.Points.H = add( "edittext", [19,39,69,59], undefined, {name: 'H', } );
						win.obj.Global.Points.Hround = add( "iconbutton", [68,39,83,59], undefined, {name: 'Hround', } );
						win.obj.Global.Points.Wminus = add( "iconbutton", [90,24,115,49], undefined, {name: 'Wminus', } );
						win.obj.Global.Points.Wminus.shortcutKey = "Left";
						win.obj.Global.Points.Wplus = add( "iconbutton", [140,24,165,49], undefined, {name: 'Wplus', } );
						win.obj.Global.Points.Wplus.shortcutKey = "Right";
						win.obj.Global.Points.Hminus = add( "iconbutton", [115,0,140,25], undefined, {name: 'Hminus', } );
						win.obj.Global.Points.Hminus.shortcutKey = "Up";
						win.obj.Global.Points.Hplus = add( "iconbutton", [115,48,140,73], undefined, {name: 'Hplus', } );
						win.obj.Global.Points.Hplus.shortcutKey = "Down";
						win.obj.Global.Points.accuracy = add( "checkbox", [120,27,140,47], undefined, {name: 'accuracy', } );
						}
					win.obj.Global.objSizes_Str = add( "statictext", [7,180,97,198], 'size, w/h', {name: 'objSizes_Str', } );
					win.obj.Global.Size = add( "group", [5,198,185,218], undefined );
					with(win.obj.Global.Size){
						win.obj.Global.Size.W = add( "edittext", [0,0,50,20], undefined, {name: 'W', } );
						win.obj.Global.Size.Wplus = add( "iconbutton", [49,0,74,10], undefined, {name: 'Wplus', } );
						win.obj.Global.Size.Wminus = add( "iconbutton", [49,10,74,20], undefined, {name: 'Wminus', } );
						win.obj.Global.Size.Wround = add( "iconbutton", [70,0,85,20], undefined, {name: 'Wround', } );
						win.obj.Global.Size.H = add( "edittext", [95,0,145,20], undefined, {name: 'H', } );
						win.obj.Global.Size.Hplus = add( "iconbutton", [144,0,169,10], undefined, {name: 'Hplus', } );
						win.obj.Global.Size.Hminus = add( "iconbutton", [144,10,169,20], undefined, {name: 'Hminus', } );
						win.obj.Global.Size.Hround = add( "iconbutton", [165,0,180,20], undefined, {name: 'Hround', } );
						}
					win.obj.Global.Text = add( "panel", [5,330,223,460], 'Text' );
					with(win.obj.Global.Text){
						win.obj.Global.Text.Text = add( "edittext", [5,35,175,115], undefined, {name: 'Text', multiline: 'true', } );
						win.obj.Global.Text.STRING = add( "radiobutton", [5,10,85,30], 'string', {name: 'String', } );
						win.obj.Global.Text.Var = add( "radiobutton", [90,10,155,30], 'var', {name: 'Var', } );
						// Text_init: add Justify
						}
					}
				win.obj.Local = add( "panel", [0,50,230,525], 'Local' );
				with(win.obj.Local){
					win.obj.Local.Font = add( "group", [5,15,220,68], undefined );
					with(win.obj.Local.Font){
						win.obj.Local.Font.item = add( "statictext", [0,3,35,23], 'font' );
						win.obj.Local.Font.Name = add( "dropdownlist", [40,0,215,22], undefined, {name: 'name', items: APP_SETTINGS.fonts, } );
						win.obj.Local.Font.item = add( "statictext", [0,33,40,53], 'style' );
						win.obj.Local.Font.Style = add( "dropdownlist", [40,30,140,52], undefined, {name: 'style', items: LISTS.fontStyles, } );
						win.obj.Local.Font.Size = add( "dropdownlist", [150,30,215,52], undefined, {name: 'size', items: LISTS.fontSizes, } );
						}
					win.obj.Local.Local2 = add( "group", [5,79,165,193], undefined );
					with(win.obj.Local.Local2){
						win.obj.Local.Local2.ReadOnly = add( "checkbox", [0,0,150,20], 'readonly', {name: 'readonly', } );
						win.obj.Local.Local2.MultiSelect = add( "checkbox", [0,20,150,40], 'multiselect', {name: 'multiselect', } );
						win.obj.Local.Local2.Scrolling = add( "checkbox", [0,40,150,60], 'scrolling', {name: 'scrolling', } );
						win.obj.Local.Local2.MultiLine = add( "checkbox", [0,60,150,80], 'multiline', {name: 'multiline', } );
						win.obj.Local.Local2.Toggle = add( "checkbox", [0,80,150,100], 'toggle', {name: 'toggle', } );
						win.obj.Local.Local2.Resizeable = add( "checkbox", [0,0,150,20], 'resizeable', {name: 'resizeable', } );
						win.obj.Local.Local2.Borderless = add( "checkbox", [0,20,150,40], 'borderless', {name: 'borderless', } );
						win.obj.Local.Local2.relativeLinks = add( "checkbox", [0,40,200,60], 'relative links', {name: 'relativeLinks', } );
						}
					win.obj.Local.Key = add( "group", [5,200,220,223], undefined );
					with(win.obj.Local.Key){
						win.obj.Local.Key.item = add( "statictext", [0,3,90,23], 'shortcutKey' );
						win.obj.Local.Key.Key = add( "edittext", [90,0,194,22], undefined, {name: 'Key', } );
						win.obj.Local.Key.Keys = add( "dropdownlist", [193,1,215,23], undefined, {name: 'Keys', items: LISTS.keys, } );
						}
					win.obj.Local.Border = add( "group", [5,230,215,255], undefined );
					with(win.obj.Local.Border){
						win.obj.Local.Border.item = add( "statictext", [0,2,90,22], 'borderStyle' );
						win.obj.Local.Border.Style = add( "dropdownlist", [90,0,210,22], undefined, {name: 'borderStyle', items: LISTS.borderStyles, } );
						}
					win.obj.Local.Style = add( "group", [5,230,220,255], undefined );
					with(win.obj.Local.Style){
						win.obj.Local.Style.item = add( "statictext", [0,2,90,22], 'style' );
						win.obj.Local.Style.Style = add( "dropdownlist", [90,0,215,22], undefined, {name: 'style', items: LISTS.styles, } );
						}
					win.obj.Local.Items = add( "panel", [5,265,220,370], 'Items' );
					with(win.obj.Local.Items){
						win.obj.Local.Items.Var = add( "radiobutton", [5,10,75,30], 'var' );
						win.obj.Local.Items.editVar = add( "edittext", [75,10,205,30], undefined, {name: 'Items', } );
						win.obj.Local.Items.Arr = add( "radiobutton", [5,32,75,52], 'array' );
						win.obj.Local.Items.editArr = add( "button", [75,32,145,54], 'edit' );
						win.obj.Local.Items.item = add( "statictext", [5,67,75,87], 'itemHeight' );
						win.obj.Local.Items.ItemsH = add( "edittext", [85,65,130,85], undefined, {name: 'ItemsH', } );
						}
					win.obj.Local.Image = add( "panel", [5,380,220,455], 'Images' );
					with(win.obj.Local.Image){
						win.obj.Local.Image.Image = add( "button", [5,10,75,32], 'image..' );
						win.obj.Local.Image.Del = add( "iconbutton", [153,10,175,32], undefined );
						win.obj.Local.Image.Add = add( "iconbutton", [183,10,205,32], undefined );
						win.obj.Local.Image.Link = add( "edittext", [5,36,205,58], undefined, {readonly: 'true', } );
						}
					}
				
				// addLayoutAndDynamicToWin - for Windows and Macintosh
				addLayoutAndDynamicToWin( win );
				
				win.obj.Controls = add( "group", [0,530,230,695], undefined );
				with(win.obj.Controls){
					win.obj.Controls.but_moveChildren = add( "button", [0,0,110,22], 'Move children' );
					win.obj.Controls.but_autoLayout = add( "button", [120,0,230,22], 'Auto Layout' );
					win.obj.Controls.moveChildren = add( "panel", [0,25,230,165], 'Move children' );
					with(win.obj.Controls.moveChildren){
						win.obj.Controls.moveChildren.item = add( "statictext", [35,41,54,91], 'w\r\rh', {multiline: 'true', } );
						win.obj.Controls.moveChildren.W = add( "edittext", [54,38,104,58], undefined, {name: 'W', } );
						win.obj.Controls.moveChildren.Wround = add( "iconbutton", [103,38,118,58], undefined, {name: 'Wround', } );
						win.obj.Controls.moveChildren.H = add( "edittext", [54,64,104,84], undefined, {name: 'H', } );
						win.obj.Controls.moveChildren.Hround = add( "iconbutton", [103,64,118,84], undefined, {name: 'Hround', } );
						win.obj.Controls.moveChildren.Wminus = add( "iconbutton", [125,48,150,73], undefined, {name: 'Wminus', } );
						win.obj.Controls.moveChildren.Wplus = add( "iconbutton", [175,48,200,73], undefined, {name: 'Wplus', } );
						win.obj.Controls.moveChildren.Hplus = add( "iconbutton", [150,71,175,96], undefined, {name: 'Hplus', } );
						win.obj.Controls.moveChildren.accuracy = add( "checkbox", [155,52,175,72], undefined, {name: 'accuracy', } );
						win.obj.Controls.moveChildren.onlyVisible = add( "checkbox", [30,101,220,121], 'only visible', {name: 'onlyVisible', } );
						win.obj.Controls.moveChildren.Hminus = add( "iconbutton", [150,25,175,50], undefined, {name: 'Hminus', } );
						}
					win.obj.Controls.autoLayout = add( "panel", [0,25,230,165], 'Auto Layout' );
					with(win.obj.Controls.autoLayout){
						win.obj.Controls.autoLayout.autofitWindowProject = add( "checkbox", [5,15,205,35], 'autofit Window project', {name: 'autofitWindowProject', } );
						win.obj.Controls.autoLayout.autoFitToContent = add( "checkbox", [5,40,205,60], 'autofit to content', {name: 'autoFitToContent', } );
						win.obj.Controls.autoLayout.autoLocation = add( "checkbox", [5,65,210,85], 'auto layouting', {name: 'autoLocation', } );
						win.obj.Controls.autoLayout.autoLocationWithinIndent = add( "checkbox", [25,85,220,105], 'within limits of auto indent', {name: 'autoLocationWithinIndent', } );
						win.obj.Controls.autoLayout.autoLocation_restoreIndent = add( "checkbox", [45,105,220,125], 'restore auto indent', {name: 'autoLocation_restoreIndent', } );
						}
					}
				}
			}
		// подписи к кнопкам
		script.getCustomDraw( win.obj.Global.Points.Wminus, {text:'<'} );
		script.getCustomDraw( win.obj.Global.Points.Wplus, {text:'>'} );
		script.getCustomDraw( win.obj.Global.Points.Hminus, {text:'^'} );
		script.getCustomDraw( win.obj.Global.Points.Hplus, {text:'V'} );
		
		script.getCustomDraw( win.obj.Local.Image.Del, {text:'-'} );
		script.getCustomDraw( win.obj.Local.Image.Add, {text:'+'} );
		
		script.getCustomDraw( win.obj.Controls.moveChildren.Wminus, {text:'<'} );
		script.getCustomDraw( win.obj.Controls.moveChildren.Wplus, {text:'>'} );
		script.getCustomDraw( win.obj.Controls.moveChildren.Hminus, {text:'^'} );
		script.getCustomDraw( win.obj.Controls.moveChildren.Hplus, {text:'V'} );
		}
	// Layout
//	script.addColor( win.obj.Layout, 0, [200,200,200] );
	// Dynamic
	script.addColor( win.obj.Dynamic.note_obj, 1, [125,125,125] );
	script.addColor( win.obj.Dynamic.note_window, 1, [125,125,125] );
	//resizeable
	script.addDynamicObject( { obj: win.builder, moveCoefs: false, resizeCoefs: [0,1], isSeparator: false, windowMinSize: [500,true], windowResizeDirections: [1,1], windowKeyRestore: 'win' } );
	script.addDynamicObject( { obj: win.builder.projects, moveCoefs: false, resizeCoefs: [1,0], isSeparator: false } );
	script.addDynamicObject( { obj: win.builder.listsbox, moveCoefs: false, resizeCoefs: [1,1], isSeparator: false } )
	
	script.addDynamicObject( {  obj: win.builder.del, moveCoefs: [0,1], resizeCoefs: false, isSeparator: false } );
	var buttonDelete = script.getInDesignIcon( 'Text/(Find and Change Panel Resources)/idrc_PNGA/113.idrc' );
	if( buttonDelete )
		win.builder.del.image = buttonDelete;
	else{
		script.getCustomDraw(win.builder.del, {text:'X'});
		win.builder.del.helpTip = 'delete selected object';
		}
	script.addDynamicObject( { obj: win.builder.moveListItem, moveCoefs: [1,1], resizeCoefs: false, isSeparator: false } );
	var arrowUpp = script.getInDesignIcon( 'Text/(RunIn Styles Panel Resources)/idrc_PNGA/100.idrc' );
	var arrowDown = script.getInDesignIcon( 'Text/(RunIn Styles Panel Resources)/idrc_PNGA/200.idrc' );
	if( arrowUpp && arrowDown ){
		win.builder.moveListItem.up.image = arrowUpp;
		win.builder.moveListItem.up.helpTip = 'move list up';
		win.builder.moveListItem.down.image = arrowDown;
		win.builder.moveListItem.down.helpTip = 'move list down';
		}
	else{
		script.getCustomDraw(win.builder.moveListItem.up, {text:'^'});
		script.getCustomDraw(win.builder.moveListItem.down, {text:'V'});
		}
	script.addDynamicObject( { obj: win.separator, moveCoefs: false, resizeCoefs: [0,1], isSeparator: 0, keyRestore: 'winSeparator' } );
	script.addDynamicObject( { obj: win.lightbox, moveCoefs: false, resizeCoefs: [1,1], isSeparator: false } );

	script.addDynamicObject( { obj: win.obj, moveCoefs: [1,0], resizeCoefs: false, isSeparator: false } );
	//===================================================================================================
	//===================================================================================================
	uiBuilderLibrary.init();
	
	return win;
	}catch(err){script.alertError(err);}
	}
function addLayoutAndDynamicToWin( win ){
	var TEXT_SIZE = File.fs == 'Windows' ? 11: 10;
	
	win.obj.Layout = win.obj.add( "panel", [0,50,230,695], 'Automatic layout' );
	with(win.obj.Layout){
		win.obj.Layout.item = add( "statictext", [10,20,110,35], 'preferredSize, w/h:' );
		win.obj.Layout.item.graphics.font = ScriptUI.newFont(win.obj.Layout.item.graphics.font.name, win.obj.Layout.item.graphics.font.style, TEXT_SIZE);
		win.obj.Layout.sizeW = add( "edittext", [110,20,160,40], undefined, {name: 'W', } );
		win.obj.Layout.sizeH = add( "edittext", [170,20,220,40], undefined, {name: 'H', } );
		win.obj.Layout.Alignment = add( "group", [5,50,220,87], undefined );
		with(win.obj.Layout.Alignment){
			win.obj.Layout.Alignment.item = add( "statictext", [5,0,115,15], 'alignment, w/h:' );
			win.obj.Layout.Alignment.item.graphics.font = ScriptUI.newFont(win.obj.Layout.Alignment.item.graphics.font.name, win.obj.Layout.Alignment.item.graphics.font.style, TEXT_SIZE);
			win.obj.Layout.Alignment.W = add( "dropdownlist", [45,15,125,37], undefined, {name: 'W', items: ['[none]','left','center','right','fill'], } );
			win.obj.Layout.Alignment.H = add( "dropdownlist", [135,15,215,37], undefined, {name: 'H', items: ['[none]','top','center','bottom','fill'], } );
			}
		win.obj.Layout.tabbedPanel = add( "checkbox", [5,100,150,120], 'TabbedPanel' );
		win.obj.Layout.tabbedPanel.graphics.font = ScriptUI.newFont(win.obj.Layout.tabbedPanel.graphics.font.name, win.obj.Layout.tabbedPanel.graphics.font.style, TEXT_SIZE);
		win.obj.Layout.Container = add( "panel", [5,125,220,310], 'Container' );
		with(win.obj.Layout.Container){
			win.obj.Layout.Container.item = add( "statictext", [5,15,75,35], 'orientation:' );
			win.obj.Layout.Container.item.graphics.font = ScriptUI.newFont(win.obj.Layout.Container.item.graphics.font.name, win.obj.Layout.Container.item.graphics.font.style, TEXT_SIZE);
			win.obj.Layout.Container.Orientation = add( "group", [80,13,190,50], undefined );
			with(win.obj.Layout.Container.Orientation){
				win.obj.Layout.Container.Orientation.Row = add( "radiobutton", [0,0,45,20], 'row', {name: 'row', } );
				win.obj.Layout.Container.Orientation.Row.graphics.font = ScriptUI.newFont(win.obj.Layout.Container.Orientation.Row.graphics.font.name, win.obj.Layout.Container.Orientation.Row.graphics.font.style, TEXT_SIZE);
				win.obj.Layout.Container.Orientation.Stack = add( "radiobutton", [45,0,105,20], 'stack', {name: 'stack', } );
				win.obj.Layout.Container.Orientation.Stack.graphics.font = ScriptUI.newFont(win.obj.Layout.Container.Orientation.Stack.graphics.font.name, win.obj.Layout.Container.Orientation.Stack.graphics.font.style, TEXT_SIZE);
				win.obj.Layout.Container.Orientation.Column = add( "radiobutton", [45,17,110,37], 'column', {name: 'column', } );
				win.obj.Layout.Container.Orientation.Column.graphics.font = ScriptUI.newFont(win.obj.Layout.Container.Orientation.Column.graphics.font.name, win.obj.Layout.Container.Orientation.Column.graphics.font.style, TEXT_SIZE);
				}
			win.obj.Layout.Container.item = add( "statictext", [5,50,115,65], 'alignChildren, w/h:' );
			win.obj.Layout.Container.item.graphics.font = ScriptUI.newFont(win.obj.Layout.Container.item.graphics.font.name, win.obj.Layout.Container.item.graphics.font.style, TEXT_SIZE);
			win.obj.Layout.Container.alignChildrenW = add( "dropdownlist", [35,65,115,87], undefined, {name: 'W', items: ['[none]','left','center','right','fill'], } );
			win.obj.Layout.Container.alignChildrenH = add( "dropdownlist", [125,65,205,87], undefined, {name: 'H', items: ['[none]','top','center','bottom','fill'], } );
			win.obj.Layout.Container.item = add( "statictext", [5,110,50,130], 'margins:' );
			win.obj.Layout.Container.item.graphics.font = ScriptUI.newFont(win.obj.Layout.Container.item.graphics.font.name, win.obj.Layout.Container.item.graphics.font.style, TEXT_SIZE);
			win.obj.Layout.Container.Margins = add( "group", [55,95,205,140], undefined );
			with(win.obj.Layout.Container.Margins){
				win.obj.Layout.Container.Margins.Left = add( "edittext", [0,15,45,35], undefined, {name: 'Left', } );
				win.obj.Layout.Container.Margins.Top = add( "edittext", [50,0,95,20], undefined, {name: 'Top', } );
				win.obj.Layout.Container.Margins.Right = add( "edittext", [100,15,145,35], undefined, {name: 'Right', } );
				win.obj.Layout.Container.Margins.Bottom = add( "edittext", [50,25,95,45], undefined, {name: 'Bottom', } );
				}
			win.obj.Layout.Container.item = add( "statictext", [5,150,50,170], 'spacing:' );
			win.obj.Layout.Container.item.graphics.font = ScriptUI.newFont(win.obj.Layout.Container.item.graphics.font.name, win.obj.Layout.Container.item.graphics.font.style, TEXT_SIZE);
			win.obj.Layout.Container.Spacing = add( "edittext", [55,150,100,170], undefined );
			}
		win.obj.Layout.Indent = add( "group", [10,320,105,340], undefined );
		with(win.obj.Layout.Indent){
			win.obj.Layout.Indent.item = add( "statictext", [0,0,45,20], 'indent:' );
			win.obj.Layout.Indent.item.graphics.font = ScriptUI.newFont(win.obj.Layout.Indent.item.graphics.font.name, win.obj.Layout.Indent.item.graphics.font.style, TEXT_SIZE);
			win.obj.Layout.Indent.Text = add( "edittext", [45,0,95,20], undefined );
			}
		win.obj.Layout.Characters = add( "group", [125,320,220,340], undefined );
		with(win.obj.Layout.Characters){
			win.obj.Layout.Characters.item = add( "statictext", [0,0,45,20], 'chars:' );
			win.obj.Layout.Characters.item.graphics.font = ScriptUI.newFont(win.obj.Layout.Characters.item.graphics.font.name, win.obj.Layout.Characters.item.graphics.font.style, TEXT_SIZE);
			win.obj.Layout.Characters.Text = add( "edittext", [45,0,95,20], undefined );
			}
		win.obj.Layout.item = add( "statictext", [10,345,110,365], 'maximumSize, w/h:' );
		win.obj.Layout.item.graphics.font = ScriptUI.newFont(win.obj.Layout.item.graphics.font.name, win.obj.Layout.item.graphics.font.style, TEXT_SIZE);
		win.obj.Layout.maxSizeW = add( "edittext", [110,345,160,365], undefined, {name: 'W', } );
		win.obj.Layout.maxSizeH = add( "edittext", [170,345,220,365], undefined, {name: 'H', } );
		win.obj.Layout.item = add( "statictext", [10,370,105,390], 'minimumSize, w/h:' );
		win.obj.Layout.item.graphics.font = ScriptUI.newFont(win.obj.Layout.item.graphics.font.name, win.obj.Layout.item.graphics.font.style, TEXT_SIZE);
		win.obj.Layout.minSizeW = add( "edittext", [110,370,160,390], undefined, {name: 'W', } );
		win.obj.Layout.minSizeH = add( "edittext", [170,370,220,390], undefined, {name: 'H', } );
		win.obj.Layout.Title = add( "panel", [5,395,220,605], 'title' );
		with(win.obj.Layout.Title){
			win.obj.Layout.Title.STRING = add( "radiobutton", [5,10,65,30], 'string', {name: 'String', } );
			win.obj.Layout.Title.STRING.graphics.font = ScriptUI.newFont(win.obj.Layout.Title.STRING.graphics.font.name, win.obj.Layout.Title.STRING.graphics.font.style, 11);
			win.obj.Layout.Title.Var = add( "radiobutton", [70,10,135,30], 'var', {name: 'Var', } );
			win.obj.Layout.Title.Var.graphics.font = ScriptUI.newFont(win.obj.Layout.Title.Var.graphics.font.name, win.obj.Layout.Title.Var.graphics.font.style, 11);
			win.obj.Layout.Title.Text = add( "edittext", [5,30,175,50], undefined );
			win.obj.Layout.Title.Justify = add( "group", [180,20,208,92], undefined );
			// Layout_init: add Justify
			win.obj.Layout.Title.Alignment = add( "group", [5,55,175,92], undefined );
			with(win.obj.Layout.Title.Alignment){
				win.obj.Layout.Title.Alignment.item = add( "statictext", [0,0,110,15], 'alignment, w/h:' );
				win.obj.Layout.Title.Alignment.item.graphics.font = ScriptUI.newFont(win.obj.Layout.Title.Alignment.item.graphics.font.name, win.obj.Layout.Title.Alignment.item.graphics.font.style, 11);
				win.obj.Layout.Title.Alignment.W = add( "dropdownlist", [0,15,80,37], undefined, {name: 'W', items: ['[none]','left','center','right'], } );
				win.obj.Layout.Title.Alignment.H = add( "dropdownlist", [90,15,170,37], undefined, {name: 'H', items: ['[none]','top','center','bottom'], } );
				}
			win.obj.Layout.Title.item = add( "statictext", [5,115,55,135], 'margins:' );
			win.obj.Layout.Title.item.graphics.font = ScriptUI.newFont(win.obj.Layout.Title.item.graphics.font.name, win.obj.Layout.Title.item.graphics.font.style, 11);
			win.obj.Layout.Title.Margins = add( "group", [60,100,210,145], undefined );
			with(win.obj.Layout.Title.Margins){
				win.obj.Layout.Title.Margins.Left = add( "edittext", [0,15,45,35], undefined, {name: 'Left', } );
				win.obj.Layout.Title.Margins.Top = add( "edittext", [50,0,95,20], undefined, {name: 'Top', } );
				win.obj.Layout.Title.Margins.Right = add( "edittext", [100,15,145,35], undefined, {name: 'Right', } );
				win.obj.Layout.Title.Margins.Bottom = add( "edittext", [50,25,95,45], undefined, {name: 'Bottom', } );
				}
			win.obj.Layout.Title.item = add( "statictext", [5,150,50,170], 'spacing:' );
			win.obj.Layout.Title.item.graphics.font = ScriptUI.newFont(win.obj.Layout.Title.item.graphics.font.name, win.obj.Layout.Title.item.graphics.font.style, 11);
			win.obj.Layout.Title.Spacing = add( "edittext", [60,150,105,170], undefined );
			win.obj.Layout.Title.item = add( "statictext", [5,175,60,195], 'characters:' );
			win.obj.Layout.Title.item.graphics.font = ScriptUI.newFont(win.obj.Layout.Title.item.graphics.font.name, win.obj.Layout.Title.item.graphics.font.style, 10);
			win.obj.Layout.Title.Characters = add( "edittext", [60,175,105,195], undefined );
			win.obj.Layout.Title.item = add( "statictext", [115,175,160,195], 'truncate:' );
			win.obj.Layout.Title.item.graphics.font = ScriptUI.newFont(win.obj.Layout.Title.item.graphics.font.name, win.obj.Layout.Title.item.graphics.font.style, 10);
			win.obj.Layout.Title.Truncate = add( "dropdownlist", [160,175,205,197], undefined, {items: ['[none]','middle','end','none'], } );
			}
		win.obj.Layout.Code = add( "button", [5,610,70,632], 'Code' );
		win.obj.Layout.CodePlus = add( "button", [75,610,140,632], 'Code+' );
		win.obj.Layout.Test = add( "button", [155,610,220,632], 'Test' );
		}
	win.obj.Dynamic = win.obj.add( "panel", [0,50,230,525], 'Dynamic' );
	with(win.obj.Dynamic){
		win.obj.Dynamic.Enabled = add( "checkbox", [10,20,100,40], 'enabled' );
		win.obj.Dynamic.obj = add( "group", [0,45,225,145], undefined );
		with(win.obj.Dynamic.obj){
			win.obj.Dynamic.obj.item = add( "statictext", [70,0,140,20], 'on width' );
			win.obj.Dynamic.obj.item.justify = "center";
			win.obj.Dynamic.obj.item = add( "statictext", [150,0,225,20], 'on height' );
			win.obj.Dynamic.obj.item.justify = "center";
			win.obj.Dynamic.obj.item = add( "statictext", [5,25,65,45], 'move:' );
			win.obj.Dynamic.obj.item.justify = "right";
			win.obj.Dynamic.obj.item = add( "statictext", [5,50,65,70], 'resize:' );
			win.obj.Dynamic.obj.item.justify = "right";
			win.obj.Dynamic.obj.move_width = add( "dropdownlist", [70,20,140,42], undefined, {name: 'move_width', items: LISTS.dynamic_coefs, } );
			win.obj.Dynamic.obj.move_height = add( "dropdownlist", [150,20,220,42], undefined, {name: 'move_height', items: LISTS.dynamic_coefs, } );
			win.obj.Dynamic.obj.resize_width = add( "dropdownlist", [70,47,140,69], undefined, {name: 'resize_width', items: LISTS.dynamic_coefs, } );
			win.obj.Dynamic.obj.resize_height = add( "dropdownlist", [150,47,220,69], undefined, {name: 'resize_height', items: LISTS.dynamic_coefs, } );
			win.obj.Dynamic.obj.separator = add( "group", [0,77,220,99], undefined );
			with(win.obj.Dynamic.obj.separator){
				win.obj.Dynamic.obj.separator.Enabled = add( "checkbox", [10,0,100,20], 'separator:' );
				win.obj.Dynamic.obj.separator.onWidth = add( "radiobutton", [100,0,125,22], undefined, {name: 'onWidth', } );
				win.obj.Dynamic.obj.separator.onHeight = add( "radiobutton", [180,0,205,22], undefined, {name: 'onHeight', } );
				}
			}
		win.obj.Dynamic.Window = add( "group", [0,45,225,115], undefined );
		with(win.obj.Dynamic.Window){
			win.obj.Dynamic.Window.item = add( "statictext", [70,0,140,20], 'on width' );
			win.obj.Dynamic.Window.item.justify = "center";
			win.obj.Dynamic.Window.item = add( "statictext", [150,0,225,20], 'on height' );
			win.obj.Dynamic.Window.item.justify = "center";
			win.obj.Dynamic.Window.item = add( "statictext", [5,25,65,45], 'minSize:' );
			win.obj.Dynamic.Window.item.justify = "right";
			win.obj.Dynamic.Window.item = add( "statictext", [5,50,65,70], 'resize:' );
			win.obj.Dynamic.Window.item.justify = "right";
			win.obj.Dynamic.Window.minSize_width = add( "checkbox", [100,22,125,44], undefined, {name: 'minSize_width', } );
			win.obj.Dynamic.Window.minSize_height = add( "checkbox", [180,22,205,44], undefined, {name: 'minSize_height', } );
			win.obj.Dynamic.Window.resize_width = add( "checkbox", [100,48,125,70], undefined, {name: 'resize_width', } );
			win.obj.Dynamic.Window.resize_height = add( "checkbox", [180,48,205,70], undefined, {name: 'resize_height', } );
			}
		win.obj.Dynamic.Clear = add( "button", [150,438,220,460], 'Clear' );
		win.obj.Dynamic.ClearAllChildren = add( "button", [5,438,145,460], 'Clear all children' );
		win.obj.Dynamic.note_obj = add( "statictext", [5,170,225,285], 'Note!\rVariable names of dynamic objects should not match', {multiline: 'true', } );
		win.obj.Dynamic.note_window = add( "statictext", [5,170,225,285], 'Note!\rNeed  activate \'resizerable\' for access options', {multiline: 'true', } );
		}
	}
//=================================================================
function getBuilderLibrary(){
	var uiBuilderLibrary = {
		currentProject: false,// объект текущего проекта
		buffer: false,// буфер обмена
		imageBuffer: false,// буфер обмена
		VarsBasa: {},
		getChildrenArray: function( obj ){// Возвращает массив ui-объектов согласно их положению в списке
			if( !SUPPORT[obj.type]['children'] )
				return;
			var res = [];
			if( obj.project.activeObjList.type == 'treeview' ){
				for( var i = 0; i < obj.listItem.items.length; i++ )
					res.push( obj.listItem.items[i].object );
				}
			else{
				var items = obj.project.activeObjList.items;
				for( var i = 0; i < items.length; i++ )
					if( items[i].object.parent == obj )
						res.push( items[i].object );
				}
			return res;
			},
		getAllChildrenArray: function( obj /*, array */ ){// Возвращает массив ui-объектов
			//script.consol( 'getAllChildrenArray(): ', obj );
			var array = arguments[1] && arguments[1].constructor == Array ? arguments[1] : [];
			if( (!obj || !this.isContainer(obj)) || !obj.children.length )
				return array;
			for( var i = 0; i < obj.children.length; i++ ){
				array.push( obj.children[i] );
				if(this.isContainer( obj.children[i]) )
					uiBuilderLibrary.getAllChildrenArray( obj.children[i], array );
	//				arguments.callee( obj.children[i], array );
				}
			if( arguments.length == 1 )
				return array;
			},
		// Возвращает слепок текущего объекта, пригодный для создания нового объекта, а также для сохранения в String. 
		// withChildren - Boolean (Optional), копировать с детьми
		// newArgs - Object (Optional), объект параметров, которые нужно изменить
		getClearArgs: function( props ){ // { obj: Object, withChildren: Bool, newArgs: Object, forSave: Bool, forOut: Bool }
			//script.consol( 'getClearArgs(): ', obj );
			try{
			if( !props )
				return false;
			var obj = props.obj;
			var withChildren = props.withChildren;
			var newArgs = props.newArgs;
			var forSave = props.forSave;
			var forOut = props.forOut;
			if( !obj )
				return false;
			var args = {
				type: obj.type,
				Var: obj.Var || 'item',
				location: [obj.location[0], obj.location[1]],
				size: [obj.size[0], obj.size[1]],
				};
			//===========================================
			// единственные параметры, ссылающиеся на объект
	//		args.project = obj.project;
			if( !this.isWindow(obj) ){
	//			args.parent = obj.parent;
				}
			else{
				// параметры окна и проекта
				args.scriptVersion = script.version;
				if( obj.Resizeable )
					args.Resizeable = obj.Resizeable;
				if( obj.Borderless )
					args.Borderless = obj.Borderless;
				if( obj.windowType )
					args.windowType = obj.windowType;
				if( obj.relativeLinks )
					args.relativeLinks = obj.relativeLinks;
				}
			//===========================================
			if( !forSave && !obj.visible /*&& obj.visible != obj.parent.visible*/ ) // visible не сохраняется в файл проекта
				args.visible = false;
			if( obj.helpTip )
				args.helpTip = obj.helpTip;
			if( obj.Name )
				args.Name = obj.Name;
			
			// ЛОКАЛЬНЫЕ
			var type = obj.type;
			if( SUPPORT[type]['text'] || this.isWindow(obj) ){
				if( obj.text )
					args.text = obj.text;
				if( obj.textVar )
					args.textVar = obj.textVar;
				}
			if( SUPPORT[type]['justify'] && obj.justify && obj.justify != SUPPORT[type]['justify'] )
				args.justify = obj.justify;
			if( SUPPORT[type]['ShortcutKey'] && obj.ShortcutKey )
				args.ShortcutKey = obj.ShortcutKey;
			if( SUPPORT[type]['image'] && this.containsImage(obj) ){
					args.image = { pathname: this.getLink({obj: obj, Value: obj.image, getFullLink: !forSave, forOut: forOut}) };
				if( obj.NextImages ){
					for( var i in obj.NextImages )
						if( obj.NextImages[i] ){
							if( !args.NextImages )
								args.NextImages = {};
							args.NextImages[i] = this.getLink({obj: obj, Value: obj.NextImages[i], getFullLink: !forSave, forOut: forOut});
							}
					}
				}
			// properties
			var props = this.getNoDefaultProperties( obj, type );
			if( props )
				args.properties = props;
			if( SUPPORT[type]['items'] ){
				var arr = this.getItems( {args: obj, forSave: forSave, forOut: forOut} );
				if( arr && arr.length )
					args.items = arr;
				if( obj.ItemsVar )
					args.ItemsVar = obj.ItemsVar;
				if( obj.itemsArr )
					args.itemsArr = true;
				if( this.getItemSize(obj) )
					args.itemSize = [undefined, obj.itemSize[1]];
				}
			// graphics
			if( obj.graphics ){
				var font = this.getNoDefaultFontProperties( obj );
				if( font ){
					if( !args.graphics ) 
						args.graphics = {};
					args.graphics.font = {};
					for( var i in font )
						args.graphics.font[i] = font[i];
					}
				}
			if( newArgs ){
				// если меняется type
				if( newArgs.type && newArgs.type != obj.type )
					args = this.pushNewArgs( newArgs, args );
				else
					this.pushNewArgs( args, newArgs );
				if( newArgs.type && !SUPPORT[newArgs.type]['children'] )
					return args;
				}	
			if( withChildren && this.isContainer(obj) && obj.children && obj.children.length ){
				var childs = this.getChildrenArray( obj );
				if( childs ){
					args.children = [];
					for( var i = 0; i < childs.length; i++ )
						args.children[i] = uiBuilderLibrary.getClearArgs( {obj: childs[i], withChildren: withChildren, forSave: forSave, forOut: forOut} );
					}
				}
			// Layout
			args.Layout = this.copyLayout( obj, forOut );
			// Dynamic
			args.Dynamic = this.copyDynamic( obj );
			
			return args;
			}catch(err){ script.alertError(err); }
			},
		// вставка новых свойств в соответствии с args.type
		// newArgs.type при этом не учитывается
		// вставляются только поддерживаемые для args.type свойства 
		pushNewArgs: function( args, newArgs ){
			//script.consol( 'pushNewArg():', args );
			try{
			for( var arg in newArgs ){
				if( !SUPPORT[args.type][arg] )
					continue;
				var status = false;
				switch( arg ){
					case 'type':
						status = true;
					break;
					case 'properties':
						if( !args.properties ) args.properties = {};
						for( var prop in newArgs.properties ){
							if( prop == 'items' )
								continue;
							 if( SUPPORT[args.type][prop] )
								args.properties[prop] = newArgs.properties[prop];
							}
						status = true;
					break;
					case 'items':
						var arr = this.getItems( {args: newArgs, forType: args.type , forSave: false} );
						if( arr && arr.length )
							args.items = arr;
						if( this.getItemSize(newArgs) )
							args.itemSize = [undefined, newArgs.itemSize[1]];
						status = true;
					break;
					case 'graphics':
						if( SUPPORT[args.type]['font'] && newArgs.graphics.font ){
							var font = this.getNoDefaultFontProperties( newArgs );
							if( font ){
								if( !args.graphics ) 
									args.graphics = {};
								args.graphics.font = {};
								for( var i in font )
									args.graphics.font[i] = font[i];
								status = true;
								}
							}
					}
				if( status ) continue;
				if( arg == 'image' && SUPPORT[args.type]['image'] ){
					var path = newArgs.image.pathname;
					if( path && args.type == 'iconbutton' && script.getExpansion( File(path) ) == 'jpg' ){
						// пропускаем image
						}
					else if( path )
						args.image = {pathname: path};
					continue;
					}
				if( arg == 'NextImages' && SUPPORT[args.type]['image'] ){
					args.NextImages = {};
					for( var i in newArgs.NextImages ){
						if( i == 'disabled' && args.type == 'iconbutton' &&  script.getExpansion( File(newArgs.NextImages[i]) ) == 'jpg' )
							continue;
						args.NextImages[i] = newArgs.NextImages[i];
						}
					continue;
					}
				if( newArgs[arg] instanceof Array && newArgs[arg].length ){// для location и size, children, items
					args[arg] = [].concat( newArgs[arg] );// извлекаем массив через ф-цию объединения
					continue;
					}
				if( arg == 'Layout' ){
					args[arg] = this.copyLayout( obj );
					if( args.type != 'group' && args.type != 'panel' ){
						args.Layout.TabbedPanel = 
						args.Layout.orientation = 
						args.Layout.alignChildren = 
						args.Layout.margins = 
						args.Layout.spacing = undefined;
						}				
					if( !SUPPORT_LAYOUT[args.type]['title'] )
						args.Layout.title = undefined;
					if( !SUPPORT_LAYOUT[args.type]['indent'] )
						args.Layout.indent = undefined;
					if( !SUPPORT_LAYOUT[args.type]['characters'] )
						args.Layout.characters = undefined;
					continue;
					}
				if( arg == 'Dynamic' ){
					args[arg] = this.copyDynamic( obj );
					continue;
					}
				args[arg] = newArgs[arg];
				}
			return args;
			}catch(err){ script.alertError(err); }
			},
		copyLayout: function( obj, forOut ){
			if( !this.isUIObject(obj) || !obj.Layout )
				return undefined;
			var layoutArgs = {};
			var IS_WINDOW = this.isWindow(obj);
			var IS_CONTAINER = this.isContainer(obj);
			// Global
			if( obj.Layout.preferredSize ){
				if( !layoutArgs.preferredSize ) layoutArgs.preferredSize = {};
				if( obj.Layout.preferredSize.width ) layoutArgs.preferredSize.width = obj.Layout.preferredSize.width;
				if( obj.Layout.preferredSize.height ) layoutArgs.preferredSize.height = obj.Layout.preferredSize.height;
				}
			if( obj.Layout.alignment )
				layoutArgs.alignment = this.getAlignment( obj, forOut );
			// Container
			if( IS_CONTAINER ){
				if( !IS_WINDOW && obj.Layout.TabbedPanel ) 
					layoutArgs.TabbedPanel = obj.Layout.TabbedPanel && (!obj.parent.Layout || !obj.parent.Layout.TabbedPanel) ? true : false;
				if( obj.Layout.orientation && obj.Layout.orientation != this.getDefaultOrientation(obj) )
					layoutArgs.orientation = obj.Layout.orientation.toLowerCase();
				if( obj.Layout.alignChildren )
					layoutArgs.alignChildren = this.getAlignChildren( obj, forOut );
				if( obj.Layout.margins ){
					layoutArgs.margins = [].concat(obj.Layout.margins);
					if( forOut && layoutArgs.margins[1] === false )
						 layoutArgs.margins[1] =  layoutArgs.margins[2] = layoutArgs.margins[3] = layoutArgs.margins[0];
					}
				if( script.constructorName( obj.Layout.spacing, 'number') )
					layoutArgs.spacing = obj.Layout.spacing;
				}
			// Local
			if( IS_WINDOW || !SUPPORT_LAYOUT[obj.type].title || ( forOut && IS_CONTAINER && ((obj.parent.Layout && obj.parent.Layout.TabbedPanel) || !obj.Layout.TabbedPanel ) ) ){
				}
			else{
				if( obj.Layout.title ) layoutArgs.title = obj.Layout.title;
				if( obj.Layout.titleVar ) layoutArgs.titleVar = true;
				if( obj.Layout.titleLayout )
						layoutArgs.titleLayout = this.getTitleLayout( obj, forOut );
				}
			if( !IS_WINDOW && SUPPORT_LAYOUT[obj.type].indent )
				if( script.constructorName( obj.Layout.indent, 'number') )
					layoutArgs.indent = obj.Layout.indent;
			if( obj.Layout.hasOwnProperty('characters') )
				layoutArgs.characters = obj.Layout.characters;
			if( obj.Layout.maximumSize ){
				if( !layoutArgs.maximumSize ) layoutArgs.maximumSize = {};
				if( obj.Layout.maximumSize.width ) layoutArgs.maximumSize.width = obj.Layout.maximumSize.width;
				if( obj.Layout.maximumSize.height ) layoutArgs.maximumSize.height = obj.Layout.maximumSize.height;
				}
			if( obj.Layout.minimumSize ){
				if( !layoutArgs.minimumSize ) layoutArgs.minimumSize = {};
				if( obj.Layout.minimumSize.width ) layoutArgs.minimumSize.width = obj.Layout.minimumSize.width;
				if( obj.Layout.minimumSize.height ) layoutArgs.minimumSize.height = obj.Layout.minimumSize.height;
				}
			for( var i in layoutArgs ) // если хоть один параметр записался
				return layoutArgs;
			},
		getTitleLayout: function( obj, forOut ){
			if( this.isWindow(obj) || !SUPPORT_LAYOUT[obj.type].titleLayout || !obj.Layout.titleLayout )
				return undefined;
			var titleLayout = {};
			if( obj.Layout.titleLayout.alignment ) titleLayout.alignment = [].concat(obj.Layout.titleLayout.alignment);
			if( obj.Layout.titleLayout.justify ) titleLayout.justify = obj.Layout.titleLayout.justify;
			if( obj.Layout.titleLayout.margins ){
				titleLayout.margins = [].concat(obj.Layout.titleLayout.margins);
				if( forOut && titleLayout.margins[1] === false )
					 titleLayout.margins[1] =  titleLayout.margins[2] = titleLayout.margins[3] = titleLayout.margins[0];
				}
			if( script.constructorName( obj.Layout.titleLayout.spacing, 'number') ) titleLayout.spacing = obj.Layout.titleLayout.spacing;
			if( script.constructorName( obj.Layout.titleLayout.characters, 'number') ) titleLayout.characters = obj.Layout.titleLayout.characters;
			if( obj.Layout.titleLayout.truncate ) titleLayout.truncate = obj.Layout.titleLayout.truncate;
			for( var i in titleLayout ) // если хоть один параметр записался
				return titleLayout;
			},
		getAlignment: function( obj, forOut ){
			if( this.isWindow(obj) || !obj.Layout || !obj.Layout.alignment )
				return undefined;
			
			var defaultAlignment = this.getDefaultAlignChildren( obj.parent );
			if( obj.parent.Layout && obj.parent.Layout.alignChildren ){ // корректируем по умолчанию согласно настройкам родителя
				if( obj.parent.Layout.alignChildren[0] ) defaultAlignment[0] = obj.parent.Layout.alignChildren[0];
				if( obj.parent.Layout.alignChildren[1] ) defaultAlignment[1] = obj.parent.Layout.alignChildren[1];
				}
			var alignment = [].concat(obj.Layout.alignment);
			if( forOut ){
				// неопределенные определяем по умолчанию
				if( !alignment[0] ) alignment[0] = defaultAlignment[0];
				if( !alignment[1] ) alignment[1] = defaultAlignment[1];
				}
			else{
				if( alignment[0] == defaultAlignment[0] ) alignment[0] = undefined;
				if( alignment[1] == defaultAlignment[1] ) alignment[1] = undefined;
				}
			if( alignment[0] == defaultAlignment[0] && alignment[1] == defaultAlignment[1] )
				alignment = undefined;
			else if( !alignment[0] && !alignment[1] )
				alignment = undefined;
			return alignment;
			},
		getDefaultOrientation: function( obj ){
			return obj.type == 'panel' || this.isWindow(obj) ? 'column' : 'row';
			},
		getDefaultAlignChildren: function( obj ){
			var parentOrientation = !obj.Layout || !obj.Layout.orientation ? this.getDefaultOrientation( obj ) : obj.Layout.orientation;
			if( parentOrientation == 'column' )
				return ['center','top'];
			else if( parentOrientation == 'row' )
				return ['left','center'];
			else return ['center','center']; // stack
			},
		getAlignChildren: function( obj, forOut ){
			if( this.isContainer(obj) && obj.Layout && obj.Layout.alignChildren )
				var alignChildren = [].concat(obj.Layout.alignChildren);
			else
				return undefined;
			var defaultAlignChildren = this.getDefaultAlignChildren( obj );
			if( forOut )
				return [
					alignChildren[0] ? alignChildren[0] : defaultAlignChildren[0],
					alignChildren[1] ? alignChildren[1] : defaultAlignChildren[1]
					];
			alignChildren[0] = alignChildren[0] && alignChildren[0] != defaultAlignChildren[0] ? alignChildren[0] : undefined;
			alignChildren[1] = alignChildren[1] && alignChildren[1] != defaultAlignChildren[1] ? alignChildren[1] : undefined;
			return (alignChildren[0] || alignChildren[1]) ? alignChildren : undefined;
			},
		copyDynamic: function( obj ){
			if( !this.isUIObject(obj) || !obj.Dynamic )
				return undefined;
			var dynArgs = {};
			if( obj.Dynamic.enabled )
				dynArgs.enabled = true;
			if( this.isWindow(obj) ){
				if( obj.Dynamic.windowMinSize && (obj.Dynamic.windowMinSize[0] || obj.Dynamic.windowMinSize[1]) )
					dynArgs.windowMinSize = [].concat( obj.Dynamic.windowMinSize );
				if( obj.Dynamic.windowResizeDirections && (obj.Dynamic.windowResizeDirections[0] || obj.Dynamic.windowResizeDirections[1]) )
					dynArgs.windowResizeDirections = [].concat( obj.Dynamic.windowResizeDirections );
				}
			else{
				if( obj.Dynamic.moveCoefs && (obj.Dynamic.moveCoefs[0] || obj.Dynamic.moveCoefs[1]) )
					dynArgs.moveCoefs = [].concat( obj.Dynamic.moveCoefs );
				if( obj.Dynamic.resizeCoefs && (obj.Dynamic.resizeCoefs[0] || obj.Dynamic.resizeCoefs[1]) )
					dynArgs.resizeCoefs = [].concat( obj.Dynamic.resizeCoefs );
				if( script.constructorName(obj.Dynamic.isSeparator, 'number') )
					dynArgs.isSeparator = obj.Dynamic.isSeparator;
				}
			for( var i in dynArgs ) // если хоть один параметр записался
				return dynArgs;
			},
		getNoDefaultProperties: function( args, objType ){ // кроме items и Name
			//script.consol( 'getNoDefaultProperties()' );
			if( !objType || !SUPPORT[objType] ){
				alert( 'getNoDefaultProperties(): error: objType == ' + objType );
				return;
				}
			if( !args.properties )
				return;
			// properties
			var flag;
			var properties = {};
			var type = objType;
			if( args.properties ){
				if( SUPPORT[type]['readonly'] && args.properties.readonly ){
					properties.readonly = true;
					flag = true;
					}
				if( SUPPORT[type]['scrolling'] && args.properties.scrolling ){
					properties.scrolling = true;
					flag = true;
					}
				if( SUPPORT[type]['multiline'] && args.properties.multiline ){
					properties.multiline = true;
					flag = true;
					}
				if( SUPPORT[type]['multiselect'] && args.properties.multiselect ){
					properties.multiselect = true;
					flag = true;
					}
				if( SUPPORT[type]['toggle'] && args.properties.toggle ){
					properties.toggle = true;
					flag = true;
					}
				if( SUPPORT[type]['borderStyle'] && args.properties.borderStyle && args.properties.borderStyle != 'etched' ){
					properties.borderStyle = args.properties.borderStyle;
					flag = true;
					}
				if( SUPPORT[type]['style'] && args.properties.style && args.properties.style != 'button' ){
					properties.style = args.properties.style;
					flag = true;
					}
				}
			return flag ? properties : false;
			},
		getCodeProperties: function( args, forOut ){ // возвращает: объект в string || '', forOut - генерация для вывода кода
			try{
			//script.consol( 'getCodeProperties() ' );
			if( !args || (!forOut && !args.properties && !args.items) || !args.type )
				return '';
			var properties = '';
			if( forOut && args.Name )
				properties += 'name: '+ (script.isNumber(args.Name) ? args.Name : '\''+args.Name+'\', ');
			var clearProps = this.getNoDefaultProperties( args, args.type );
			if( clearProps )
				for( var i in clearProps )
					if( i != 'items' )
						properties += i+': \''+clearProps[i]+'\', ';
			// Items
			var str = '';
			if( forOut && args.ItemsVar && !args.itemsArr )
				str = args.ItemsVar;
			else if( args.items ){
				var arr = this.getItems( {args: args, forType: '' , forSave: false} );
				if( arr && arr.length ){
					for( var z = 0; z <arr.length-1; z++ )
						str += '\''+arr[z].text+'\',';
					str += '\''+arr[z].text+'\'';
					str = '['+str+']';
					}
				}
			if( str )
				properties += 'items: '+str+', ';
			return properties ? (forOut ? '{'+properties+'}' : '({'+properties+'})') : '';
			}catch(err){ script.alertError( err ); return ''; }
			},
		// возвращает полный путь в зависимости от project.relativeLinks
		// Value = fsName | File | scriptUIImage
		// getFullLink - Bool, вернуть только полный путь
		getLink: function( prefs ){ // getLink( {obj, Value, getFullLink, forOut} )
			// работаем только с fsName
			if( !prefs || !prefs.obj || !prefs.Value )
				return '';
			var link = '';
			switch( prefs.Value.constructor ){
				case String:
					link = /^\.\//.test(prefs.Value) ? prefs.obj.project.file.parent.fsName + prefs.Value.replace(/^\./,'') : prefs.Value;
					link = File(link).fsName;
				break;
				case Object:
					if( !prefs.Value.pathname )
						return '';
					link = /^\.\//.test(prefs.Value.pathname) ? prefs.obj.project.file.parent.fsName + prefs.Value.pathname.replace(/^\./,'') : prefs.Value.pathname;
					link = File(link).fsName;
				break;
				case File:
					link = prefs.Value.fsName;
				break;
				case ScriptUIImage:
					link = File(prefs.Value.pathname).fsName;
				break;
				}
			if( prefs.obj.project.relativeLinks ){
				if( prefs.forOut )
					link = link.replace(prefs.obj.project.file.parent.fsName, '').replace(/^[\\\/]+/,'');
				else if( !prefs.getFullLink )
					link = link.replace(prefs.obj.project.file.parent.fsName, '.');
				}
			return script.adaptFsNameForSave( link );
			},
		// ТИПЫ
		isUIObject: function( obj ){
			if( !obj )
				return false;
			try{
			try{// тест на существование объекта, если объект был удален - выдаст ошибку
			obj.parent;
	//		obj.parent.type;
			}catch(err){ return false }
			if( SUPPORT[obj.type] )
	//		if( SUPPORT[obj.constructor.name.toString().toLowerCase()] )
				return true;
			}catch(err){ script.alertError(err); return false;}
			},
		isWindow: function( args ){ // args = uiOblect or args
			try{
			return args && args.hasOwnProperty('slotIndex') ? true : false;
			}catch(err){ script.alertError(err); return false;}
			},
		isContainer: function( obj ){
			if( !obj || !this.isUIObject(obj) )
				return;
			switch( obj.type ){
				case 'window':
				case 'dialog':
				case 'palette':
				case 'group':
				case 'panel':
				case 'tabbedPanel':
				case 'tab':
				return true;
				default:
				return false;
				}
			},
		isParentOf: function( object, object2 ){// проверяется, не является ли uiObject потомком (на всех уровнях) текущего объекта
			if( !this.isContainer(object) )
				return false;
			for( var i = 0; i < object.children.length; i++ ){
				if( object.children[i] == object2 )
					return true;
				if( uiBuilderLibrary.isParentOf(object.children[i], object2) )
	//			if( arguments.callee(object.children[i], object2) )
					return true;
				}
			return false;
			},
		// СПИСКИ
		addProjectToList: function( project ){ // добавляет и выделяет проект
			//script.consol( 'addProjectToList(): ', project );
			var selection = win.builder.projects.selection;// запоминаем выделение
			var item = win.builder.projects.add('item', project.tittle);
			item.project = project;
			project.projectsListItem = item;
			if( selection )// восстанавливаем выделение
				win.builder.projects.selection = selection;
			},
		addObjectToList: function( obj ){
			//script.consol( 'addObjectToList(): ', obj );
			if( !obj )
				return;
			var list = obj.project.activeObjList;
			var selection = list.selection;// запоминаем выделение
			var item;
			if( list.type == 'treeview' ){
				var itemType = this.isContainer(obj) ? 'node' : 'item';
				var parentItem = this.isWindow(obj) ? list : obj.parent.listItem;
				item = parentItem.add(itemType, obj.Var);
				}
			else{
				item = list.add('item', this.getFullVar(obj));
				}
			obj.listItem = item;
			item.object = obj;
			if( selection )// восстанавливаем выделение
				selection.parent.selection = selection;
			},
		// ТЕКУЩИЕ ОБЪЕКТЫ
		getSelectedObject: function(){ // возвращает выделеный объект текущего проекта
			//script.consol( 'getSelectedObject()' );
			return this.currentProject ? this.currentProject.currentObject : false;
			},
		selectingStatus: false,// режим работы с интерфейсом, при котором он не реагирует на ввод данных
		getSelectedObject_forInterface: function(){ // возвращает выделеный объект текущего проекта для интерфейса
			return this.selectingStatus ? false : this.getSelectedObject();
			},
		// ПРОЕКТЫ
		clearProjectSlot: function( index ){
			//script.consol( 'clearProjectSlot(): ', index );
			win.builder.listsbox.children[index].visible = false;
			win.builder.listsbox.children[index].removeAll();
			win.builder.listsbox.children[index].project = false;
			if( win.projects[index].children.length )
				for( var i =  win.projects[index].children.length-1; i > -1 ; i-- )
					win.projects[index].remove(win.projects[index].children[i]);
			win.projects[index].Var = '';
			win.projects[index].text = '';
			win.projects[index].textVar = false;
			win.projects[index].Resizeable = false;
			win.projects[index].Borderless = false;
			win.projects[index].relativeLinks = false;
			win.projects[index].file = false;
			win.projects[index].saved = false;
			win.projects[index].activeObjList = false;
			win.projects[index].slotIndex = index;
			win.projects[index].bounds = [0,0,SETTINGS.projectSize[0],SETTINGS.projectSize[1]];
			win.projects[index].visible = false;
			win.projects[index].projectsListItem = false;
			win.projects[index].listItem = false;
			win.projects[index].currentObject = false;
			},
		getEmptyProject: function(){ // возвращает индекс свободного слота или false если все слоты заняты
			//script.consol( 'getEmptyProject()' );
			for( var i = 0; i < win.projects.length; i++ )
				if( !win.projects[i].projectsListItem ){
					this.clearProjectSlot( i );
					return win.projects[i];
					}
			return false;
			},
		setCurrentProject: function( obj ){
			//script.consol( 'setCurrentProject(): ', obj );
			if( obj && this.currentProject == obj.project )
				return;
			// old currentProject
			if( this.currentProject ){
				this.currentProject.visible = false;
				win.builder.listsbox.children[this.currentProject.slotIndex].visible = false;
				}
			// new currentProject
			if( !obj )
				return this.currentProject = false;
			// выделяем
			try{
				this.selectingStatus = true;
				win.builder.projects.selection = obj.project.projectsListItem;
				this.currentProject = obj.project;
			}catch(err){ script.alertError(err); return this.currentProject = false; }
			finally{ this.selectingStatus = false }
			// objects
			obj.project.visible = true;
			obj.project.activeObjList.visible = true;
			if( !obj.project.currentObject )
				this.setCurrentObject( obj.project );
			else
				this.setObject( obj.project.currentObject );
			if( obj.project.file )
				WORKS.folderCurrent(obj.project.file);//устанавливаем папку по умолчанию - папка проекта
			},
		getProject: function( obj ){// возвращает проект (окно) объекта, для вновь создаваемых объектов, возвращает project или false
			//script.consol( 'getProject(): ', obj );
			if( !obj || !this.isUIObject(obj) )
				return false;
			return this.isWindow( obj ) ? obj : uiBuilderLibrary.getProject(obj.parent);
	//		return this.isWindow( obj ) ? obj : arguments.callee(obj.parent);
			},
		getProjectOfFile: function( file ){// если файл в данный момент открыт - возвращает его проект
			//script.consol( 'getProjectOfFile(): ', file );
			for( var i = 0; i < win.projects.length; i++ )
				if( win.projects[i].projectsListItem && win.projects[i].file && win.projects[i].file.absoluteURI == file.absoluteURI )
					return win.projects[i];
			},
		closeProject: function( project, noSave, Delete ){
			//script.consol( 'closeProject(): ', project );
			if( !project )
				return;
			var isCurrentProject = ( project == this.currentProject );
			if( !noSave && !Delete && !project.saved ){
				var res = script.confirm( 'Close project', 'Save project "'+project.tittle+'" before closed?' );
				if( res == undefined )
					return;
				if( res && !this.saveProject(project) )
					return;
				}
			if( Delete && project.file ){
				if( !confirm('Delete project "'+project.tittle+'"?', false, 'Delete project') )
					return;
				project.file.remove();
				}
			project.projectsListItem.parent.remove( project.projectsListItem );
			this.clearProjectSlot( project.slotIndex );
			if( isCurrentProject ){
				this.currentProject = false;
				if( win.builder.projects.children.length )// выделяем первый
					this.setCurrentProject( win.builder.projects.children[0].project );
				}
			return true;
			},
		getArgsOfProject: function( project ){ // для сохранения проекта
			if( !project )
				return;
			var args = this.getClearArgs( { obj: project, withChildren: true, forSave: true } );
			args.scriptVersion = script.version;
			args.scriptName = script.name;
			return args;
			},
		saveProject: function( project, saveAs ){
			//script.consol( 'saveProject(): ', project );
			try{
			if( !project || project.saved && !saveAs )
				return;
			if( project.file && !project.saved && !saveAs ){ // просто сохраняем
				if( !script.fileWrite(project.file, script.objectToSource(this.getArgsOfProject(project))) )// если ошибка записи
					return;
				project.saved = true;
				project.projectsListItem.text = script.getNameOnly( project.file );
				}
			else if( !project.file || saveAs ){
				var file = File.saveDialog('Save'+(saveAs?' as...':''), 'File:*.txt');
				if( !file )
					return;
				var openedProject = this.getProjectOfFile(file);
				if( !openedProject ){ // если файл не открыт
					if( saveAs && project.file && project.saved )
						project.file.copy( file );
					else if( !script.fileWrite(file, script.objectToSource(this.getArgsOfProject(project))) )// если ошибка записи
						return;
					project.file = file;
					project.saved = true;
					project.projectsListItem.text = script.getNameOnly( project.file );
					}
				else if( openedProject ){ // если файл уже открыт
					if( project != openedProject ){
						alert( file.fsName + '\r' + 'файл в данный момент открыт' );
						return false;
						}
					else 
						return this.saveProject(project);
					}
				}
			}catch(err){ script.alertError(err); }
			},
		openProject: function(){
			//script.consol( 'openProject()' );
			if( !this.getEmptyProject() )
				return alert( 'Максимальное количество проектов - ' + SETTINGS.projectsCount );
			var file = File.openDialog('Open project', "File:*.txt");
			if( file )
				this.setProject( {file: file} );
			},
		setProject: function( prefs ){ // prefs = {file: File of project}
			//script.consol( 'setProject(): ', prefs );
			try{
			prefs = prefs || {};
			var project = this.getEmptyProject();
			if( !project ){
				alert( 'Максимальное количество проектов - ' + SETTINGS.projectsCount );
				return;
				}
			var args = {};
			if( prefs.file ){
				var pr = this.getProjectOfFile(prefs.file);
				if( pr ){// если проект уже открыт
					this.setCurrentProject( pr );
					return pr;
					}
				args = script.sourceToObject( script.fileRead(prefs.file) );
				if( !args || !Object.isValid(args) ){
					alert('Error load file:\r' + prefs.file.fsName);
					return;
					}
				if( !args.scriptName || args.scriptName != script.name ){
					alert( 'This is not a project ' + script.name );
					return;
					}
				if( args.scriptVersion && args.scriptVersion > script.version ){
					var mess = 'Error.'+'\r';
					mess += 'Current script version: ' + script.version + '\r';
					mess += 'Version of project: ' + args.scriptVersion + '\r';
					mess += '\r';
					mess += 'Download last version of script.';
					alert( mess );
					return;
					}
				
				if( args.Layout ){
					// переводим args.Layout.preferredSize из массива в свойства
					if( args.Layout.preferredSize && args.Layout.preferredSize.constructor == Array ){
						var _width = args.Layout.preferredSize[0];
						var _height = args.Layout.preferredSize[1];
						delete args.Layout.preferredSize;
						args.Layout.preferredSize = {width: _width, height: _height};
						}
					// переводим args.Layout.maximumSize из массива в свойства
					if( args.Layout.maximumSize && args.Layout.maximumSize.constructor == Array ){
						var _width = args.Layout.maximumSize[0];
						var _height = args.Layout.maximumSize[1];
						delete args.Layout.maximumSize;
						args.Layout.maximumSize = {width: _width, height: _height};
						}
					// переводим args.Layout.minimumSize из массива в свойства
					if( args.Layout.minimumSize && args.Layout.minimumSize.constructor == Array ){
						var _width = args.Layout.minimumSize[0];
						var _height = args.Layout.minimumSize[1];
						delete args.Layout.minimumSize;
						args.Layout.minimumSize = {width: _width, height: _height};
						}
					}
				}
			project.saved = false;
			var tittle;
			if( !prefs.file ){
				tittle = 'New project';
				var projectListItems =  win.builder.projects.children;
				for( var i = projectListItems.length-1; i > -1; i-- ){
					if( /^\[New project.*\]$/.test(projectListItems[i].project.tittle) ){
						var res = /(\d+)\]$/.exec(projectListItems[i].project.tittle);
						tittle += ' ' + ( (res && res[1] ? +res[1] : 0)+1 );
						break;
						}
					}
				tittle = '['+tittle+']';
				}
			else{
				tittle = script.getNameOnly( prefs.file );
				project.saved = true;
				}
			project.tittle = tittle;
			project.file = prefs.file ? prefs.file : false;
			project.Var = args.Var || 'win';
			project.project = project; // для быстрой навигации
			project.currentObject = false;
			project.activeObjList = win.builder.listsbox.children[project.slotIndex];
			project.activeObjList.visible = true;
			this.addObjectToList( project );
			this.addProjectToList( project );
			if( args )
				this.setObject( project, args, {select:true} );
			this.setCurrentProject( project );
			
			return project;
			}catch(err){ script.alertError(err); }
			},
		// ОБЪЕКТЫ
		deleteObject: function( props ){ // props = { obj: uiObject, withoutConfirm: Bool, notSelectParentOfCurrentObject: Bool }
			//script.consol( 'deleteObject(): ', obj );
			try{
			var obj = props.obj;
			if( this.isWindow(obj) )
				return this.closeProject(obj, true, true);
			if( this.isContainer(obj) ){
				if( obj.children.length ){
					if( !props.withoutConfirm ){ // if without confirm
						var message = 'Will be deleted objects:\r';
						var objs = this.getAllChildrenArray(obj);
						for( var i = 0; i < objs.length; i++ )
							message += this.getFullVar( objs[i] ) + '\r';
						if( !confirm(message, false, 'Delete object') )
							return;
						}
					for( var i = obj.children.length-1; i > -1 ; i-- )
						this.deleteObject( { obj: obj.children[i], withoutConfirm: true, notSelectParentOfCurrentObject: true } ); 
		//				arguments.callee( obj.children[i], true );
					}
				}
			obj.project.saved = false;
			obj.listItem.parent.remove( obj.listItem );
			
			var isCurrentObject = false;
			if( obj.project.currentObject == obj ){
				isCurrentObject = true;
				obj.project.currentObject = false;
				}
			var parent = obj.parent;
			obj.parent.remove( obj );
			if( isCurrentObject && !props.notSelectParentOfCurrentObject )
				this.setCurrentObject( parent );
			}catch(err){ script.alertError(err); }
			},
		highlightObject: function( obj ){
			if( !obj )
				return;
			switch( obj.type ){
				case 'treeview': // не поддерживается ни один тип выделения
				break;
				case 'image':
				case 'iconbutton':
					// исключения, не выделяются
				break;
				case 'checkbox':
				case 'radiobutton':
				case 'listbox':
					script.addColor( obj, 1, APP_SETTINGS.highlightColor ? APP_SETTINGS.highlightColor : SETTINGS.highlightColor );
				break;
				case 'group':
				case 'panel':
				case 'dropdownlist':
				case 'edittext':
					script.addColor( obj, 0, APP_SETTINGS.highlightColor ? APP_SETTINGS.highlightColor : SETTINGS.highlightColor );
				break;
				default:
					script.getCustomDraw( obj, {bgRGB: APP_SETTINGS.highlightColor ? APP_SETTINGS.highlightColor : SETTINGS.highlightColor } );
				}
			},
		unHighlightObject: function( obj ){
			if( !obj )
				return;
			switch( obj.type ){
				case 'treeview': // не поддерживается ни один тип выделения
				break;
				case 'image':
				case 'iconbutton':
					// исключения, не выделяются
				break;
				case 'checkbox':
				case 'radiobutton':
				case 'listbox':
					script.addColor( obj, 1, SETTINGS.Default.graphics.foregroundColor.color );
				break;
				case 'group':
				case 'panel':
					script.addColor( obj, 0, SETTINGS.Default.graphics.backgroundColor.color );
				break;
				case 'dropdownlist':
				case 'edittext':
				script.addColor( obj, 0, [255,255,255] );
				break;
				default:
					script.getCustomDraw( obj ); // сбрасываем customDraw
				}
			},
		setCurrentObject: function( obj, isCallOfSetObject ){
			//script.consol( 'setCurrentObject(): ', obj );
			// на совпадение текущего и передаваемого объектов не проверяем, 
			// поскольку при ппересоздании если текущий объект уже удален - выдает ошибку
			if( !obj/* || obj.project.currentObject == obj */)
				return;
			if( !this.isUIObject(obj.project.currentObject) )
				obj.project.currentObject = false;
			if( obj.project.currentObject != obj ){ 
				 // снимаем подсветку
				if( APP_SETTINGS.highlightCurrentObject && obj.project.currentObject )
					this.unHighlightObject( obj.project.currentObject );
				obj.project.currentObject = obj;
				if( APP_SETTINGS.highlightCurrentObject )
					this.highlightObject( obj );
				}
			// выделяем в списке
			try{
			this.selectingStatus = true;
			if( obj.listItem.parent.type == 'node' )
				obj.listItem.parent.expanded = true;
			obj.project.listItem.parent.selection = obj.listItem;
			}catch(err){ script.alertError(err); return; }
			finally{ this.selectingStatus = false }
			// показываем настройки и подсвечиваем
			 if( !isCallOfSetObject )
				this.setObject( obj );
			},
		check: function( args, parent ){// Проверка на наличие обязателных параметров и соответствие родителю
			//script.consol( 'check(): ', args );
			if( !args || args.constructor != Object || !parent )
				return false;
			if( !args.type ){
				alert( 'Error: function check:\r type == '+args.type );
				return false;
				}
			if( SUPPORT[args.type]['parent'] ){
				if( !parent ){
					alert( 'Error: function check:\r parent == '+args.parent );
					return false;
					}
				}
			return true;
			},
		// если obj не передается - значит создание нового объекта
		// args - объект свойств
		setObject: function( obj, args, prefs ){ // prefs = {select: Boolean, withoutChildren: Boolean, copy: Boolean, parent: uiObject}, где parent - либо новый родитель
			//script.consol( 'setObject(): ', obj );
			try{
			if( !obj && !args )
				return;
			prefs = prefs || {};
			//если нужно только выделить
			if( obj && !args && !prefs.copy && !prefs.parent ){
				prefs.select = true;
				if( obj.project != this.currentProject )
					this.setCurrentProject( obj.project );
				// пропускаем создание объекта
				}
			else if( obj ){
				if( prefs.copy || (prefs.parent && this.isUIObject(prefs.parent) && prefs.parent != obj.parent) ){
					args = this.getClearArgs( { obj: obj, withChildren: !prefs.withoutChildren, newArgs: args } );
					if( prefs.copy && !prefs.parent )
						prefs.parent = obj.parent;
					if( prefs.parent ){
						if( this.isParentOf(obj, prefs.parent) ){
							alert( 'setObject(): error: obj '+ obj+' isParentOf prefs.parent '+prefs.parent );
							return;
							}
						this.deleteObject( { obj: obj, withoutConfirm: true, notSelectParentOfCurrentObject: true } );
						}
					obj = false;
					prefs.select = true;
					}
				else if( args ){// здесь вычисляется требуют ли новые аргументы пересоздания объекта
					var flag;
					if( args.type && args.type != obj.type )
						flag = true;
					else if( obj.type == 'dropdownlist' && this.arrayContainsSeparator(args.items) )
						flag = true;
					else if( args.properties && !this.isWindow(obj) ){
						if( obj.properties ){
							var objClearProps = this.getNoDefaultProperties( obj, obj.type );
							for( var i in args.properties )
								if( !objClearProps.hasOwnProperty(i) || objClearProps[i] != args.properties[i] ){
									flag = true;
									break;
									}
							}
						else
							flag = true;
						}
					if( flag ){
						args = this.getClearArgs( { obj: obj, withChildren: !prefs.withoutChildren, newArgs: args } );
						prefs.parent = obj.parent;
						// перебрасываемые данные
						if( obj.project.currentObject == obj ){
							obj.project.currentObject = false;
							prefs.select = true;
							}
						args.listItem = obj.listItem;
						if( this.isContainer( obj ) && obj.children && obj.children.length )
							for( var i = obj.children.length-1; i > -1 ; i-- )
								this.deleteObject( { obj: obj.children[i], withoutConfirm: true, notSelectParentOfCurrentObject: true } );
						obj.parent.remove( obj );
						obj = false;
						}
					}
				}
			// проверяем условия для создания нового объекта
			if( !obj && (!args || (!prefs.parent || !this.isUIObject(prefs.parent))) ){
				alert( 'setObject(): error: obj: ' + obj + ', prefs.parent = ' +prefs.parent );
				return;
				}
			// если для создания все условия выполнены - создаем
			 if( !obj ){
				// обязательные параметры для args
				args.type = args.type || 'statictext';
				if( !this.isContainer(prefs.parent) )
					prefs.parent = prefs.parent.parent;
				if( !this.check(args, prefs.parent) )
					return alert( 'setObject(): error: args:\r ' + args.toSource() + '\r parent: ' + prefs.parent );
				var obj = prefs.parent.add( args.type, undefined, undefined, eval( this.getCodeProperties(args) ) );
				if( obj.type ==  'group' || obj.type ==  'panel' ) // для корректной работы выделения
					script.addColor( obj, 0, SETTINGS.Default.graphics.backgroundColor.color );
				if( args.hasOwnProperty('items') )// удаляем из args уже созданные items
					args.items = false;
				if( obj.type ==  'button' )
					obj.onClick = function(){ return false } // ф-ция против срабатывания автособытий на кнопки с именами 'OK' и 'Cancel'
				obj.enabled = true; // восстанавливаем enabled
				obj.project = this.getProject( obj ); // для быстрой навигации
	//			obj.Var = args.Var ? args.Var : SUPPORT[obj.type]['Var']; // уже определяем Var для добавления в списки
				obj.Var = args.Var ? args.Var : PREFERRED_NAMES[obj.type]; // уже определяем Var для добавления в списки
				if( this.VarsBasa[obj.Var] ) // если Var есть в списке по умолчанию - меняем его в args (для ф-ции Var()) согласно типу объекта
					args.Var = PREFERRED_NAMES[obj.type];
	//				args.Var = SUPPORT[obj.type]['Var'];
				if( args.listItem ){
					if( obj.project.activeObjList.type != 'treeview' || (this.isContainer(obj) && args.listItem.type == 'node') || (!this.isContainer(obj) && args.listItem.type == 'item') )
						obj.listItem = args.listItem;
					else{ // меняем тип listItem
						var thisParent = args.listItem.parent;
						var thisIndex = args.listItem.index;
						var thisText = args.listItem.text;
						thisParent.remove( thisIndex );
						obj.listItem = thisParent.add( (this.isContainer(obj)?'node':'item'), thisText, thisIndex );
						}
					obj.listItem.object = obj;
					}
				else
					this.addObjectToList(obj);
				}
			}catch(err){ script.alertError(err); return false; }
			// отсюда уже идет обработка переданного или вновь созданного объекта
			if( !this.isUIObject(obj) ){
				alert( 'setObject(): error_2: obj = ' + obj );
				return;
				}
			try{
			if( prefs.select )
				this.setCurrentObject( obj, true );
			
			this.Type( obj );
			
			if( args && this.isWindow(obj) ){
				if( args.hasOwnProperty('Resizeable') )
					obj.Resizeable = args.Resizeable;
				if( args.hasOwnProperty('Borderless') )
					obj.Borderless = args.Borderless;
				if( args.hasOwnProperty('relativeLinks') )
					obj.relativeLinks = args.relativeLinks;
				}
			this.Properties( obj );
			
			this.Var( obj, args );
			this.Name( obj, args );
			this.Location( obj, args );
			this.Size( obj, args );
			this.Visible( obj, args );
			this.HelpTip( obj, args );
			
			this.Text( obj, args );
			this.Items( obj, args );
			this.Font( obj, args );
			this.Image( obj, args );
			this.ShortcutKey( obj, args );
			this.GroupLocation( obj );
			this.Layout( obj, args );
			this.Dynamic( obj, args );
			// children
			if( !prefs.withoutChildren && args && args.children && args.children.length )
				for( var i = 0; i < args.children.length; i++ )
					uiBuilderLibrary.setObject( false, args.children[i], { parent: obj } );
			}catch(err){ script.alertError(err); return; }
			return true;
			},
		Select_init: function(){
			//script.consol( 'Select_init()' );
			var LIB = this;
			for( var i = 0; i < SETTINGS.projectsCount; i++ ){
				win.builder.listsbox.children[i].onChange = function(){
					if( !LIB.selectingStatus ) // если это не режим ввода данных
						LIB.setObject( this.selection.object );
					}
				}
			},
		moveListItem_init: function(){
			var LIB = this;
			win.builder.moveListItem.up.onClick = 
			win.builder.moveListItem.down.onClick = function(){
				LIB.moveListItem( this.properties.name );
				}
			},
		moveListItem: function( shift ){ // shift = 1 / -1
			try{
			var obj = this.getSelectedObject();
			if( !obj )
				return;
			//исключения
			if( obj.listItem.parent.items.length < 1 )
				return;
			if( this.isWindow(obj) )
				return;
			if( obj.listItem.type=='node' && obj.listItem.items.length > 0 )
				return;
			if( shift == -1 && obj.listItem.index == 0 )
				return;
			if( shift == 1 && obj.listItem.index == obj.listItem.parent.items.length-1 )
				return;
				
			var nextIndex = obj.listItem.index + shift;//определяем направление перемещения
			var nextItem = obj.listItem.parent.items[nextIndex];//определяем направление перемещения
			
			if( obj.project.activeObjList.type == 'treeview' ){
				if( (obj.listItem.type != nextItem.type) || ( nextItem.type == 'node' && nextItem.items.length ) ){
					//запоминаем данные текущего
					var thisParent = obj.listItem.parent;
					var thisType = obj.listItem.type;
					var thisText = obj.listItem.text;
					//КОРРЕКТНОЕ УДАЛЕНИЕ ИЗ СПИСКА
					obj.listItem.parent.remove(obj.listItem.index);

					obj.listItem = thisParent.add( thisType, thisText, nextIndex );
					obj.listItem.object = obj;
					}
				else//если оба элемента однотипны
					this.swapOfListItems( obj.listItem, nextItem );
				}
			else{//'listbox'
				if( shift == -1 && obj.parent == nextItem.object )//если элемент хочет подняться выше своего родителя - прерываем
					return;
				if(shift == 1 && obj == nextItem.object.parent )//если элемент хочет опуститься ниже своего child - прерываем
					return;
				this.swapOfListItems( obj.listItem, nextItem );
				}
			//выделяем
			obj.project.activeObjList.selection = obj.listItem;
			obj.project.saved = false;
			}catch(err){script.alertError(err);}
			},
		swapOfListItems: function( listItem_1, listItem_2 ){
			try{
			//запоминаем
			var data_2 = {
				text: String(listItem_2.text),
				object: listItem_2.object
				};
			//перебрасываем
			listItem_2.text = listItem_1.text;
			listItem_2.object = listItem_1.object;
			listItem_2.object.listItem = listItem_2;
			
			listItem_1.text = data_2.text;
			listItem_1.object = data_2.object;
			listItem_1.object.listItem = listItem_1;
			
			}catch(err){script.alertError(err)};
			},
		// НАСТРОЙКИ, ТРЕБУЮЩИЕ ПЕРЕСОЗДАНИЯ ОБЪЕКТА
		Type_init: function(){
			//script.consol( 'Type_init()' );
			win.obj.Global.Type.onChange = function(){
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( !obj || this.selection == null ){
					if( !uiBuilderLibrary.getSelectedObject() )
						this.selection = null;
					return;
					}
				uiBuilderLibrary.Type(obj, {type:this.selection.text});
				}
			},
		Type: function( obj, args ){
			//script.consol( 'Type(): ', obj, ', args: ', args );
			// меняем
			if( args && args.type && obj.type != args.type ){
				if( this.isContainer(obj) && obj.children.length && !SUPPORT[args.type]['children'] ){
					var allChildren = this.getAllChildrenArray(obj);
					var list = '';
					for( var i = 0; i <allChildren.length; i++ )
						list += this.getFullVar(obj) + '\r';
					if( list && !confirm('Будут удалены дочерние элементы: \r' + list + '\rПродолжить?') )
						return;
					}
				return this.setObject( obj, { type: args.type } );
				}
			// показываем настройки
			if( this.getSelectedObject() != obj || !win.obj.Global.visible )
				return;
			try{
			this.selectingStatus = true;
			var list = win.obj.Global.Type;
			if( this.isWindow(obj) ){
				list.enabled = false;
				list.selection = null;
				return;
				}
			list.enabled = true;
			list.selection = list.find(obj.type);
			}catch(err){ script.alertError(err); return; }
			finally{ this.selectingStatus = false }
			},
		Properties_init: function(){// обработка readonly, multiselect, scrolling, multiline, borderStyle, style, toggle
			//script.consol( 'Properties_init()' );
			for( var i = 0; i < win.obj.Local.Local2.children.length; i++ )
				win.obj.Local.Local2.children[i].onClick = Properties_Listener;
			win.obj.Local.Border.Style.onChange = win.obj.Local.Style.Style.onChange = Properties_Listener;
			function Properties_Listener(){
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( !obj ){
					switch( this.type ){
						case "dropdownlist":
						case "listbox":
						case "treeview":
						if( !uiBuilderLibrary.getSelectedObject() )
							this.selection = null;
						}
					return;
					}
				var result;
				switch( this.type ){
					case "dropdownlist":
					case "listbox":
					case "treeview":
					result = this.selection.text;
					break;
					case "checkbox":
					case "radiobutton":
					result = this.value;
					break;
					case "edittext":
					result = this.text;
					}
				var props = {properties:{}};
				props.properties[this.properties.name] = result;
				return uiBuilderLibrary.Properties( obj, props );
				}
			},
		Properties: function( obj, args ){ // здесь обрабатываются только свойства, требующие пересоздания объекта: readonly, multiselect, scrolling, multiline, borderStyle, style, itemHeight
			//script.consol( 'Properties(): ', obj, ', args: ', args );
			// меняем
			var isWin = this.isWindow( obj );
			if( args ){
				if( isWin ){
					// обработка сигнала от интерфейса (загрузка проекта обрабатывается в setObject)
					if( args.properties ){
						if( args.properties.hasOwnProperty('resizeable') )
							obj.Resizeable = args.properties.resizeable;
						if( args.properties.hasOwnProperty('borderless') )
							obj.Borderless = args.properties.borderless;
						if( args.properties.hasOwnProperty('relativeLinks') )
							obj.relativeLinks = args.properties.relativeLinks;
						}
					}
				else
					return this.setObject( obj, args );
				}
			// показываем настройки
			if( this.getSelectedObject() != obj || !win.obj.Local.visible )
				return;
			try{
			this.selectingStatus = true;
			var type = obj.type;
			win.obj.Local.Local2.ReadOnly.visible = SUPPORT[type]['readonly'] ? true : false;
			win.obj.Local.Local2.ReadOnly.value =  SUPPORT[type]['readonly'] && obj.properties && obj.properties.readonly ? true : false;
			
			win.obj.Local.Local2.MultiSelect.visible = SUPPORT[type]['multiselect'] ? true : false;
			win.obj.Local.Local2.MultiSelect.value = SUPPORT[type]['multiselect'] && obj.properties && obj.properties.multiselect ? true : false;
			
			win.obj.Local.Local2.Scrolling.visible = SUPPORT[type]['scrolling'] ? true : false;
			win.obj.Local.Local2.Scrolling.value = SUPPORT[type]['scrolling'] && obj.properties && obj.properties.scrolling ? true : false;
			
			win.obj.Local.Local2.MultiLine.visible = SUPPORT[type]['multiline'] ? true : false;
			win.obj.Local.Local2.MultiLine.value = SUPPORT[type]['multiline'] && obj.properties && obj.properties.multiline ? true : false;
			
			win.obj.Local.Local2.Toggle.visible = SUPPORT[type]['toggle'] ? true : false;
			win.obj.Local.Local2.Toggle.value = SUPPORT[type]['toggle'] && obj.properties && obj.properties.toggle ? true : false;
			
			win.obj.Local.Border.visible = SUPPORT[type]['borderStyle'] ? true : false;
			win.obj.Local.Border.Style.selection = SUPPORT[type]['borderStyle'] && obj.properties && obj.properties.borderStyle ? win.obj.Local.Border.Style.find(obj.properties.borderStyle) : win.obj.Local.Border.Style.find('etched');
				
			win.obj.Local.Style.visible = SUPPORT[type]['style'] ? true : false;
			win.obj.Local.Style.Style.selection = SUPPORT[type]['style'] && obj.properties && obj.properties.style ? win.obj.Local.Style.Style.find(obj.properties.style) : 0;
			
			win.obj.Local.Local2.Resizeable.visible = isWin ? true : false;
			win.obj.Local.Local2.Resizeable.value = obj.Resizeable ? true : false;
			
			win.obj.Local.Local2.Borderless.visible = isWin ? true : false;
			win.obj.Local.Local2.Borderless.value = obj.Borderless  ? true : false;
			
			win.obj.Local.Local2.relativeLinks.visible = isWin ? true : false;
			win.obj.Local.Local2.relativeLinks.enabled = obj.project.file ? true : false;
			win.obj.Local.Local2.relativeLinks.value = obj.relativeLinks  ? true : false;
			
			}catch(err){ script.alertError(err); return; }
			finally{ this.selectingStatus = false }
			},
		// НАСТРОЙКИ, НЕ ТРЕБУЮЩИЕ ПЕРЕСОЗДАНИЯ ОБЪЕКТА
		// ГЛОБАЛЬНЫЕ
		getFullVar: function( obj ){// return fullVar, рекурсивная ф-ция
			//script.consol( 'getFullVar(): ', obj );
			try{
			if( !obj.Var )
				obj.Var = this.Var( obj );
			if( this.isWindow(obj) )
				return obj.Var;
			var  string = obj.parent.Var + '.' + ( arguments[1] ? arguments[1] : obj.Var );
			if( this.isWindow(obj.parent) )
				return string;
			return uiBuilderLibrary.getFullVar( obj.parent, string );
			}catch(err){ script.alertError(err); }
			},
		recomposeLists: function( obj ){
			//script.consol( 'recomposeLists(): ', obj );
			obj.listItem.text = obj.project.listItem.parent.type == 'treeview' ? obj.Var : this.getFullVar(obj);
			if( this.isContainer(obj) ){
				for( var i = 0; i < obj.children.length; i++ )
					uiBuilderLibrary.recomposeLists( obj.children[i] );
	//				arguments.callee( obj.children[i] );
				}
			},
		Var_init: function(){
			//script.consol( 'Var_init()' );
			win.obj.Global.Var.onChanging = CORRECTS.varCorrectChanging_forInterface;
	//		win.obj.Global.Var.onChanging = function(){
	//			this.text = this.text.replace(/[^a-zA-Z\d_]/g,'');
	//			}
			win.obj.Global.Var.onChange = function(){
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( obj ){
					this.text = CORRECTS.varCorrect(this.text);
					uiBuilderLibrary.Var( obj, {Var:this.text} );
					}
				}
			},
		Var: function( obj, args ){
			//script.consol( 'Var(): ', obj, ', args: ', args );
			// меняем
			if( args && obj.Var != args.Var ){
				obj.Var = args.Var ? args.Var : (obj.Var ? obj.Var : PREFERRED_NAMES[obj.type]);
	//			obj.Var = args.Var ? args.Var : (obj.Var ? obj.Var : SUPPORT[obj.type]['Var']);
				this.recomposeLists( obj );
				}
			// показываем настройки
			if( this.getSelectedObject() != obj || !win.obj.Global.visible )
				return;
			try{
			this.selectingStatus = true;
			win.obj.Global.Var.text = obj.Var;
			}catch(err){ script.alertError(err); return; }
			finally{ this.selectingStatus = false }
			},
		Name_init: function(){
			//script.consol( 'Name_init()' );
			win.obj.Global.Name.onChange = function(){
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( obj ){
	//				this.text = CORRECTS.varCorrect(this.text);
					obj.Name = this.text;
					}
				}
			},
		Name: function( obj, args ){
			//script.consol( 'Name(): ', obj, ', args: ', args );
			// меняем
			if( args && args.hasOwnProperty('Name') )
				obj.Name = args.Name;
			// показываем настройки
			if( this.getSelectedObject() != obj || !win.obj.Global.visible )
				return;
			try{
			this.selectingStatus = true;
			win.obj.Global.Name.text = obj.Name ? obj.Name : '';
			}catch(err){ script.alertError(err); return; }
			finally{ this.selectingStatus = false }
			},	
		Location_init: function(){
			//script.consol( 'Location_init()' );
			var winPoints = win.obj.Global.Points;
			winPoints.W.onChanging = winPoints.H.onChanging = CORRECTS.dataCorrectEnter_forInterface;
			// через addEventListener недоступен shortcutKey
			winPoints.W.onChange = 
			winPoints.Wplus.onClick = 
			winPoints.Wminus.onClick = 
			winPoints.Wround.onClick = 
			winPoints.H.onChange = 
			winPoints.Hplus.onClick = 
			winPoints.Hminus.onClick =
			winPoints.Hround.onClick = function(){
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( !obj )
					return;
				var location = [obj.location[0], obj.location[1]];
				switch( this.properties.name ){
					case 'W':
						location[0] = CORRECTS.dataCorrect( winPoints.W.text );
					break;
					case 'Wplus':
						location[0] += SETTINGS.getStep();
					break;
					case 'Wminus':
						location[0] = SETTINGS.getStep() > location[0] ? 0 : location[0] - SETTINGS.getStep();
					break;
					case 'Wround':
						location[0] = CORRECTS.dataRound( winPoints.W.text );
					break;
					case 'H':
						location[1] = CORRECTS.dataCorrect( winPoints.H.text );
					break;
					case 'Hplus':
						location[1] += SETTINGS.getStep();
					break;
					case 'Hminus':
						location[1] = SETTINGS.getStep() > location[1] ? 0 : location[1] - SETTINGS.getStep();
					break;
					case 'Hround':
						location[1] = CORRECTS.dataRound( winPoints.H.text );
					break;
					case 'onlyVisible':
					return;// прерываем
					break;
					}
				uiBuilderLibrary.Location( obj, {location: location}, LAYOUT_SETTINGS.autoFitToContent );
				}
			if( File.fs == 'Windows' && script.getAppName( 'indesign' ) ){
				winPoints.Wminus.shortcutKey = "Left";
				winPoints.Wplus.shortcutKey = "Right";
				winPoints.Hminus.shortcutKey = "Up";
				winPoints.Hplus.shortcutKey = "Down";
				}
			else{
				win.addEventListener('keyup', handler);
				function handler( e ){
					if( e.keyLocation == 3 ) // DOM_KEY_LOCATION_NUMPAD
						switch( e.keyName ){
							case '4':
								winPoints.Wminus.onClick();
							break;
							case '6':
								winPoints.Wplus.onClick();
							break;
							case '8':
								winPoints.Hminus.onClick();
							break;
							case '2':
								winPoints.Hplus.onClick();
							break
							}
					}
				}
			},
		Location: function( obj, args, fitParentToContent ){// если args не указан - location вычисляется автоматически
			//script.consol( 'Location(): ', obj, ', args: ', args );
			var oldLocation = obj.location ? [obj.location[0],obj.location[1]] : false;
			// меняем
			var thisFitParentToContent = false;
			var fitOnW = false;
		//	if( !this.isWindow(obj) ){
				if( !obj.location ){
					obj.location = this.getAutoLocation( obj );
					thisFitParentToContent = true;
					}
				if( args && args.location ){
					obj.location = args.location;
					thisFitParentToContent = fitOnW = fitParentToContent ? true : false; // отменяем fitParentToContent если он явно не передавался, а также определяем fit по горизонтали
					}
		//		}
			// показываем настройки
			if( this.getSelectedObject() == obj && win.obj.Global.visible ){
				try{
				this.selectingStatus = true;
				if( this.isWindow(obj) ){
					win.obj.Global.Points.enabled = false;
					win.obj.Global.Points.W.text = win.obj.Global.Points.H.text = '';
					return;
					}
				win.obj.Global.Points.enabled = true;
				win.obj.Global.Points.W.text = obj.location[0];
				win.obj.Global.Points.H.text = obj.location[1];
				}catch(err){ script.alertError(err); return; }
				finally{ this.selectingStatus = false }
				}
			if( args && obj.size && !this.isWindow(obj) ){
				// autoLocation - изменяет местоположение соседних справа и снизу объектов
				if( LAYOUT_SETTINGS.autoLocation && oldLocation && obj.parent.children.length > 1 )
					this.setAutoLocation( obj,  [obj.location[0] - oldLocation[0], obj.location[1] - oldLocation[1]] );
				// autoFitToContent
	//			if( (thisFitParentToContent && LAYOUT_SETTINGS.autoFitToContent) || this.isWindow(obj.parent) )
	//			if( thisFitParentToContent && LAYOUT_SETTINGS.autoFitToContent )
				if( (thisFitParentToContent && LAYOUT_SETTINGS.autoFitToContent) || (this.isWindow(obj.parent) && LAYOUT_SETTINGS.autofitWindowProject) )
					this.fitToContent( obj.parent, [fitOnW||this.isWindow(obj.parent)?true:false, true] );
				}
			},
		getAutoLocation: function( obj ){ // 
			//script.consol( 'getAutoLocation(): ', obj );
			try{
			if( this.isWindow( obj ) )
				return [0,0];
			var parent = obj.parent;
			var thisPointH = 0;
			var children = parent.children;
			if( children.length && !(children.length==1&&children[0]==obj) )
				for( var i=0;i<children.length-1;i++ ){
					if( children[i] == obj )
						continue;
					thisPointH = (children[i].bounds[3]>thisPointH) ? children[i].bounds[3] : thisPointH;
					}
			var padding = this.getPaddingForContainer( parent );
			var thisIndentH = parent.children.length == 1 ? padding[1] : AUTO_SETTINGS.autoIndent[1];// если первый объект - отступ от родителя
			return [padding[0], thisIndentH + thisPointH];
			}catch(err){ script.alertError(err); return [0,0];}
			},
		Size_init: function(){
			//script.consol( 'Size_init()' );
			var winSize = win.obj.Global.Size;
			winSize.W.onChanging = winSize.H.onChanging = CORRECTS.dataCorrectEnter_forInterface;
			winSize.W.onChange = 
			winSize.Wplus.onClick = 
			winSize.Wminus.onClick = 
			winSize.Wround.onClick = 
			winSize.H.onChange = 
			winSize.Hplus.onClick = 
			winSize.Hminus.onClick =
			winSize.Hround.onClick = function(){
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( !obj )
					return;
				var size = [obj.size[0], obj.size[1]];
				switch( this.properties.name ){
					case 'W':
						size[0] = CORRECTS.dataCorrect( winSize.W.text );
					break;
					case 'Wplus':
						size[0] += SETTINGS.getStep();
					break;
					case 'Wminus':
						size[0] -= SETTINGS.getStep();
					break;
					case 'Wround':
						size[0] = CORRECTS.dataRound( winSize.W.text );
					break;
					case 'H':
						size[1] = CORRECTS.dataCorrect( winSize.H.text );
					break;
					case 'Hplus':
						size[1] += SETTINGS.getStep();
					break;
					case 'Hminus':
						size[1] -= SETTINGS.getStep();
					break;
					case 'Hround':
						size[1] = CORRECTS.dataRound( winSize.H.text );
					break;
					}
				uiBuilderLibrary.Size( obj, {size: size}, LAYOUT_SETTINGS.autoFitToContent );
				}
			},
		Size: function( obj, args, fitParentToContent ){// если args не указан - size вычисляется автоматически
			//script.consol( 'Size(): ', obj, ', args: ', args );
			try{
			var oldSize = obj.size ? [obj.size[0],obj.size[1]] : false;
			var thisFitParentToContent = false;
			var fitOnW = false;
			// меняем
			if( !obj.size ){
				obj.size = this.getAutoSize( obj );
				thisFitParentToContent = true;
				}
			if( args && args.size ){
				obj.size = args.size;
				thisFitParentToContent = fitOnW = fitParentToContent ? true : false; // отменяем fitParentToContent если он явно не передавался, а также определяем fit по горизонтали
				}
			// показываем настройки
			if( this.getSelectedObject() == obj && win.obj.Global.visible ){
				try{
				this.selectingStatus = true;
				win.obj.Global.Size.W.text = obj.size[0];
				win.obj.Global.Size.H.text = obj.size[1];
				}catch(err){ script.alertError(err); return; }
				finally{ this.selectingStatus = false }
				}
			if( args /*&& obj.size */&& !this.isWindow(obj) ){
				// autoLocation - изменяет местоположение соседних справа и снизу объектов
				if( LAYOUT_SETTINGS.autoLocation && oldSize && obj.parent.children.length > 1 )
					this.setAutoLocation( obj,  [obj.size[0] - oldSize[0], obj.size[1] - oldSize[1]] );
				// autoFitToContent
	//			if( (thisFitParentToContent && LAYOUT_SETTINGS.autoFitToContent) || this.isWindow(obj.parent) )
	//			if( thisFitParentToContent && LAYOUT_SETTINGS.autoFitToContent )
				if( (thisFitParentToContent && LAYOUT_SETTINGS.autoFitToContent) || (this.isWindow(obj.parent) && LAYOUT_SETTINGS.autofitWindowProject) )
					this.fitToContent( obj.parent, [fitOnW||this.isWindow(obj.parent)?true:false, true] );
				}
			}catch(err){ script.alertError(err);}
			},
		setAutoLocation: function( obj, shifts ){// изменяет местоположение соседних справа и снизу объектов
			//script.consol( 'setAutoLocation(): ', obj, ', shifts: ', shifts );
			var colleagues = obj.parent.children;
			var objOldBounds = [
				obj.bounds[0]-shifts[0],
				obj.bounds[1]-shifts[1],
				obj.bounds[2]-shifts[0],
				obj.bounds[3]-shifts[1]
				];
			var num = 0;
			if( shifts[0] ){ // по ширине
				for( var i = 0; i < colleagues.length; i++ ){
					if( colleagues[i] != obj && colleagues[i].location[0] >= objOldBounds[2] && !(colleagues[i].bounds[3] < objOldBounds[1] || colleagues[i].bounds[1] > objOldBounds[3]) ){
						if( LAYOUT_SETTINGS.autoLocationWithinIndent ){
							num = colleagues[i].location[0]-objOldBounds[2];// расстояние м-ду объектами
							num = num == AUTO_SETTINGS.autoIndent[0] ? shifts[0] : ( num < AUTO_SETTINGS.autoIndent[0] ? shifts[0] +(LAYOUT_SETTINGS.autoLocation_restoreIndent ? AUTO_SETTINGS.autoIndent[0]-num : 0) : 0 );
							if( num )
								this.Location( colleagues[i], { location: [colleagues[i].location[0]+num, colleagues[i].location[1]] } );
							}
						else
							colleagues[i].location = [colleagues[i].location[0]+shifts[0], colleagues[i].location[1]];
						}
					}
				}
			if( shifts[1] ){ // по высоте
				for( var i = 0; i < colleagues.length; i++ ){
					if( colleagues[i] != obj && colleagues[i].location[1] >= objOldBounds[3] && !(colleagues[i].bounds[2] < objOldBounds[0] || colleagues[i].bounds[0] > objOldBounds[2]) ){
						if( LAYOUT_SETTINGS.autoLocationWithinIndent ){
							num = colleagues[i].location[1]-objOldBounds[3];// расстояние м-ду объектами
							num = num == AUTO_SETTINGS.autoIndent[1] ? shifts[1] : ( num < AUTO_SETTINGS.autoIndent[1] ? shifts[1] +(LAYOUT_SETTINGS.autoLocation_restoreIndent ? AUTO_SETTINGS.autoIndent[1]-num : 0) : 0 );
							if( num )
								this.Location( colleagues[i], { location: [colleagues[i].location[0], colleagues[i].location[1]+num] } );
							}
						else
							colleagues[i].location = [colleagues[i].location[0], colleagues[i].location[1]+shifts[1]];
						}
					}
				}
			},
		getAutoSize: function( obj ){
			//script.consol( 'getAutoSize(): ', obj );
			try{
			if( this.isWindow(obj) )
				return SETTINGS.projectSize;
			if( !SUPPORT[obj.type]['size'] )
				return undefined;
			var size = [AUTO_SETTINGS.autoSize[obj.type][0], AUTO_SETTINGS.autoSize[obj.type][1]];
			if( size[0] == 'fill' ){
				var parent = obj.parent;
				var thisIndentW = ( parent.type == 'group' && !this.isWindow(parent) ) ? 0 : AUTO_SETTINGS.autoIndent[0];//отступ по горизонтали в group нулевой
				var addForPanel = parent.type == 'panel' ? 5 : 0;//поправка для panel для отступа справа
				size[0] = ( parent.bounds[2] - parent.bounds[0] ) - ( thisIndentW * 2 ) - addForPanel;
				}
			return size;
			}catch(err){ script.alertError(err); return [70, 22];}
			},
		Visible_init: function(){
			//script.consol( 'Visible_init()' );
			win.obj.Global.Visible.onClick = function(){
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( obj )
					obj.visible = this.value;
				}
			},
		Visible: function( obj, args ){
			//script.consol( 'Visible(): ', obj, ', args: ', args );
			// меняем
			if( !obj.visible )
				obj.visible = obj.visible === false ? false : true;
			if( args )
				obj.visible = args.visible === false ? false : true;
			// показываем настройки
			if( this.getSelectedObject() == obj && win.obj.Global.visible ){
				try{
				this.selectingStatus = true;
				win.obj.Global.Visible.enabled = !this.isWindow( obj );
				win.obj.Global.Visible.value = obj.visible;
				}catch(err){ script.alertError(err); return; }
				finally{ this.selectingStatus = false }
				}
			},
		HelpTip_init: function(){
			//script.consol( 'HelpTip_init()' );
			win.obj.Global.HelpTip.onChange = function(){
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( obj )
					obj.helpTip = this.text;
				}
			},
		HelpTip: function( obj, args ){
			//script.consol( 'HelpTip(): ', obj, ', args: ', args );
			// меняем
			if( args && args.hasOwnProperty('helpTip') )
				obj.helpTip = args.helpTip;
			// показываем настройки
			if( this.getSelectedObject() == obj && win.obj.Global.visible ){
				try{
				this.selectingStatus = true;
				win.obj.Global.HelpTip.text = obj.helpTip ? obj.helpTip : '';
				}catch(err){ script.alertError(err); return; }
				finally{ this.selectingStatus = false }
				}
			},
		// ЛОКАЛЬНЫЕ
		Text_init: function(){
			//script.consol( 'Text_init()' );
			var winText = win.obj.Global.Text;
			winText.Text.onChange = function(){
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( obj ){
					uiBuilderLibrary.Text( obj, {text: this.text} );
	//				winText.Text.enabled = !winText.Text.enabled; winText.Text.enabled = !winText.Text.enabled; // для обновления прорисовки выделения объекта после смены текста
					}
				}
			winText.STRING.onClick = winText.Var.onClick = function(){
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( obj )
					obj.textVar = (this.properties.name == 'Var');
				}
			// JUSTIFY
			winText.Justify = winText.add( "group", [185,35,207,107], undefined );
			var Justify = winText.Justify;
			var leftIcon = script.getInDesignIcon( 'Text/(Paragraph Panel Resources)/idrc_PNGA/10381.idrc' );
			var centerIcon = script.getInDesignIcon( 'Text/(Paragraph Panel Resources)/idrc_PNGA/10382.idrc' );
			var rightIcon = script.getInDesignIcon( 'Text/(Paragraph Panel Resources)/idrc_PNGA/10383.idrc' );
			if( rightIcon && centerIcon && leftIcon ){
				Justify.Left = Justify.add( "iconbutton", [0,0,22,22], leftIcon, {name: 'left'} );
				Justify.Center = Justify.add( "iconbutton", [0,25,22,47], centerIcon, {name: 'center'} );
				Justify.Right = Justify.add( "iconbutton", [0,50,22,72], rightIcon, {name: 'right'} );
				}
			else{
				if( File.fs == 'Windows' ){
					Justify.Left = Justify.add( "button", [0,0,22,22], '>', {name: 'left', } );
					Justify.Center = Justify.add( "button", [0,25,22,47], '|', {name: 'center', } );
					Justify.Right = Justify.add( "button", [0,50,22,72], '<', {name: 'right', } );
					}
				else{
					Justify.Left = Justify.add( "iconbutton", [0,0,22,22], undefined, {name: 'left', style: 'button', toggle: true } );
					Justify.Center = Justify.add( "iconbutton", [0,25,22,47], undefined, {name: 'center', } );
					Justify.Right = Justify.add( "iconbutton", [0,50,22,72], undefined, {name: 'right', } );
					script.getCustomDraw (Justify.Left, {text:'>'});
					script.getCustomDraw (Justify.Center, {text:'|'});
					script.getCustomDraw (Justify.Right, {text:'<'});
					}
				}
			Justify.Left.onClick = Justify.Center.onClick = Justify.Right.onClick = function(){
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( !obj )
					return;
				Justify.Left.enabled = Justify.Center.enabled = Justify.Right.enabled = true;
				this.enabled = false;
				obj.justify = this.properties.name.toString();
				}
			},
		Text: function( obj, args ){
			//script.consol( 'Text(): ', obj, ', args: ', args );
			// меняем
			if( (SUPPORT[obj.type]['text'] || this.isWindow(obj)) && args  ){
				if( args.hasOwnProperty('text') ) obj.text = args.text;
				if( args.hasOwnProperty('textVar') ) obj.textVar = args.textVar;
				if( args.justify ) obj.justify = args.justify;
	//			if( !obj.text && (obj.type == 'checkbox' || obj.type == 'radiobutton') ) // для корректной работы выделения
	//				obj.text = obj.Var;
				}
			// показываем настройки
			if( this.getSelectedObject() != obj || !win.obj.Global.visible )
				return;
			try{
				this.selectingStatus = true;
				var winText = win.obj.Global.Text;
				if( SUPPORT[obj.type]['text'] || this.isWindow(obj) ){
					winText.visible = true;
					winText.Text.text = obj.text ? obj.text : '';
					obj.textVar ? winText.Var.value = true : winText.STRING.value = true;
					if( SUPPORT[obj.type]['justify'] ){
						winText.Justify.Left.enabled = winText.Justify.Center.enabled = winText.Justify.Right.enabled = true;
						switch( obj.justify ){
							case  'center':
								winText.Justify.Center.enabled = false;
							break;
							case  'right':
								winText.Justify.Right.enabled = false;
							break;
							default:
								winText.Justify.Left.enabled = false;
							}
						winText.Justify.visible = true;
						}
					else
						winText.Justify.visible = false;
					}
				else
					winText.visible = false;
			}catch(err){ script.alertError(err); return; }
			finally{ this.selectingStatus = false }
			},
		Items_init: function(){
			//script.consol( 'Items_init()' );
			var winItems = win.obj.Local.Items;
			winItems.ItemsH.onChanging = function(){
				this.text = this.text.replace(/[^\d]/g,'');
				}
			winItems.ItemsH.onChange = function(){
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( obj )
					uiBuilderLibrary.Items( obj, {itemSize: [undefined, +this.text]} );
				}
			winItems.Var.onClick = function(){
				winItems.editVar.enabled = true;
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( obj )
					obj.itemsArr = false;
				}
			winItems.editVar.onChange = function(){
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( obj ){
					this.text = obj.ItemsVar = CORRECTS.varCorrect(this.text);
					}
				}
			winItems.Arr.onClick = function(){
				winItems.editVar.enabled = false;
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( obj )
					obj.itemsArr = true;
				}
			winItems.editArr.onClick = function(){
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( !obj )
					return;
				var editItems = new Window('dialog', 'Edit items');
				editItems.orientation = 'row';
				editItems.alignChildren = 'fill';
				editItems.margins = editItems.spacing = 5;
				with(editItems){
					editItems.lBox = add('listbox');
					editItems.lBox.preferredSize = [300,200];
					editItems.Grp = add('group');
					editItems.Grp.orientation = 'column';
					with(editItems.Grp){
						editItems.Grp.Add = add('button', undefined, 'Add');
						editItems.Grp.Del = add('button', undefined, 'Delete');
						editItems.Grp.Rename = add('button', undefined, 'Rename');
						editItems.Grp.Up = add('button', undefined, '^', {name:-1});
						editItems.Grp.Down = add('button', undefined, 'V', {name:1});
						editItems.Grp.sText = add('statictext');
						editItems.Grp.Cancel = add('button', undefined, 'Cancel');
						editItems.Grp.OK = add('button', undefined, 'OK');
						}
					};
				var LIST = editItems.lBox;
				editItems.Grp.OK.enabled = false;
				if( obj.children.length )
					for( var i = 0; i <  obj.children.length; i++ )
						LIST.add('item', obj.children[i].text);
				editItems.Grp.Add.onClick = function(){
					var name = prompt( 'Name:', '', 'New item' );
					if( name ){
						LIST.selection = LIST.add('item', name);
						editItems.Grp.OK.enabled = true;
						}
					}
				editItems.Grp.Del.onClick = function(){
					if( !LIST.selection )
						return;
					var index = LIST.selection.index;
					LIST.remove( LIST.selection );
					if( index > 0 )
						LIST.selection = index - 1;
					else if( LIST.children.length >= index )
						LIST.selection = index;
					editItems.Grp.OK.enabled = true;
					}
				editItems.Grp.Rename.onClick = function(){
					if( !LIST.selection )
						return;
					var name = prompt( 'Name:', LIST.selection.text, 'Edit item' );
					if( name ){
						LIST.selection.text = name;
						editItems.Grp.OK.enabled = true;
						}
					}
				editItems.Grp.Up.onClick = editItems.Grp.Down.onClick = function(){
					try{
					if(LIST.selection == null || !LIST.items.length )
						return;
					if(this.properties.name == -1 && LIST.selection.index == 0)
						return;
					if(this.properties.name == 1 && LIST.selection.index == LIST.items.length-1)
						return;
					var item = LIST.selection;
					var nextItem = LIST.items[LIST.selection.index + this.properties.name];
					var text =item.text;
					LIST.selection.text = nextItem.text;
					nextItem.text = text;
					LIST.selection = nextItem;
					editItems.Grp.OK.enabled = true;
					}catch(err){script.alertError(err);}
					}
				editItems.Grp.Cancel.onClick = function(){
					this.window.close();
					}
				editItems.Grp.OK.onClick = function(){
					uiBuilderLibrary.Items( obj, {items: uiBuilderLibrary.getItems( {args: LIST, forType: '' , forSave: false} )} );
					this.window.close();
					}
				
				editItems.center();
				editItems.show();
				}
			},
		Items: function( obj, args ){
			//script.consol( 'Items(): ', obj, ', args: ', args );
			// меняем
			if( args && SUPPORT[obj.type]['items'] ){
				obj.ItemsVar = args.ItemsVar ? args.ItemsVar : '';
				if( args.hasOwnProperty('items') && args.items.constructor == Array ){ // реагирует только на массив, остальные типы игнорируются
					if( obj.type == 'dropdownlist' && this.arrayContainsSeparator(args.items)  )
						return this.setObject( obj, {items: args.items} );
					if( obj.children.length )
						obj.removeAll();
					for( var i = 0; i < args.items.length; i++ )
						obj.add(args.items[i].type, args.items[i].text);
					}
				if( args.hasOwnProperty('itemSize') && args.itemSize.constructor == Array ){
					if( !args.itemSize[1] && this.getItemSize(obj) )
						obj.itemSize = SETTINGS.Default.itemSize;
					else if( args.itemSize[1] != obj.itemSize[1] )
						obj.itemSize = [undefined, args.itemSize[1]];
					}
				}
			// показываем настройки
			if( this.getSelectedObject() == obj && win.obj.Local.visible ){
				try{
				this.selectingStatus = true;
				win.obj.Local.Items.visible = SUPPORT[obj.type]['items'] ? true : false;
				if( SUPPORT[obj.type]['items'] ){
					win.obj.Local.Items.Var.value = win.obj.Local.Items.editVar.enabled = obj.itemsArr ? false : true;
					win.obj.Local.Items.editVar.text = obj.ItemsVar ? obj.ItemsVar : '';
					win.obj.Local.Items.Arr.value = obj.itemsArr ? true : false;
					win.obj.Local.Items.ItemsH.text = this.getItemSize( obj ) ? obj.itemSize[1] : '';
					}
				}catch(err){ script.alertError(err); return; }
				finally{ this.selectingStatus = false }
				}
			},
		getItemSize: function( args ){ // возвращает Array или false, если не подерживает или совпадает с дефолтовыми
			try{
			if( args.itemSize && args.itemSize[1] ){
				if( args.items.length )
					return args.itemSize[1] != SETTINGS.Default.itemSize[1] ? [undefined, args.itemSize[1]] : false;
				else
					return args.itemSize[1] != SETTINGS.Default.itemSize_EmptyList[1] ? [undefined, args.itemSize[1]] : false;
				}
			}catch(err){ return false }
			},
		arrayContainsSeparator: function( arr ){ // для dropdownlist - проверяет содержит ли массив сепаратор
			try{
			for( var i = 0; i < arr.length; i++ )
				if( arr[i].text == '-' )
					return true;
			return false;
			}catch(err){ return false }
			},
		// args = uiObject или объект свойств, возвращаеет массив или false(если св-во не поддерживается)
		// forType = dropdownlist / listbox / treeview (Optional)
		getItems: function( props ){ // props = {args: args, forType: Bool, forSave: Bool, forOut: Bool}
			//script.consol( 'getItems(): ', props );
			if( !props ||! props.args )
				return false;
			var args = props.args || '';
			var forType = props.forType || '';
			var forSave = props.forSave;
			var forOut = props.forOut;
			return getItemsArray( args );
			
			function getItemsArray( obj ){
				try{
				var arr = [];
				if( obj.items && obj.items.length ){
					arr.items = [];
					for( var i = 0; i <obj.items.length; i++ ){
						arr[i] = {type: (!forType || forType=='treeview') ? obj.items[i].type : 'item', text: obj.items[i].text};
						if( obj.items[i].image && obj.items[i].image != script.images.zero ){
							arr[i].image = {pathname: obj.items[i].image.pathname};
	//						arr[i].image.pathname = obj.items[i].image.pathname;
							}
						if( obj.items[i].subItems && obj.items[i].subItems.length && (!forType || forType=='listbox')  ){
							arr[i].subItems = [];
							for( var j = 0; j <obj.items[i].subItems.length; j++ ){
								arr[i].subItems[j] = {text: obj.items[i].subItems[j].text}
								if( obj.items[i].subItems[j].image && obj.items[i].subItems[j].image != script.images.zero ){
									arr[i].subItems[j].image = { pathname: this.getLink({obj: obj, Value: obj.items[i].subItems[j].image, getFullLink: forSave, forOut: forOut}) };
	//								arr[i].subItems[j].image.pathname = obj.items[i].subItems[j].image.pathname;
									}
								}
							}
						if( obj.items[i].items && obj.items[i].items.length && args.type == 'treeview' && (!forType || forType=='treeview') )
							arr[i].items = getItemsArray( obj.items[i] );
						}
					}
				return arr;
				}catch(err){script.alertError(err);}
				}
			},
		Font_init: function(){
			//script.consol( 'Font_init()' );
			var winFont = win.obj.Local.Font;
			winFont.Name.onChange = winFont.Style.onChange = winFont.Size.onChange = function(){
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( !obj || this.selection==null ){
					if( !uiBuilderLibrary.getSelectedObject() )
						this.selection = null;
					return;0
					}
				var args = {graphics:{font:{}}};
				args.graphics.font[this.properties.name] = this.selection.text;
				uiBuilderLibrary.Font( obj, args );
				}
			},
		Font: function( obj, args ){
			//script.consol( 'Font(): ', obj, ', args: ', args );
			// меняем
			if( SUPPORT[obj.type]['font'] && args && args.graphics && args.graphics.font ){
				if(obj.type=='panel'){//обнуляем text перед сменой формата (для panel)
					var text = obj.text || '';
					obj.text='';
					}
				if( args.graphics.font instanceof ScriptUIFont )
					obj.graphics.font = args.graphics.font;
				else{
					var font = args.graphics.font;
					try{
						obj.graphics.font = ScriptUI.newFont( (font.name ? font.name : obj.graphics.font.name), (font.style ? font.style : obj.graphics.font.style), (font.size ? +font.size : obj.graphics.font.size) );
						if( font.name && !win.obj.Local.Font.Name.find(font.name) ){
							win.obj.Local.Font.Name.add('item', font.name);
							APP_SETTINGS.fonts.push( font.name );
							SETTINGS.saveAppSettings = true;
							}
						}catch(err){
							alert( 'It was not possible to apply font customisation\r('+font.name+','+font.style+','+font.size+')' );//установки шрифта применить не удалось.
							}
					}
				if(obj.type=='panel')
					obj.text = text;
				}
			// показываем настройки
			if( this.getSelectedObject() != obj || !win.obj.Local.visible )
				return;
			try{
				this.selectingStatus = true;
				var winFont = win.obj.Local.Font;
				if( SUPPORT[obj.type]['font'] ){
					winFont.Name.selection = winFont.Style.selection = winFont.Size.selection = null;
					var font = this.getNoDefaultFontProperties( obj );
					if( font ){
						if( font.name )
							winFont.Name.selection = winFont.Name.find( font.name );
						if( font.style )
							winFont.Style.selection = winFont.Style.find( font.style );
						if( font.size )
							winFont.Size.selection = winFont.Size.find( font.size );
						}
					winFont.visible = true;
					}
				else
					winFont.visible = false;
			}catch(err){ script.alertError(err); return; }
			finally{ this.selectingStatus = false }
			},
		getNoDefaultFontProperties: function( obj ){ // возвращает только недефолтовые свойства шрифта
			//script.consol( 'getNoDefaultFontProperties(): ', obj );
			var res = {};
			if( !obj.graphics || !obj.graphics.font )
				return;
			var flag;
			var font = obj.graphics.font;
			if( font.name && font.name != SETTINGS.Default.graphics.font.name ){
				res.name = font.name;
				flag = true;
				}
			if( font.style && font.style != SETTINGS.Default.graphics.font.style ){
				res.style = font.style;
				flag = true;
				}
			if( font.size && font.size != SETTINGS.Default.graphics.font.size ){
				res.size = font.size;
				flag = true;
				}
			return flag ? res : false;
			},
		Image_init: function(){
			//script.consol( 'Image_init()' );
			var imageOpen = function( obj ){ // imageType = normal, disabled, pressed, rollover
				if(obj.type=='iconbutton')
					return File.openDialog('Image', "Files:*.png;*.idrc");
				else
					return File.openDialog('Image', "Files:*.png;*.jpg;*.idrc");
				}
			var winImage = win.obj.Local.Image;
			winImage.Image.onClick = function(){
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( !obj )
					return;
				var image = imageOpen( obj );
				if( image )
					uiBuilderLibrary.Image( obj, {image: {pathname: image.fsName}} );
				}
			winImage.Del.onClick = function(){
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( !obj )
					return;
				uiBuilderLibrary.Image( obj, {image: {pathname: ''}} );
				}
			winImage.Add.onClick = function(){
				try{
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( !obj /*|| !obj.image || File(obj.image.pathname) == script.images.zero */)
					return;
				if( !obj.NextImages )
					obj.NextImages = {};
				var links = {};
				if(File.fs=='Windows'){
					var addImages=new Window('dialog','Add images',[0,0,600,125]);
					with(addImages){
						var normalAdd=add('statictext',[5,8,70,28],'normal');
						links['normal'] = add('edittext',[80,5,595,30],'',{readonly:true});
						var disabledAdd=add('button',[5,35,70,60],'disabled');
						links['disabled']=add('edittext',[80,35,560,60], '', {readonly:true});
						var disabledDel=add('button',[570,35,595,60],'-', {name:'disabled'});
							disabledDel.helpTip='clear disabled';
						var pressedAdd=add('button',[5,65,70,90],'pressed');
						links['pressed']=add('edittext',[80,65,560,90], '', {readonly:true});
						var pressedDel=add('button',[570,65,595,90],'-', {name:'pressed'});
							pressedDel.helpTip='clear pressed';
						var rolloverAdd=add('button',[5,95,70,120],'rollover');
						links['rollover']=add('edittext',[80,95,560,120], '', {readonly:true});
						var rolloverDel=add('button',[570,95,595,120],'-', {name:'rollover'});
							rolloverDel.helpTip='clear rollover';
						}
					}
				else{
					var addImages = new Window("dialog", "Add images", [0,0,600,120]);
					with(addImages){
						var normalAdd = add("statictext", [5,8,87,38], "normal");
						links['normal'] = add("edittext", [95,5,595,25], '', {readonly: true});
						var disabledAdd = add("button", [5,35,87,55], "disabled");
						links['disabled'] = add("edittext", [95,35,570,55], '', {readonly: true});
						var disabledDel = add("iconbutton", [575,35,595,55], undefined, {name:'disabled'});
						disabledDel.helpTip = "clear disabled";
						var item = add("statictext", [584,40,654,60], "-");
						var pressedAdd = add("button", [5,65,87,85], "pressed");
						links['pressed'] = add("edittext", [95,65,570,85], '', {readonly: true});
						var pressedDel = add("iconbutton", [575,65,595,85], undefined, {name:'pressed'});
						pressedDel.helpTip = "clear pressed";
						item = add("statictext", [584,70,654,90], "-");
						var rolloverAdd = add("button", [5,95,87,115], "rollover");
						links['pressed'] = add("edittext", [95,95,570,115], '', {readonly: true});
						var rolloverDel = add("iconbutton", [575,95,595,115], undefined, {name:'rollover'});
						rolloverDel.helpTip = "clear rollover";
						item = add("statictext", [584,100,654,120], "-");
						}
					}
				normalAdd.justify = 'center';
				links['normal'].text = uiBuilderLibrary.containsImage(obj) ? uiBuilderLibrary.getLink({obj: obj, Value: obj.image, getFullLink: false}) : '';
				
				if( obj.NextImages.disabled ){
					var _link = uiBuilderLibrary.getLink({obj: obj, Value: obj.NextImages.disabled, getFullLink: false});
					links['disabled'].text = File(obj.NextImages.disabled).exists ? _link : script.localize('File not found')+': '+_link;
					} else links['disabled'].text = '';
				if( obj.type == 'image' ){
					pressedAdd.enabled = links['pressed'].enabled = pressedDel.enabled = false;
					rolloverAdd.enabled = links['rollover'].enabled = rolloverDel.enabled = false;
					}
				else{
					if( obj.NextImages.pressed ){
						var _link = uiBuilderLibrary.getLink({obj: obj, Value: obj.NextImages.pressed, getFullLink: false});
						links['pressed'].text = File(obj.NextImages.pressed).exists ? _link : script.localize('File not found')+': '+_link;
						} else links['pressed'].text = '';
					if( obj.NextImages.rollover ){
						var _link = uiBuilderLibrary.getLink({obj: obj, Value: obj.NextImages.rollover, getFullLink: false});
						links['rollover'].text = File(obj.NextImages.pressed).exists ? _link : script.localize('File not found')+': '+_link;
						} else links['rollover'].text = '';
					}
				disabledAdd.onClick = pressedAdd.onClick = rolloverAdd.onClick = function(){
					var image = imageOpen( obj );
					if( image ){
						var args = {NextImages:{}};
						args.NextImages[this.text] = image.absoluteURI;
						uiBuilderLibrary.Image( obj, args );
						links[this.text].text = uiBuilderLibrary.getLink({obj: obj, Value: obj.NextImages[this.text], getFullLink: false});
						}
					}
				disabledDel.onClick = pressedDel.onClick = rolloverDel.onClick = function(){
					if( obj.NextImages[this.properties.name] ){
						var args = {NextImages:{}};
						args.NextImages[this.properties.name] ='';
						uiBuilderLibrary.Image( obj, args );
						links[this.properties.name].text = uiBuilderLibrary.getLink({obj: obj, Value: obj.NextImages[this.properties.name], getFullLink: false});
						}
					}
				addImages.center();
				addImages.show();
				}catch(err){script.alertError(err);}
				}
			},
		Image: function( obj, args ){
			try{
			//script.consol( 'Image(): ', obj, ', args: ', args );
			// меняем
			if( SUPPORT[obj.type]['image'] && args ){
				var normal = args.image && args.image.hasOwnProperty('pathname') ? args.image.pathname : (obj.image && obj.image.pathname ? obj.image.pathname : '');
				if( !obj.NextImages ) obj.NextImages = {};
				if( args.NextImages ){
					if( args.NextImages.hasOwnProperty('disabled') ) obj.NextImages.disabled = args.NextImages.disabled;
					if( args.NextImages.hasOwnProperty('pressed') ) obj.NextImages.pressed = args.NextImages.pressed;
					if( args.NextImages.hasOwnProperty('rollover') ) obj.NextImages.rollover = args.NextImages.rollover;
					}
				if( normal ){
					if( !File(normal).exists )
						alert( script.localize('File not found') + ':\r' + normal, 'Document: '+obj.project.projectsListItem.text );
					else
						obj.image = ScriptUI.newImage( 
							normal,
							obj.NextImages.disabled && File(obj.NextImages.disabled).exists ? obj.NextImages.disabled : undefined,
							obj.NextImages.pressed && File(obj.NextImages.pressed).exists ? obj.NextImages.pressed : undefined,
							obj.NextImages.rollover && File(obj.NextImages.rollover).exists ? obj.NextImages.rollover : undefined
							);
					}
				else if( this.containsImage(obj) ) // удаляем текущий
					obj.image = script.images.zero;
				}
			}catch(err){ script.alertError(err); return; }
			// показываем настройки
			if( this.getSelectedObject() == obj && win.obj.Local.visible ){
				var winImage = win.obj.Local.Image;
				try{
				this.selectingStatus = true;
				if( SUPPORT[obj.type]['image'] ){
					winImage.visible = true;
					if( this.containsImage(obj) ){
						winImage.Link.text = this.getLink({obj: obj, Value: obj.image, getFullLink: false});
						winImage.Add.enabled = winImage.Del.enabled = true;
						}
					else{
						winImage.Link.text = '';
						winImage.Add.enabled = winImage.Del.enabled = false;
						}
					}
				else
					winImage.visible = false;
				}catch(err){ script.alertError(err); return; }
				finally{ this.selectingStatus = false }
				}
			},
		containsImage: function( obj ){
			try{
			return SUPPORT[obj.type]['image'] && obj.image && obj.image != script.images.zero && obj.image.pathname != script.images.zero.pathname ? true : false;
			}catch(err){script.alertError(err); return false}
			},
		ShortcutKey_init: function(){
			//script.consol( 'ShortcutKey_init()' );
			win.obj.Local.Key.Key.onChange = function(){
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( !obj )
					return;
				if( this.text == '' )
					return obj.ShortcutKey = '';
				else if( this.text != obj.ShortcutKey ){
					var oldKey = ( obj.ShortcutKey == undefined || !obj.ShortcutKey ) ? '' : obj.ShortcutKey.toString();//запоминаем старый Key
					try{
						obj.shortcutKey = this.text;
						obj.ShortcutKey = this.text = obj.shortcutKey;
						obj.shortcutKey = " ";
						} catch (err) {
							alert('Value of shortcutKey incorrectly. Value is not installed');//Значение shortcutKey некорректно. Значение не установлено
							return this.text = oldKey;//возвращаем исходное
							}
					}
				}
			win.obj.Local.Key.Keys.onChange = function(){
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( !obj ){
					this.selection = null;
					return;
					}
				win.obj.Local.Key.Key.text=this.selection.text.replace(/ [^ ]+$/,'');
				this.selection=null;
				win.obj.Local.Key.Key.onChange();
				}
			},
		ShortcutKey: function( obj, args ){
			//script.consol( 'ShortcutKey(): ', obj, ', args: ', args );
			// меняем
			if( SUPPORT[obj.type]['ShortcutKey'] && args && args.hasOwnProperty('ShortcutKey') )
				obj.ShortcutKey = args.ShortcutKey;
			// показываем настройки
			if( this.getSelectedObject() == obj && win.obj.Local.visible ){
				try{
				this.selectingStatus = true;
				if( !SUPPORT[obj.type]['ShortcutKey'] ){
					win.obj.Local.Key.visible = false;
					win.obj.Local.Key.Key.text = '';
					return;
					}
				win.obj.Local.Key.visible = true;
				win.obj.Local.Key.Key.text = obj.ShortcutKey ? obj.ShortcutKey : '';
				}catch(err){ script.alertError(err); return; }
				finally{ this.selectingStatus = false }
				}
			},
		GroupLocation_init: function(){
			//script.consol( 'GroupLocation_init()' );
			var moveChildren = win.obj.Controls.moveChildren;
			moveChildren.W.onChanging = moveChildren.H.onChanging = CORRECTS.dataCorrectEnter_forInterface;
			moveChildren.W.onChange =
			moveChildren.Wround.onClick =
			moveChildren.H.onChange =
			moveChildren.Hround.onClick =
			moveChildren.Wminus.onClick =
			moveChildren.Wplus.onClick =
			moveChildren.Hminus.onClick =
			moveChildren.Hplus.onClick = function(){
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( !obj )
					return;
				var location;
				switch( this.properties.name ){
					case 'W':
						location = [
							moveChildren.W.text ? +moveChildren.W.text : 0, 
							+moveChildren.H.text
							];
					break;
					case 'Wplus':
						location = [+moveChildren.W.text+SETTINGS.getStep(), +moveChildren.H.text];
					break;
					case 'Wminus':
						location = [+moveChildren.W.text, +moveChildren.H.text];
						location[0] = SETTINGS.getStep() > location[0] ? 0 : location[0] - SETTINGS.getStep();
					break;
					case 'Wround':
						location = [CORRECTS.dataRound(moveChildren.W.text), +moveChildren.H.text];
					break;
					case 'H':
						if( !moveChildren.H.text ) moveChildren.H.text = 0;
						location = [
							+moveChildren.W.text, 
							moveChildren.H.text ? +moveChildren.H.text : 0
							];
					break;
					case 'Hplus':
						location = [+moveChildren.W.text, +moveChildren.H.text+SETTINGS.getStep()];
					break;
					case 'Hminus':
						location = [+moveChildren.W.text, +moveChildren.H.text];
						location[1] = SETTINGS.getStep() > location[1] ? 0 : location[1] - SETTINGS.getStep();
					break;
					case 'Hround':
						location = [+moveChildren.W.text, CORRECTS.dataRound(moveChildren.H.text)];
					break;
					case 'onlyVisible':
					case 'accuracy':
						return;// прерываем
					break;
					}
				uiBuilderLibrary.GroupLocation( obj, location );
				}
			moveChildren.onlyVisible.onClick = function(){
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( obj )
					uiBuilderLibrary.GroupLocation( obj );// обновляем
				}
			},
		GroupLocation: function( obj, location ){// только управляет диалогом
			//script.consol( 'GroupLocation(): ', obj );
			// показываем настройки
			if( this.getSelectedObject() != obj )
				return;
			var moveChildren = win.obj.Controls.moveChildren;
			if( this.isContainer(obj) && obj.children.length ){
				moveChildren.enabled = true;
				var groupBounds = this.groupBounds( obj, moveChildren.onlyVisible.value, location );
				moveChildren.W.text = groupBounds[0];
				moveChildren.H.text = groupBounds[1];
				}
			else{
				moveChildren.W.text = moveChildren.H.text = '';
				moveChildren.enabled = false;
				}
			},
		groupBounds: function( obj, onlyVisible, location ){ // возвращается групповой bounds или false. Если указан location [num,num] - производится смещение в новую позицию
			//script.consol( 'groupBounds(): ', obj, ', location: ', location );
			if( !SUPPORT[obj.type]['children'] )
				return false;
			try{
			var children = obj.children;
			var groupBounds = [0,0,0,0];
			var flag = false;
			// вычисляем groupBounds
			for( var i=0; i<children.length; i++ ){
				if( (onlyVisible && !children[i].visible) || !children[i].bounds )
					continue;
				if( !flag ){
					groupBounds[0] = children[i].bounds[0];
					groupBounds[1] = children[i].bounds[1];
					groupBounds[2] = children[i].bounds[2];
					groupBounds[3] = children[i].bounds[3];
					}
				else{
					groupBounds[0] = groupBounds[0] < children[i].bounds[0] ? groupBounds[0] : children[i].bounds[0] ;
					groupBounds[1] = groupBounds[1] < children[i].bounds[1] ? groupBounds[1] : children[i].bounds[1] ;
					groupBounds[2] = groupBounds[2] > children[i].bounds[2] ? groupBounds[2] : children[i].bounds[2] ;
					groupBounds[3] = groupBounds[3] > children[i].bounds[3] ? groupBounds[3] : children[i].bounds[3] ;
					}
				flag = true;
				}
			if( location ){
				try{ var setShifts = [location[0]-groupBounds[0], location[1]-groupBounds[1]]; }catch(err){script.alertError(err);return groupBounds}
				if( setShifts[0] == 0 && setShifts[1] == 0 )
					return groupBounds;
				for( var  i = 0; i < children.length; i++ ){
					if( onlyVisible && !children[i].visible )
						continue;
					children[i].location = [
						children[i].location[0] + setShifts[0],
						children[i].location[1] + setShifts[1]
						];
					}
	//			if( LAYOUT_SETTINGS.autoFitToContent || this.isWindow(obj) )
	//			if( LAYOUT_SETTINGS.autoFitToContent )
				if( LAYOUT_SETTINGS.autoFitToContent || (this.isWindow(obj) && LAYOUT_SETTINGS.autofitWindowProject) )
					this.fitToContent( obj, [true, true] );
				groupBounds = [
					groupBounds[0] + setShifts[0],
					groupBounds[1] + setShifts[1],
					groupBounds[2] + setShifts[0],
					groupBounds[3] + setShifts[1],
					];
				}
			return groupBounds;
			}catch(err){script.alertError(err); return false}
			},
		getPaddingForContainer: function( obj ){
			if( !this.isContainer(obj) )
				return;
			if( this.isWindow(obj) )
				return [AUTO_SETTINGS.autoIndent[0], AUTO_SETTINGS.autoIndent[1], AUTO_SETTINGS.autoIndent[0], AUTO_SETTINGS.autoIndent[1]];
			else if( obj.type == 'group' )
				return [0,0,0,0];
			else if( obj.type == 'panel' )
				return [AUTO_SETTINGS.autoIndent[0], AUTO_SETTINGS.autoIndent[1]+(obj.text?5:0), AUTO_SETTINGS.autoIndent[0]+5, AUTO_SETTINGS.autoIndent[1]+5+(obj.text?5:0)];
			},
		fitToContent: function( obj, directions ){//directions: [true, true] =  [ по горизонтали,  по вертикали ]
			//script.consol( 'fitToContent(): ', obj, ', directions: ', directions );
			try{
			if( !directions || !SUPPORT[obj.type]['children'] || !obj.children.length || (!directions[0]&&!directions[1]) )
				return;
			var groupBounds = this.groupBounds( obj );
			var padding = this.getPaddingForContainer( obj );
			var newSize = [groupBounds[2]+padding[2], groupBounds[3]+padding[3]];
			var flag;
			if( directions[0] && obj.size[0] != newSize[0] )
				flag = true;
			else newSize[0] = obj.size[0];
			if( directions[1] && obj.size[1] != newSize[1] )
				flag = true;
			else newSize[1] = obj.size[1];
			if( flag  )
				this.Size( obj, {size: newSize}, true );
			}catch(err){script.alertError(err);}
			},
		fill: function( obj, direction ){//растянуть по ширине родителя (с учетом отступов), direction: 0=ширина / 1=высота
			try{
			if( !obj || this.isWindow(obj) )
				return;
			direction = direction ? 1 : 0;
			var padding = this.getPaddingForContainer( obj.parent );
			var parentSize = [obj.parent.size[0], obj.parent.size[1]];
			if( direction ){
				this.Location( obj, { location: [obj.location[0], padding[1]] } );
				this.Size( obj, { size: [obj.size[0], parentSize[1]-(padding[1]+padding[3])] } );
				}
			else{
				this.Location( obj, { location: [padding[0], obj.location[1]] } );
				this.Size( obj, { size: [parentSize[0]-(padding[0]+padding[2]), obj.size[1]] } );
				}
			obj.project.saved = false;
			}catch(err){script.alertError(err);}
			},
		Layout_init: function(){
			var LIB = this;
			var Layout = win.obj.Layout;
			
			Layout.sizeW.onChanging = 
			Layout.sizeH.onChanging = 
			Layout.Container.Margins.Left.onChanging = 
			Layout.Container.Margins.Top.onChanging = 
			Layout.Container.Margins.Bottom.onChanging = 
			Layout.Container.Margins.Right.onChanging = 
			Layout.Container.Spacing.onChanging = 
			Layout.Indent.Text.onChanging = 
			Layout.Characters.Text.onChanging =
			Layout.maxSizeW.onChanging =
			Layout.maxSizeH.onChanging =
			Layout.minSizeW.onChanging =
			Layout.minSizeH.onChanging = CORRECTS.dataCorrectEnter_forInterface;
			
			Layout.sizeW.onChange = Layout.sizeH.onChange = function(){
				var obj = LIB.getSelectedObject_forInterface();
				if( !obj )
					return;
				if( !obj.Layout )
					obj.Layout = {};
				if( !obj.Layout.preferredSize )
					obj.Layout.preferredSize = {};
				if( +this.text == 0 )
					this.text = '';
				obj.Layout.preferredSize.width = Layout.sizeW.text ? +Layout.sizeW.text : undefined;
				obj.Layout.preferredSize.height = Layout.sizeH.text ? +Layout.sizeH.text : undefined;
				}
			Layout.Alignment.W.onChange = Layout.Alignment.H.onChange = function(){
				var obj = LIB.getSelectedObject_forInterface();
				if( !obj )
					return;
				if( !obj.Layout )
					obj.Layout = {};
				if( !this.selection.index )
					this.selection = null;
				if( !Layout.Alignment.W.selection && !Layout.Alignment.H.selection )
					obj.Layout.alignment = undefined;
				else{
					if( !obj.Layout.alignment )
						obj.Layout.alignment = [undefined, undefined];
					if( this.properties.name == 'W' ){
						obj.Layout.alignment[0] = Layout.Alignment.W.selection ? Layout.Alignment.W.selection.text : undefined;
						// обновляем
						obj.Layout.alignment = LIB.getAlignment( obj );
						if( !obj.Layout.alignment || !obj.Layout.alignment[0] ) Layout.Alignment.W.selection = null;
						}
					else{
						obj.Layout.alignment[1] = Layout.Alignment.H.selection ? Layout.Alignment.H.selection.text : undefined;
						// обновляем
						obj.Layout.alignment = LIB.getAlignment( obj );
						if( !obj.Layout.alignment || !obj.Layout.alignment[1] ) Layout.Alignment.H.selection = null;
						}
					}
				}
			
			Layout.tabbedPanel.onClick = function(){
				var obj = LIB.getSelectedObject_forInterface();
				if( !obj )
					return;
				if( !obj.Layout )
					obj.Layout = {};
				obj.Layout.TabbedPanel = Layout.Title.visible = this.value;
				Layout.Container.visible = !this.value;
				}
			Layout.Container.Orientation.Row.onClick = 
			Layout.Container.Orientation.Stack.onClick = 
			Layout.Container.Orientation.Column.onClick = function(){
				var obj = LIB.getSelectedObject_forInterface();
				if( !obj )
					return;
				if( !obj.Layout )
					obj.Layout = {};
				obj.Layout.orientation = this.properties.name;
				}
			Layout.Container.alignChildrenW.onChange = Layout.Container.alignChildrenH.onChange = function(){
				var obj = LIB.getSelectedObject_forInterface();
				if( !obj )
					return;
				if( !obj.Layout )
					obj.Layout = {};
				if( !this.selection.index )
					this.selection = null;
				if( !Layout.Container.alignChildrenW.selection && !Layout.Container.alignChildrenH.selection )
					obj.Layout.alignChildren = undefined;
				else{
					if( !obj.Layout.alignChildren )
						obj.Layout.alignChildren = [undefined, undefined];
					if( this.properties.name == 'W' ){
						obj.Layout.alignChildren[0] = Layout.Container.alignChildrenW.selection ? Layout.Container.alignChildrenW.selection.text : undefined;
						// обновляем
						obj.Layout.alignChildren = LIB.getAlignChildren( obj );
						if( !obj.Layout.alignChildren || !obj.Layout.alignChildren[0] ) Layout.Container.alignChildrenW.selection = null;
						}
					else{
						obj.Layout.alignChildren[1] = Layout.Container.alignChildrenH.selection ? Layout.Container.alignChildrenH.selection.text : undefined;
						// обновляем
						obj.Layout.alignChildren = LIB.getAlignChildren( obj );
						if( !obj.Layout.alignChildren || !obj.Layout.alignChildren[1] ) Layout.Container.alignChildrenH.selection = null;
						}
					}
				}
			var reMargins = false;
			Layout.Container.Margins.Left.onChange = function(){
				try{
				var obj = LIB.getSelectedObject_forInterface();
				if( !obj )
					return;
				if( !obj.Layout )
					obj.Layout = {};
				if( !obj.Layout.margins )
					obj.Layout.margins = [false,false,false,false];
				
				if(reMargins)
					return;
				obj.Layout.margins[0] = +this.text;
				if(this.text == ''){
					reMargins = true;
					Layout.Container.Margins.Top.text = Layout.Container.Margins.Bottom.text = Layout.Container.Margins.Right.text = '';
					reMargins = false;
					obj.Layout.margins = undefined;
					}
				else if( obj.Layout.margins[1] === obj.Layout.margins[0] && obj.Layout.margins[2] === obj.Layout.margins[0] && obj.Layout.margins[3] === obj.Layout.margins[0] ){
					Layout.Container.Margins.Top.text = Layout.Container.Margins.Bottom.text = Layout.Container.Margins.Right.text = '';
					obj.Layout.margins[1] = obj.Layout.margins[2] = obj.Layout.margins[3] = false;
					}
				}catch(err){ script.alertError( err ); reMargins = false; }
				}
			Layout.Container.Margins.Top.onChange = Layout.Container.Margins.Bottom.onChange = Layout.Container.Margins.Right.onChange = function(){
				try{
				var obj = LIB.getSelectedObject_forInterface();
				if( !obj )
					return;
				if( !obj.Layout )
					obj.Layout = {};
				if( !obj.Layout.margins )
					obj.Layout.margins = [false,false,false,false];
				
				if( reMargins )
					return;
				if(this.text == ''){
					reMargins = true;
					Layout.Container.Margins.Top.text = Layout.Container.Margins.Bottom.text = Layout.Container.Margins.Right.text = '';
					reMargins = false;
					obj.Layout.margins[1] = obj.Layout.margins[2] = obj.Layout.margins[3] = false;
					}
				else{
					var index = this.properties.name == 'Top' ? 1 : ( this.properties.name == 'Right' ? 2 : 3 );
					obj.Layout.margins[index] = +this.text;
					reMargins = true;
					var thisValue = obj.Layout.margins[0] === false ? obj.Layout.margins[index] : obj.Layout.margins[0];
					for(var i = 0; i < 4; i++)
						if(Layout.Container.Margins.children[i].text == '')
							Layout.Container.Margins.children[i].text = obj.Layout.margins[i] = thisValue;
					if( obj.Layout.margins[1] === obj.Layout.margins[0] && obj.Layout.margins[2] === obj.Layout.margins[0] && obj.Layout.margins[3] === obj.Layout.margins[0] ){
						Layout.Container.Margins.Top.text = Layout.Container.Margins.Bottom.text = Layout.Container.Margins.Right.text = '';
						obj.Layout.margins[1] = obj.Layout.margins[2] = obj.Layout.margins[3] = false;
						}
					reMargins = false;
					}
				}catch(err){ script.alertError( err ); reMargins = false; }
				}
			Layout.Container.Spacing.onChange = function(){
				var obj = LIB.getSelectedObject_forInterface();
				if( !obj )
					return;
				if( !obj.Layout )
					obj.Layout = {};
				obj.Layout.spacing = this.text == '' ? undefined : +this.text;
				}
			Layout.Indent.Text.onChange = function(){
				var obj = LIB.getSelectedObject_forInterface();
				if( !obj )
					return;
				if( !obj.Layout )
					obj.Layout = {};
				obj.Layout.indent = this.text == '' ? undefined : +this.text;
				}
			Layout.Characters.Text.onChange = function(){
				var obj = LIB.getSelectedObject_forInterface();
				if( !obj )
					return;
				if( !obj.Layout )
					obj.Layout = {};
				obj.Layout.characters = this.text == '' ? undefined : +this.text;
				}
			Layout.maxSizeW.onChange = Layout.maxSizeH.onChange = function(){
				try{
				var obj = LIB.getSelectedObject_forInterface();
				if( !obj )
					return;
				if( !obj.Layout )
					obj.Layout = {};
				if( !obj.Layout.maximumSize )
					obj.Layout.maximumSize = {};
				if( +this.text == 0 )
					this.text = '';
				obj.Layout.maximumSize.width = Layout.maxSizeW.text ? +Layout.maxSizeW.text : undefined;
				obj.Layout.maximumSize.height = Layout.maxSizeH.text ? +Layout.maxSizeH.text : undefined;
				}catch(err){ script.alertError(err); }
				}
			Layout.minSizeW.onChange = Layout.minSizeH.onChange = function(){
				try{
				var obj = LIB.getSelectedObject_forInterface();
				if( !obj )
					return;
				if( !obj.Layout )
					obj.Layout = {};
				if( !obj.Layout.minimumSize )
					obj.Layout.minimumSize = {};
				if( +this.text == 0 )
					this.text = '';
				obj.Layout.minimumSize.width = Layout.minSizeW.text ? +Layout.minSizeW.text : undefined;
				obj.Layout.minimumSize.height = Layout.minSizeH.text ? +Layout.minSizeH.text : undefined;
				}catch(err){ script.alertError(err); }
				}
			// TITLE
			Layout.Title.Margins.Left.onChanging = 
			Layout.Title.Margins.Top.onChanging = 
			Layout.Title.Margins.Bottom.onChanging = 
			Layout.Title.Margins.Right.onChanging = 
			Layout.Title.Spacing.onChanging = 
			Layout.Title.Characters.onChanging = CORRECTS.dataCorrectEnter_forInterface;
			
			Layout.Title.Text.onChange = function(){
				var obj = LIB.getSelectedObject_forInterface();
				if( !obj )
					return;
				if( !obj.Layout )
					obj.Layout = {};
				obj.Layout.title = this.text == '' ? undefined : this.text;
				}
			Layout.Title.STRING.onClick = Layout.Title.Var.onClick = function(){
				var obj = LIB.getSelectedObject_forInterface();
				if( !obj.Layout )
					obj.Layout = {};
				if( obj )
					obj.Layout.titleVar = (this.properties.name == 'Var');
				}
			// JUSTIFY
			var Justify = Layout.Title.Justify;
			var leftIcon = script.getInDesignIcon( 'Text/(Paragraph Panel Resources)/idrc_PNGA/10381.idrc' );
			var centerIcon = script.getInDesignIcon( 'Text/(Paragraph Panel Resources)/idrc_PNGA/10382.idrc' );
			var rightIcon = script.getInDesignIcon( 'Text/(Paragraph Panel Resources)/idrc_PNGA/10383.idrc' );
			if( rightIcon && centerIcon && leftIcon ){
				Justify.Left = Justify.add( "iconbutton", [3,0,25,22], leftIcon, {name: 'left', } );
				Justify.Center = Justify.add( "iconbutton", [3,25,25,47], centerIcon, {name: 'center', } );
				Justify.Right = Justify.add( "iconbutton", [3,50,25,72], rightIcon, {name: 'right', } );
				}
			else{
				if( File.fs == 'Windows' ){
					Justify.Left = Justify.add( "button", [3,0,25,22], '>', {name: 'left', } );
					Justify.Center = Justify.add( "button", [3,25,25,47], '|', {name: 'center', } );
					Justify.Right = Justify.add( "button", [3,50,25,72], '<', {name: 'right', } );
					}
				else{
					Justify.Left = Justify.add( "iconbutton", [0,0,22,22], undefined, {name: 'left', style: 'button', toggle: true } );
					Justify.Center = Justify.add( "iconbutton", [0,25,22,47], undefined, {name: 'center', } );
					Justify.Right = Justify.add( "iconbutton", [0,50,22,72], undefined, {name: 'right', } );
					script.getCustomDraw (Justify.Left, {text:'>'});
					script.getCustomDraw (Justify.Center, {text:'|'});
					script.getCustomDraw (Justify.Right, {text:'<'});
					}
				}
			Justify.Left.onClick = Justify.Center.onClick = Justify.Right.onClick = function(){
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( !obj )
					return;
				if( !obj.Layout )
					obj.Layout = {};
				if( !obj.Layout.titleLayout )
					obj.Layout.titleLayout = {};
				Justify.Left.enabled = Justify.Center.enabled = Justify.Right.enabled = true;
				this.enabled = false;
				obj.Layout.titleLayout.justify = this.properties.name.toString();
				}
			// END JUSTIFY
			Layout.Title.Alignment.W.onChange = Layout.Title.Alignment.H.onChange = function(){
				var obj = LIB.getSelectedObject_forInterface();
				if( !obj )
					return;
				if( !obj.Layout )
					obj.Layout = {};
				if( !obj.Layout.titleLayout )
					obj.Layout.titleLayout = {};
				if( !this.selection.index )
					this.selection = null;
				if( !Layout.Title.Alignment.W.selection && !Layout.Title.Alignment.H.selection )
					obj.Layout.titleLayout.alignment = undefined;
				else{
					if( !obj.Layout.titleLayout.alignment )
						obj.Layout.titleLayout.alignment = [undefined, undefined];
					if( this.properties.name == 'W' )
						obj.Layout.titleLayout.alignment[0] = Layout.Title.Alignment.W.selection ? Layout.Title.Alignment.W.selection.text : undefined;
					else{
						obj.Layout.titleLayout.alignment[1] = Layout.Title.Alignment.H.selection ? Layout.Title.Alignment.H.selection.text : undefined;
						}
					}
				}
			var Title_reMargins = false;
			Layout.Title.Margins.Left.onChange = function(){
				try{
				var obj = LIB.getSelectedObject_forInterface();
				if( !obj )
					return;
				if( !obj.Layout )
					obj.Layout = {};
				if( !obj.Layout.titleLayout )
					obj.Layout.titleLayout = {};
				if( !obj.Layout.titleLayout.margins )
					obj.Layout.titleLayout.margins = [false,false,false,false];
				
				if(Title_reMargins)
					return;
				obj.Layout.titleLayout.margins[0] = +this.text;
				if(this.text == ''){
					Title_reMargins = true;
					Layout.Title.Margins.Top.text = Layout.Title.Margins.Bottom.text = Layout.Title.Margins.Right.text = '';
					Title_reMargins = false;
					obj.Layout.titleLayout.margins = undefined;
					}
				else if( obj.Layout.titleLayout.margins[1] === obj.Layout.titleLayout.margins[0] && obj.Layout.titleLayout.margins[2] === obj.Layout.titleLayout.margins[0] && obj.Layout.titleLayout.margins[3] === obj.Layout.titleLayout.margins[0] ){
					Layout.Title.Margins.Top.text = Layout.Title.Margins.Bottom.text = Layout.Title.Margins.Right.text = '';
					obj.Layout.titleLayout.margins[1] = obj.Layout.titleLayout.margins[2] = obj.Layout.titleLayout.margins[3] = false;
					}
				}catch(err){ script.alertError( err ); Title_reMargins = false; }
				}
			Layout.Title.Margins.Top.onChange = Layout.Title.Margins.Bottom.onChange = Layout.Title.Margins.Right.onChange = function(){
				try{
				var obj = LIB.getSelectedObject_forInterface();
				if( !obj )
					return;
				if( !obj.Layout )
					obj.Layout = {};
				if( !obj.Layout.titleLayout )
					obj.Layout.titleLayout = {};
				if( !obj.Layout.titleLayout.margins )
					obj.Layout.titleLayout.margins = [false,false,false,false];
				
				if( Title_reMargins )
					return;
				if(this.text == ''){
					Title_reMargins = true;
					Layout.Title.Margins.Top.text = Layout.Title.Margins.Bottom.text = Layout.Title.Margins.Right.text = '';
					Title_reMargins = false;
					obj.Layout.titleLayout.margins[1] = obj.Layout.titleLayout.margins[2] = obj.Layout.titleLayout.margins[3] = false;
					}
				else{
					var index = this.properties.name == 'Top' ? 1 : ( this.properties.name == 'Right' ? 2 : 3 );
					obj.Layout.titleLayout.margins[index] = +this.text;
					Title_reMargins = true;
					for(var i = 0; i < 4; i++)
						if(Layout.Title.Margins.children[i].text == '')
							Layout.Title.Margins.children[i].text = obj.Layout.titleLayout.margins[i] = +this.text;
					if( obj.Layout.titleLayout.margins[1] === obj.Layout.titleLayout.margins[0] && obj.Layout.titleLayout.margins[2] === obj.Layout.titleLayout.margins[0] && obj.Layout.titleLayout.margins[3] === obj.Layout.titleLayout.margins[0] ){
						Layout.Title.Margins.Top.text = Layout.Title.Margins.Bottom.text = Layout.Title.Margins.Right.text = '';
						obj.Layout.titleLayout.margins[1] = obj.Layout.titleLayout.margins[2] = obj.Layout.titleLayout.margins[3] = false;
						}
					Title_reMargins = false;
					}
				}catch(err){ script.alertError( err ); Title_reMargins = false; }
				}
			Layout.Title.Spacing.onChange = function(){
				var obj = LIB.getSelectedObject_forInterface();
				if( !obj )
					return;
				if( !obj.Layout )
					obj.Layout = {};
				if( !obj.Layout.titleLayout )
					obj.Layout.titleLayout = {};
				obj.Layout.titleLayout.spacing = this.text == '' ? undefined : +this.text;
				}
			Layout.Title.Characters.onChange = function(){
				var obj = LIB.getSelectedObject_forInterface();
				if( !obj )
					return;
				if( !obj.Layout )
					obj.Layout = {};
				if( !obj.Layout.titleLayout )
					obj.Layout.titleLayout = {};
				obj.Layout.titleLayout.characters = this.text == '' ? undefined : +this.text;
				}
			Layout.Title.Truncate.onChange = function(){
				var obj = LIB.getSelectedObject_forInterface();
				if( !obj )
					return;
				if( !obj.Layout )
					obj.Layout = {};
				if( !obj.Layout.titleLayout )
					obj.Layout.titleLayout = {};
				obj.Layout.titleLayout.truncate = this.selection && this.selection.index ? his.selection.text : undefined;
				}
			Layout.Code.onClick = function(){
				LIB.showCode( true, true );
				}
			Layout.CodePlus.onClick = function(){
				LIB.showCodePlus( true );
				}
			Layout.Test.onClick = function(){
				LIB.testCode( true );
				}
			},
		Layout: function( obj, args ){
			//script.consol( 'Layout(): ', obj, ', args: ', args );
			var IS_WINDOW = this.isWindow(obj);
			var IS_CONTAINER = this.isContainer(obj);
			// меняем
			if( args && args.hasOwnProperty('Layout') ){
				if( !script.constructorName(args.Layout, 'object') ) // обнуляем
					obj.Layout = undefined;
				else // поскольку вся работа с объектом реализована в интерфейсе - просто присваваем объект
					obj.Layout = args.Layout;
				}
			if( this.getSelectedObject() != obj || !win.obj.Layout.visible )
				return;
			try{
				this.selectingStatus = true;
				var Layout = win.obj.Layout;
				if( obj.Layout && obj.Layout.preferredSize ){
					Layout.sizeW.text = obj.Layout.preferredSize.width ? obj.Layout.preferredSize.width : '';
					Layout.sizeH.text = obj.Layout.preferredSize.height ? obj.Layout.preferredSize.height : '';
					}
				else Layout.sizeW.text = Layout.sizeH.text = '';
				if( IS_WINDOW )
					Layout.Alignment.visible =  false;
				else{
					Layout.Alignment.visible =  true;
					if( obj.Layout && obj.Layout.alignment ){
						// обновляем alignment
						obj.Layout.alignment = this.getAlignment( obj );
						Layout.Alignment.W.selection = obj.Layout.alignment && obj.Layout.alignment[0] ? Layout.Alignment.W.find(obj.Layout.alignment[0]) : null;
						Layout.Alignment.H.selection = obj.Layout.alignment && obj.Layout.alignment[1] ? Layout.Alignment.H.find(obj.Layout.alignment[1]) : null;
						}
					else Layout.Alignment.W.selection = Layout.Alignment.H.selection = null;
					}
				if( !IS_WINDOW && IS_CONTAINER ){
					Layout.tabbedPanel.visible = true;
					Layout.tabbedPanel.value = ( obj.Layout && obj.Layout.TabbedPanel );
					Layout.tabbedPanel.enabled = ( obj.parent.Layout && obj.parent.Layout.TabbedPanel ) ? false : true;
					}
				else Layout.tabbedPanel.visible = false;
				if( IS_CONTAINER ){
					Layout.Container.visible = !( obj.Layout && obj.Layout.TabbedPanel );
					if( obj.Layout && obj.Layout.orientation )
						Layout.Container.Orientation[obj.Layout.orientation.toLowerCase()].value = true;
					else Layout.Container.Orientation.Column.value = true;
					if( obj.Layout && obj.Layout.alignChildren ){
						Layout.Container.alignChildrenW.selection = obj.Layout.alignChildren[0] ? Layout.Container.alignChildrenW.find(obj.Layout.alignChildren[0]) : null;
						Layout.Container.alignChildrenH.selection = obj.Layout.alignChildren[1] ? Layout.Container.alignChildrenH.find(obj.Layout.alignChildren[1]) : null;
						}
					else Layout.Container.alignChildrenW.selection = Layout.Container.alignChildrenH.selection = null;
					Layout.Container.Margins.Left.text = Layout.Container.Margins.Top.text = Layout.Container.Margins.Right.text = Layout.Container.Margins.Bottom.text = '';
					if( obj.Layout && obj.Layout.margins ){
						if( script.constructorName(obj.Layout.margins[0], 'number') ) Layout.Container.Margins.Left.text = obj.Layout.margins[0];
						if( script.constructorName(obj.Layout.margins[1], 'number') ) Layout.Container.Margins.Top.text = obj.Layout.margins[1];
						if( script.constructorName(obj.Layout.margins[2], 'number') ) Layout.Container.Margins.Right.text = obj.Layout.margins[2];
						if( script.constructorName(obj.Layout.margins[3], 'number') ) Layout.Container.Margins.Bottom.text = obj.Layout.margins[3];
						}
					Layout.Container.Spacing.text = obj.Layout && script.constructorName(obj.Layout.spacing, 'number') ? obj.Layout.spacing : '';
					}
				else Layout.Container.visible = false;
				if( IS_WINDOW || !SUPPORT_LAYOUT[obj.type].indent )
					Layout.Indent.visible = false;
				else{
					Layout.Indent.visible = true;
					Layout.Indent.Text.text = obj.Layout && script.constructorName(obj.Layout.indent, 'number') ? obj.Layout.indent : '';
					}
				if( !SUPPORT_LAYOUT[obj.type].characters )
					Layout.Characters.visible = false;
				else{
					Layout.Characters.visible = true;
					Layout.Characters.Text.text = obj.Layout && script.constructorName(obj.Layout.characters, 'number') ? obj.Layout.characters : '';
					}
				if( obj.Layout && obj.Layout.maximumSize ){
					Layout.maxSizeW.text = obj.Layout.maximumSize.width ? obj.Layout.maximumSize.width : '';
					Layout.maxSizeH.text = obj.Layout.maximumSize.height ? obj.Layout.maximumSize.height : '';
					}
				else Layout.maxSizeW.text = Layout.maxSizeH.text = '';
				if( obj.Layout && obj.Layout.minimumSize ){
					Layout.minSizeW.text = obj.Layout.minimumSize.width ? obj.Layout.minimumSize.width : '';
					Layout.minSizeH.text = obj.Layout.minimumSize.height ? obj.Layout.minimumSize.height : '';
					}
				else Layout.minSizeW.text = Layout.minSizeH.text = '';
				// TITLE
				if( IS_WINDOW || !SUPPORT_LAYOUT[obj.type].title || (IS_CONTAINER && (!obj.Layout || !obj.Layout.TabbedPanel)) )
					Layout.Title.visible = false;
				else{
					Layout.Title.visible = true;
					Layout.Title.Text.text = obj.Layout && obj.Layout.title ? obj.Layout.title : '';
					obj.Layout && obj.Layout.titleVar ? Layout.Title.Var.value = true : Layout.Title.STRING.value = true;
					// Justify
					Layout.Title.Justify.Left.enabled = Layout.Title.Justify.Center.enabled = Layout.Title.Justify.Right.enabled = true;
					if( obj.Layout && obj.Layout.titleLayout && obj.Layout.titleLayout.justify )
						switch( obj.Layout.titleLayout.justify ){
							case  'center':
								Layout.Title.Justify.Center.enabled = false;
							break;
							case  'right':
								Layout.Title.Justify.Right.enabled = false;
							break;
							default:
								Layout.Title.Justify.Left.enabled = false;
							}
					else Layout.Title.Justify.Left.enabled = false;
					// Alignment
					if( obj.Layout && obj.Layout.titleLayout && obj.Layout.titleLayout.alignment ){
						Layout.Title.Alignment.W.selection = obj.Layout.titleLayout.alignment[0] ? Layout.Title.Alignment.W.find(obj.Layout.titleLayout.alignment[0]) : null;
						Layout.Title.Alignment.H.selection = obj.Layout.titleLayout.alignment[1] ? Layout.Title.Alignment.H.find(obj.Layout.titleLayout.alignment[1]) : null;
						}
					else Layout.Title.Alignment.W.selection = Layout.Title.Alignment.H.selection = null;
					// Margins
					Layout.Title.Margins.Left.text = Layout.Title.Margins.Top.text = Layout.Title.Margins.Right.text = Layout.Title.Margins.Bottom.text = '';
					if( obj.Layout && obj.Layout.titleLayout && obj.Layout.titleLayout.margins ){
						if( script.constructorName( obj.Layout.titleLayout.margins[0], 'number') ) Layout.Title.Margins.Left.text =  obj.Layout.titleLayout.margins[0];
						if( script.constructorName( obj.Layout.titleLayout.margins[1], 'number') ) Layout.Title.Margins.Top.text =  obj.Layout.titleLayout.margins[1];
						if( script.constructorName( obj.Layout.titleLayout.margins[2], 'number') ) Layout.Title.Margins.Right.text =  obj.Layout.titleLayout.margins[2];
						if( script.constructorName( obj.Layout.titleLayout.margins[3], 'number') ) Layout.Title.Margins.Bottom.text =  obj.Layout.titleLayout.margins[3];
						}
					// Spacing
					Layout.Title.Spacing.text = obj.Layout && obj.Layout.titleLayout && obj.Layout.titleLayout.spacing ? obj.Layout.titleLayout.spacing : '';
					// Characters
					Layout.Title.Characters.text = obj.Layout && obj.Layout.titleLayout && script.constructorName(obj.Layout.titleLayout.characters, 'number') ? obj.Layout.titleLayout.characters : '';
					// Truncate
					Layout.Title.Truncate.selection = obj.Layout && obj.Layout.titleLayout && obj.Layout.titleLayout.truncate ? Layout.Truncate.find(obj.Layout.titleLayout.truncate) : null;
					}
			}catch(err){ script.alertError(err); return; }
			finally{ this.selectingStatus = false }
			},
		Dynamic_init: function(){
			var Dynamic = win.obj.Dynamic;
			Dynamic.Enabled.onClick = function(){
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( !obj )
					return;
				if( this.value && !obj.Dynamic )
					obj.Dynamic = {};
				obj.Dynamic.enabled = this.value;
				if( uiBuilderLibrary.isWindow(obj) )
					Dynamic.Window.enabled = this.value;
				else
					Dynamic.obj.enabled = this.value;
				}
			Dynamic.obj.move_width.add( 'item', 'center' );
			
			Dynamic.obj.move_width.onChange = 
			Dynamic.obj.move_height.onChange = 
			Dynamic.obj.resize_width.onChange = 
			Dynamic.obj.resize_height.onChange = function(){
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( !obj )
					return;
				if( !obj.Dynamic )
					obj.Dynamic = {};
				switch( this.properties.name ){
					case 'move_width':
					case 'move_height':
						if( !obj.Dynamic.moveCoefs )
							obj.Dynamic.moveCoefs = [false,false];
						if( this.properties.name == 'move_width' )
							obj.Dynamic.moveCoefs[0] = this.selection.text == 'center' ? this.selection.text : this.selection.index;
						else
							obj.Dynamic.moveCoefs[1] = this.selection.index;
						if( !obj.Dynamic.moveCoefs[0] && !obj.Dynamic.moveCoefs[1] )
							obj.Dynamic.moveCoefs = undefined;
					break;
					case 'resize_width':
					case 'resize_height':
						if( !obj.Dynamic.resizeCoefs )
							obj.Dynamic.resizeCoefs = [false,false];
						if( this.properties.name == 'resize_width' )
							obj.Dynamic.resizeCoefs[0] = this.selection.index;
						else
							obj.Dynamic.resizeCoefs[1] = this.selection.index;
						if( !obj.Dynamic.resizeCoefs[0] && !obj.Dynamic.resizeCoefs[1] )
							obj.Dynamic.resizeCoefs = undefined;
					break;
					}
				if( !this.selection.index )
					this.selection = null;
				}
			// separator
			Dynamic.obj.separator.Enabled.onClick = function(){
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( !obj )
					return;
				if( !obj.Dynamic )
					obj.Dynamic = {};
				Dynamic.obj.separator.onWidth.enabled =
				Dynamic.obj.separator.onHeight.enabled = this.value;
				if( this.value ){
					Dynamic.obj.separator.onWidth.value = true;
					obj.Dynamic.isSeparator = 0;
					}
				else{
					Dynamic.obj.separator.onWidth.value = 
					Dynamic.obj.separator.onHeight.value =
					obj.Dynamic.isSeparator = false;
					}
				}
			Dynamic.obj.separator.onWidth.onClick =
			Dynamic.obj.separator.onHeight.onClick = function(){
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( !obj )
					return;
				if( !obj.Dynamic )
					obj.Dynamic = {};
				obj.Dynamic.isSeparator = this.properties.name == 'onWidth' ? 0 : 1;
				}
			// Window
			Dynamic.Window.minSize_width.onClick =
			Dynamic.Window.minSize_height.onClick =
			Dynamic.Window.resize_width.onClick =
			Dynamic.Window.resize_height.onClick = function(){
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( !obj )
					return;
				if( !obj.Dynamic )
					obj.Dynamic = {};
				switch( this.properties.name ){
					case 'minSize_width':
					case 'minSize_height':
						if( !obj.Dynamic.windowMinSize )
							obj.Dynamic.windowMinSize = [false,false];
						if( this.properties.name == 'minSize_width' )
							obj.Dynamic.windowMinSize[0] = this.value;
						else
							obj.Dynamic.windowMinSize[1] = this.value;
						if( !obj.Dynamic.windowMinSize[0] && !obj.Dynamic.windowMinSize[1] )
							obj.Dynamic.windowMinSize = undefined;
					break;
					case 'resize_width':
					case 'resize_height':
						if( !obj.Dynamic.windowResizeDirections )
							obj.Dynamic.windowResizeDirections = [true,true];
						if( this.properties.name == 'resize_width' )
							obj.Dynamic.windowResizeDirections[0] = this.value;
						else
							obj.Dynamic.windowResizeDirections[1] = this.value;
						if( obj.Dynamic.windowResizeDirections[0] && obj.Dynamic.windowResizeDirections[1] )
							obj.Dynamic.windowResizeDirections = undefined;
					break;
					}
				}
			Dynamic.Clear.onClick = function(){
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( !obj || !obj.Dynamic )
					return;
				uiBuilderLibrary.Dynamic( obj, {Dynamic: false} );
				}
			Dynamic.ClearAllChildren.onClick = function(){
				var obj = uiBuilderLibrary.getSelectedObject_forInterface();
				if( !obj )
					return;
				if( !confirm('Will reset all dynamic settings of children current object.\rAre you sure?') )
					return;
				recursive( obj );
				this.enabled = false;
				function recursive( obj ){
					if( !uiBuilderLibrary.isContainer(obj) || !obj.children.length )
						return;
					for( var i = 0; i < obj.children.length; i++ ){
						obj.children[i].Dynamic = undefined;
						recursive( obj.children[i] );
						}
					}
				}
			},
		Dynamic: function( obj, args ){
			//script.consol( 'Dynamic(): ', obj, ', args: ', args );
			// меняем
			if( args && args.hasOwnProperty('Dynamic') ){
				if( !script.constructorName(args.Dynamic, 'object') ) // обнуляем
					obj.Dynamic = undefined;
				else{
					if( !obj.Dynamic )
						obj.Dynamic = {};
					if( args.Dynamic.hasOwnProperty('enabled') ) obj.Dynamic.enabled = args.Dynamic.enabled;
					if( this.isWindow(obj) ){
						if( args.Dynamic.windowMinSize )
							obj.Dynamic.windowMinSize = args.Dynamic.windowMinSize;
						if( args.Dynamic.windowResizeDirections )
							obj.Dynamic.windowResizeDirections = args.Dynamic.windowResizeDirections;
						}
					else{
						if( args.Dynamic.moveCoefs )
							obj.Dynamic.moveCoefs = args.Dynamic.moveCoefs;
						if( args.Dynamic.resizeCoefs )
							obj.Dynamic.resizeCoefs = args.Dynamic.resizeCoefs;
						if( args.Dynamic.hasOwnProperty('isSeparator') )
							obj.Dynamic.isSeparator = args.Dynamic.isSeparator;
						}
					}
				}
			// показываем настройки
			if( this.getSelectedObject() != obj || !win.obj.Dynamic.visible )
				return;
			try{
				this.selectingStatus = true;
				var Dynamic = win.obj.Dynamic;
				var IS_WINDOW = this.isWindow(obj);
				Dynamic.obj.visible = Dynamic.note_obj.visible = !IS_WINDOW;
				Dynamic.Window.visible = Dynamic.note_window.visible = IS_WINDOW;
				if( !obj.Dynamic ){ // обнуляем
					if( IS_WINDOW ){
						Dynamic.Enabled.enabled = ( obj.Resizeable );
						Dynamic.Enabled.value =
						Dynamic.Window.enabled =
						Dynamic.Window.minSize_width.value = 
						Dynamic.Window.minSize_height.value = false;
						Dynamic.Window.resize_width.value = 
						Dynamic.Window.resize_height.value = true;
						}
					else{
						Dynamic.Enabled.value = false;
						Dynamic.obj.enabled = false;
						Dynamic.obj.move_width.selection =
						Dynamic.obj.move_height.selection =
						Dynamic.obj.resize_width.selection =
						Dynamic.obj.resize_height.selection = null;
						// separator
						Dynamic.obj.separator.enabled = true;
						Dynamic.obj.separator.onWidth.enabled =
						Dynamic.obj.separator.onHeight.enabled = false;
						Dynamic.obj.separator.Enabled.value =
						Dynamic.obj.separator.onWidth.value =
						Dynamic.obj.separator.onHeight.value = false;
						}
					}
				else{ // показываем
					if( IS_WINDOW ){
						Dynamic.Enabled.enabled = ( obj.Resizeable );
						Dynamic.Window.enabled = ( obj.Resizeable && obj.Dynamic.enabled );
						Dynamic.Enabled.value = ( obj.Dynamic.enabled );
						Dynamic.Window.minSize_width.value = obj.Dynamic.windowMinSize && obj.Dynamic.windowMinSize[0] ? true : false;
						Dynamic.Window.minSize_height.value = obj.Dynamic.windowMinSize && obj.Dynamic.windowMinSize[1] ? true : false;
						Dynamic.Window.resize_width.value = (!obj.Dynamic.windowResizeDirections || obj.Dynamic.windowResizeDirections[0]) ? true : false;
						Dynamic.Window.resize_height.value = (!obj.Dynamic.windowResizeDirections || obj.Dynamic.windowResizeDirections[1]) ? true : false;
						}
					else{
						Dynamic.Enabled.enabled = true;
						Dynamic.Enabled.value =
						Dynamic.obj.enabled = ( obj.Dynamic.enabled );
						Dynamic.obj.move_width.selection = obj.Dynamic.moveCoefs && obj.Dynamic.moveCoefs[0] ? (obj.Dynamic.moveCoefs[0] == 'center' ? Dynamic.obj.move_width.find('center') : obj.Dynamic.moveCoefs[0]) : null;
						Dynamic.obj.move_height.selection = obj.Dynamic.moveCoefs && obj.Dynamic.moveCoefs[1] ? obj.Dynamic.moveCoefs[1] : null;
						Dynamic.obj.resize_width.selection = obj.Dynamic.resizeCoefs && obj.Dynamic.resizeCoefs[0] ? obj.Dynamic.resizeCoefs[0] : null;
						Dynamic.obj.resize_height.selection = obj.Dynamic.resizeCoefs && obj.Dynamic.resizeCoefs[1] ? obj.Dynamic.resizeCoefs[1] : null;
						// separator
						if( script.constructorName(obj.Dynamic.isSeparator, 'number') ){
							Dynamic.obj.separator.Enabled.value =
							Dynamic.obj.separator.onWidth.enabled = true;
							Dynamic.obj.separator.onHeight.enabled = true;
							if( !obj.Dynamic.isSeparator )
								Dynamic.obj.separator.onWidth.value = true;
							else
								Dynamic.obj.separator.onHeight.value = true;
							}
						else{
							Dynamic.obj.separator.Enabled.value =
							Dynamic.obj.separator.onWidth.enabled =
							Dynamic.obj.separator.onHeight.enabled =
							Dynamic.obj.separator.onWidth.value =
							Dynamic.obj.separator.onHeight.value = false;
							}
						}
					}
				
				if( uiBuilderLibrary.isContainer(obj) ){
					Dynamic.ClearAllChildren.visible = true;
					Dynamic.ClearAllChildren.enabled = this.containedDynamicChildren( obj );
					}
				else
					Dynamic.ClearAllChildren.visible = false;
			}catch(err){ script.alertError(err); return; }
			finally{ this.selectingStatus = false }
			},
		containedDynamicChildren: function( obj ){
			if( !obj )
				return false;
			var LIB = this;
			return recursive( obj );
			function recursive( obj ){
				if( !LIB.isContainer(obj) || !obj.children.length )
					return false;
				for( var i = 0; i < obj.children.length; i++ )
					if( obj.children[i].Dynamic || recursive(obj.children[i]) )
						return true;
				return false;
				}
			},
		//======================== ГЕНЕРАЦИЯ КОДА ===============================
		getCode: function( obj, PREFS ){ // prefs = { varAdd: Bool, tabCode: Bool, code_varAsTree: Bool, code_createFunctions: Bool, withoutVariables: Bool, automationLayout: Bool }
			try{
			var LIB = this;
			PREFS = PREFS || { varAdd: true, tabCode: true, code_varAsTree: true, code_createFunctions: false };
			var Var = PREFS.varAdd ? 'var ' : '';//объявления через var 
			var relativeLink = obj.project.relativeLink;//относительные линки
			itemNameStatus = false;//выставляем по умолчанию глобальную переменную, для объявления через var только первой переменной с именем 'item'
			var tab = PREFS.tabCode ? '\t' : '';
			var PAR = '\r';
			var Str = '';
			var vars = ''; // объявления переменных для массивов и текста
			var varObjects = {};// база объектов, создаваемых для объявления переменных
			var functs = '';// объявления ф-ций
			// Layout
			var automationLayout = PREFS.automationLayout;
			// Dynamic
			var windowDynamic_init = '';
			var dynamicStr = '';
			var dynamicObjects_namesBasa = {};
			var dynamicObjectsNamesErrors = [];
			var windowResizeDirections =  obj.project.Resizeable && obj.project.Dynamic && obj.project.Dynamic.enabled ? (obj.project.Dynamic.windowResizeDirections ? obj.project.Dynamic.windowResizeDirections : [true,true] ) : [false,false];
				
			var args = this.getClearArgs( { obj: obj, withChildren: true, forOut: true } );
			
			if( obj.project == obj ){ //is Window
				// Dynamic
				if( windowResizeDirections[0] || windowResizeDirections[1] ){
					var thisDynamic = args.Dynamic;
					if( thisDynamic.windowMinSize && (thisDynamic.windowMinSize[0] || thisDynamic.windowMinSize[1]) )
						windowDynamic_init += 'windowMinSize: [' +thisDynamic.windowMinSize.toString()+ '], ';
					if( !windowResizeDirections[0] || !windowResizeDirections[1] )
						windowDynamic_init += 'windowResizeDirections: [' +thisDynamic.windowResizeDirections.toString()+ '], ';
					if( windowDynamic_init )
						windowDynamic_init = 'window: '+args.Var +', '+ windowDynamic_init;
					}
				//========
				var props = '';
				if( args.relativeLinks ) Str += 'Folder.current = File($.fileName).parent;\r\r' + PAR;
				if( args.Resizeable ) props = 'resizeable: true, ';
				if( args.Borderless ) props = 'borderless: true, ';
				props = props ? '{'+props+'}' : '';
				var bounds = automationLayout ? 'undefined' : '[0,0,'+args.size[0]+','+args.size[1]+']';
				Str += Var + args.Var + ' = new Window("dialog", ' + getTextForCode( args )+', '+ bounds +', '+props+');' + PAR;
				Str += getAutomationLayout( args, "dialog", '', args.Var );
				if( args.children ){
					Str += 'with(' + args.Var + '){' + PAR;
					for( var i = 0; i < args.children.length; i++ )
						Str += codeChildren( args.children[i], tab, args.Var );
					Str += tab + '}' + PAR;
					}
				// объявление переменных и ф-ций
				declareVariable( args, args.Var );
				// Dynamic
				if( windowDynamic_init )
					dynamicStr = 'script.addDynamicObject( {' + windowDynamic_init + '} );' + PAR + dynamicStr + PAR;
				Str += dynamicStr;
				//=======
				if( automationLayout && obj.project.Resizeable && (!obj.project.Dynamic || !obj.project.Dynamic.enabled) ){
					Str += args.Var + '.onResizing = function(){ this.layout.resize() }' + PAR;
					Str += args.Var + '.onShow = function(){ this.layout.layout(); this.minimumSize = this.preferredSize }' + PAR;
					}
				//=======
				Str = vars + Str + functs;
				Str += args.Var + '.center();' + PAR;
				Str += args.Var + '.show();' + PAR;
				}
			else{
				if( automationLayout && obj.parent.Layout &&  obj.parent.Layout.TabbedPanel ){
					if( args.type != 'group' && args.type != 'panel' )
						return 'Error: current object can not be shown as Tab';
					args.parentIsTabbedPanel = true;
					}
				Str += codeChildren( args, '', this.getFullVar(obj.parent) );
				Str = vars + Str + functs;
				}
			if( dynamicObjectsNamesErrors.length )
				alert( 'Warning!\rThe names of several variables of dynamic objects coincide:\r\r' + dynamicObjectsNamesErrors.join('\r') );
			return Str;
			}catch(err){script.alertError(err); return ''; }
			// ============================================================
			function codeChildren( args, t, treeVar ){//ф-ция взятия кода из children
				try{
				if( automationLayout && args.parentIsTabbedPanel && !(args.type == 'group' || args.type == 'panel') )
					return '';
				var thisVar = PREFS.code_varAsTree ? (treeVar ? treeVar : Var)+'.'+args.Var : Var + args.Var;
				var props = LIB.getCodeProperties( args, !PREFS.withoutVariables );
				var TYPE = automationLayout ? ( args.Layout && args.Layout.TabbedPanel ? 'tabbedpanel' : (args.parentIsTabbedPanel ? 'tab' : args.type) ) : args.type;
				var BOUNDS = automationLayout ? 'undefined' : '['+args.location[0]+','+args.location[1]+','+(args.location[0]+args.size[0])+','+(args.location[1]+args.size[1])+']';
				var Str = t + thisVar + ' = add( "' + TYPE + '", '+ BOUNDS +', ' + getTextForCode( args ) + (props ? ', '+props : '') +' );' + PAR;
				Str += getAutomationLayout( args, TYPE, t, thisVar );
				//image
				if( args.image && args.image.pathname ){
					var NextImages = '';
					if( args.NextImages ){
						var flag;
						for( var i in args.NextImages )
							if( args.NextImages[i] ){
								flag = true;
								break;
								}
						if( flag ){
							NextImages += ', ' + ( args.NextImages['disabled'] ? '\'' + args.NextImages['disabled'] + '\'' : 'undefined' );
							NextImages += ', ' + ( args.NextImages['pressed'] ? '\'' + args.NextImages['pressed'] + '\'' : 'undefined' );
							NextImages += ', ' + ( args.NextImages['rollover'] ? '\'' + args.NextImages['rollover'] + '\'' : 'undefined' );
							}
						}
					Str += t + thisVar + '.image = ScriptUI.newImage("' + args.image.pathname +'"'+ NextImages + ');' + PAR;
					}
				// font
				if( args.graphics && args.graphics.font && (args.graphics.font.name || args.graphics.font.style || args.graphics.font.size) )
					Str += t + thisVar + '.graphics.font = ScriptUI.newFont('
						+ ( args.graphics.font.name ? '\''+args.graphics.font.name+'\'' : thisVar + '.graphics.font.name' ) +', '
						+ ( args.graphics.font.style ? '\''+args.graphics.font.style+'\'' : thisVar + '.graphics.font.style' ) +', '
						+ ( args.graphics.font.size ? args.graphics.font.size : thisVar + '.graphics.font.size' ) +
						');' + PAR;
				// itemSize
				if( LIB.getItemSize(args) )
					Str += t + thisVar + '.itemSize = [undefined, ' + args.itemSize[1] + '];' + PAR;
				// shortcutKey
				if( args.ShortcutKey )
					Str += t + thisVar + '.shortcutKey = "' + args.ShortcutKey + '";' + PAR;
				if( args.helpTip ) // helpTip
					Str += t + thisVar + '.helpTip = "' + CORRECTS.correctForCode( args.helpTip )+ '";' + PAR;
				if( args.visible === false ) // visible
					Str += t + thisVar + '.visible = false;' + PAR;
				if( args.justify )
					Str += t + thisVar + '.justify = "' + args.justify + '";' + PAR;
				// Dynamic
				if( args.Dynamic && args.Dynamic.enabled ){
					var thisDynamic = args.Dynamic;
					var thisDynamicStr = '' ;
					if( thisDynamic.moveCoefs && (thisDynamic.moveCoefs[0] || thisDynamic.moveCoefs[1]) )
						thisDynamicStr += 'moveCoefs: [' + 
							(thisDynamic.moveCoefs[0] ? (thisDynamic.moveCoefs[0]=='center' ? '\'center\'' :  (thisDynamic.moveCoefs[0]>1?'1/':0)+thisDynamic.moveCoefs[0]) : 0) + ',' +
							(thisDynamic.moveCoefs[1] ? (thisDynamic.moveCoefs[1]>1?'1/':0)+thisDynamic.moveCoefs[1] : 0) + '], ';
					if( thisDynamic.resizeCoefs && (thisDynamic.resizeCoefs[0] || thisDynamic.resizeCoefs[1]) )
						thisDynamicStr += 'resizeCoefs: [' + 
							(thisDynamic.resizeCoefs[0] ? (thisDynamic.resizeCoefs[0]>1?'1/':0)+thisDynamic.resizeCoefs[0] : 0) + ',' +
							(thisDynamic.resizeCoefs[1] ? (thisDynamic.resizeCoefs[1]>1?'1/':0)+thisDynamic.resizeCoefs[1] : 0) + '], ';
					if( script.constructorName(thisDynamic.isSeparator, 'number') )
						thisDynamicStr += 'isSeparator: ' + thisDynamic.isSeparator + ',';
					if( thisDynamicStr && windowDynamic_init ){
						thisDynamicStr += windowDynamic_init;
						windowDynamic_init = false;
						}
					if( thisDynamicStr ){
						if( dynamicObjects_namesBasa[thisVar] )
							dynamicObjectsNamesErrors.push( thisVar );
						dynamicObjects_namesBasa[thisVar] = true;
						dynamicStr += 'script.addDynamicObject( {obj: ' + thisVar + ', ' + thisDynamicStr + '} );'+PAR;
						}
					}
				// объявление переменных и ф-ций
				declareVariable( args, thisVar );
				//берем код из детей
				if( SUPPORT[args.type]['children'] && args.children && args.children.length ){
					Str += t + 'with(' + thisVar + '){' + PAR;
					for( var i = 0; i < args.children.length; i++ ){
						if( automationLayout && args.Layout && args.Layout.TabbedPanel )
							args.children[i].parentIsTabbedPanel = true;
						Str += codeChildren( args.children[i], t+tab, thisVar );
						}
					Str += t + tab + '}' + PAR;
					}
				return Str;
				}catch(err){script.alertError(err); return '[ERROR]\r'; }
				}
			function getAutomationLayout( args, TYPE, tab, fullVar ){
				if( !automationLayout || !args.Layout )
					return '';
				var Str = '';
				if( args.Layout.preferredSize ){
					if( args.Layout.preferredSize.width && args.Layout.preferredSize.height )
						Str += tab + fullVar + '.preferredSize = [' + args.Layout.preferredSize.width + ',' + args.Layout.preferredSize.height + '];' + PAR;
					else{
						if( args.Layout.preferredSize.width )
							Str += tab + fullVar + '.preferredSize.width = ' + args.Layout.preferredSize.width + ';' + PAR;
						if( args.Layout.preferredSize.height )
							Str += tab + fullVar + '.preferredSize.height = ' + args.Layout.preferredSize.height + ';' + PAR;
						}
					}
				if( TYPE != 'tab' && args.Layout.alignment && (args.Layout.alignment[0] || args.Layout.alignment[1]) )
					Str += tab + fullVar + '.alignment = [\''+args.Layout.alignment[0]+'\', \''+args.Layout.alignment[1]+'\'];' + PAR;
				if( TYPE != 'tabbedpanel' && args.Layout.orientation )
					Str += tab + fullVar + '.orientation = \'' + args.Layout.orientation.toString() + '\';' + PAR;
				if( TYPE != 'tabbedpanel' && args.Layout.alignChildren && (args.Layout.alignChildren[0] || args.Layout.alignChildren[1]) )
					Str += tab + fullVar + '.alignChildren = [\''+args.Layout.alignChildren[0]+'\', \''+args.Layout.alignChildren[1]+'\'];' + PAR;
				if( TYPE != 'tabbedpanel' && args.Layout.margins ){
					var margins = args.Layout.margins[0] == args.Layout.margins[1] && args.Layout.margins[0] == args.Layout.margins[2] && args.Layout.margins[0] == args.Layout.margins[3] ? args.Layout.margins[0] : '['+args.Layout.margins.toString()+']';
					Str += tab + fullVar + '.margins = ' + margins + ';' + PAR;
					}
				if( TYPE != 'tabbedpanel'  ){
					if( script.constructorName(args.Layout.indent, 'number') )
						Str += tab + fullVar + '.indent = ' + args.Layout.indent + ';' + PAR;
					if( script.constructorName(args.Layout.spacing, 'number') )
						Str += tab + fullVar + '.spacing = ' + args.Layout.spacing + ';' + PAR;
					}
				if( args.Layout.title )
					Str += tab + fullVar + '.title = ' + getTitleForCode( args ) + ';' + PAR;
				if( args.Layout.titleLayout ){
					if( args.Layout.titleLayout.alignment && (args.Layout.titleLayout.alignment[0] != SETTINGS.Default.automationLayout.titleAlignment[0] || args.Layout.titleLayout.alignment[0] != SETTINGS.Default.automationLayout.titleAlignment[0]) ){
						Str += tab + fullVar + '.titleLayout.alignment = [\''+
						(args.Layout.titleLayout.alignment[0]?args.Layout.titleLayout.alignment[0]:SETTINGS.Default.automationLayout.titleAlignment[0])+'\', \''+
						(args.Layout.titleLayout.alignment[1]?args.Layout.titleLayout.alignment[1]:SETTINGS.Default.automationLayout.titleAlignment[1])+'\'];' + PAR;
						}
					if( args.Layout.titleLayout.justify )
						Str += tab + fullVar + '.titleLayout.justify = \'' + args.Layout.titleLayout.justify + '\';' + PAR;
					if( args.Layout.titleLayout.margins ){
						var margins = args.Layout.titleLayout.margins[0] == args.Layout.titleLayout.margins[1] && args.Layout.titleLayout.margins[0] == args.Layout.titleLayout.margins[2] && args.Layout.titleLayout.margins[0] == args.Layout.titleLayout.margins[3] ? args.Layout.titleLayout.margins[0] : '['+args.Layout.titleLayout.margins.toString()+']';
						Str += tab + fullVar + '.titleLayout.margins = ' + margins + ';' + PAR;
						}
					if( script.constructorName(args.Layout.titleLayout.spacing, 'number') )
						Str += tab + fullVar + '.titleLayout.spacing = ' + args.Layout.titleLayout.spacing + ';' + PAR;
					if( script.constructorName(args.Layout.titleLayout.characters, 'number') )
						Str += tab + fullVar + '.titleLayout.characters = ' + args.Layout.titleLayout.characters + ';' + PAR;
					if( args.Layout.titleLayout.truncate )
						Str += tab + fullVar + '.titleLayout.truncate = \'' + args.Layout.titleLayout.truncate + '\';' + PAR;
					}
				if( script.constructorName(args.Layout.characters, 'number') )
					Str += tab + fullVar + '.characters = ' + args.Layout.characters + ';' + PAR;
				
				if( args.Layout.maximumSize ){
					if( args.Layout.maximumSize.width && args.Layout.maximumSize.height )
							Str += tab + fullVar + '.maximumSize = [' + args.Layout.maximumSize.width + ',' + args.Layout.maximumSize.height + '];' + PAR;
					else{
						if( args.Layout.maximumSize.width )
							Str += tab + fullVar + '.maximumSize.width = ' + args.Layout.maximumSize.width + ';' + PAR;
						if( args.Layout.maximumSize.height )
							Str += tab + fullVar + '.maximumSize.height = ' + args.Layout.maximumSize.height + ';' + PAR;
						}
					}
				if( args.Layout.minimumSize ){
					if( args.Layout.minimumSize.width && args.Layout.minimumSize.height )
							Str += tab + fullVar + '.minimumSize = [' + args.Layout.minimumSize.width + ',' + args.Layout.minimumSize.height + '];' + PAR;
					else{
						if( args.Layout.minimumSize.width )
							Str += tab + fullVar + '.minimumSize.width = ' + args.Layout.minimumSize.width + ';' + PAR;
						if( args.Layout.minimumSize.height )
							Str += tab + fullVar + '.minimumSize.height = ' + args.Layout.minimumSize.height + ';' + PAR;
						}
					}
				return Str;
				}
			function getTextForCode( args ){
				if( args.textVar && args.text && !PREFS.withoutVariables )
					return args.text;
				else
					return args.text ? '\'' + CORRECTS.correctForCode( args.text ) + '\'' : 'undefined';
				}
			function getTitleForCode( args ){
				if( !args.Layout )
					return  '\'\'';
				if( args.Layout.titleVar && args.Layout.title && !PREFS.withoutVariables )
					return args.Layout.title;
				else
					return args.Layout.title ? '\'' + CORRECTS.correctForCode( args.Layout.title ) + '\'' : 'undefined';
				}
			function declareVariable( args, fullVar ){
				if( PREFS.withoutVariables )
					return;
				//собираем переменные массивов
				if( args.ItemsVar && !args.ItemsArr ){
					vars += args.ItemsVar + ' = [';
					if( args.items && args.items.constructor == Array && args.items.length ){
						for( var j = 0; j < args.items.length-1; j++ )
							vars += '\''+args.items[j].text+'\',';
						vars += '\''+args.items[j].text+'\'';
						}
					vars += '];' + PAR;
					}
				//собираем переменные текстов
				if( args.textVar && args.text )
					vars += args.text + ' = \'\';' + PAR;
				// объявление ф-ции
				if( PREFS.code_createFunctions ){
					if( SUPPORT[args.type]['change'] )
						functs += fullVar + '.onChange = function(){' + PAR + tab + '}' + PAR;
					else if( SUPPORT[args.type]['click'] )
						functs += fullVar + '.onClick = function(){' + PAR + tab + '}' + PAR;
					}
				}
			},
		getAcrobatCode: function( obj, PREFS ){
			try{
			var LIB = this;
			PREFS = PREFS || { varAdd: true, tabCode: true, code_varAsTree: true, code_createFunctions: false };
			var args = this.getClearArgs( { obj: obj, withChildren: true, forOut: true } );
			
			var varsBasa = {}; // база использованых в диалоге ключей - для выявления повторов
			var ids_variables = {}; // объект ключей для замены в тексте кода: {'findKey':'changeKey'}
			var ids_count = 0;
			var dialog_load_object = {};
			var preVariables = {}; // {varName: value}
			var DIALOG = {};
			var functs = {}; // объект функций
			var ok_button_created;
			var description = getElement( args );
			if( !ok_button_created ) // добавляем кнопки, чтобы можно было закрыть диалоговое окно
				description.elements.push( {
					alignment: "align_right",
					type: "ok_cancel",
					ok_name: "Ok",
					cancel_name: "Cancel"
					});
			// собираем диалог
			DIALOG.initialize = eval( "(function(dialog){ // called when dialog created\
				dialog.load( "+script.objectToSource( dialog_load_object ) +");\
				dialog.enable({});\
				})" );
			DIALOG.commit = function(dialog){// called when OK pressed
				var results = dialog.store('itemID');
				};
			for( var i in functs )
				DIALOG[i] = functs[i];
			DIALOG.description = description;
			// out
			var str = '';
			for( var i in preVariables ){
				if( preVariables[i] && preVariables[i].constructor && /(Object|Array)/.test(preVariables[i].constructor.name) )
//				if( preVariables[i] instanceof Object )
					str += 'var '+i+' = '+ script.objectToSource( preVariables[i] ) + ';\r';
				else
					str += 'var '+i+' = '+ preVariables[i] + ';\r';
				}
			str += '\r';
			str += 'var '+args.Var+' = ' + script.objectToSource( DIALOG ) + ';\r';
			str += 'app.execDialog('+args.Var+');';
			// финальная обработка - заменяем вреенные имена на конечные
			for( var i in ids_variables ){
				//alert( i +' --->'+ ids_variables[i] );
				str = str.replace( '"'+i+'"', ids_variables[i] );
				}
			// декодируем от имеющих место эффектов из-за применения uneval()
			return decodeURI( str.replace(/(\t+)/g,'\r') ); // удаляем все табы (с ними не обрабатывается код на http://jsbeautifier.org/)
			// =====================================
			function getElement( args, parentArgs ){
				var object = {};
				// var
				// item_id должен состоять строго из 4 символов
				if( parentArgs ){ // если parentArgs не определен - значит это диалог
					if( args.Var.length < 4 ){
						var _var = args.Var;
						while( _var.length < 4 )
							_var += '_';
						}
					else if( args.Var.length > 4 )
						object.item_id = args.Var.replace( /^(.{4}).+$/,'$1' );
					else
						object.item_id = args.Var;
					if( varsBasa[object.item_id] ){ // если такой ключ уже использовался - изменяем текущий
						var _count = 0;
						while( _count < 1000 ){
							object.item_id = object.item_id.replace(new RegExp('.{'+_count.toString().length+'}$'),_count++);
							if( !varsBasa[object.item_id] )
								break;
							}
						varsBasa[object.item_id] = true;
						}
					}
				// type
				switch( args.type ){
					case 'panel':
					case 'tabbedpanel':
					case 'tab':
						object.type = 'cluster';
						break;
					case 'group':
						if( parentArgs ) // если parentArgs не определен - значит это диалог
							object.type = 'view';
						break;
					case 'button':
						object.type = 'button';
						if( !args.textVar && /^ok$/i.test(args.text) ){
							object.type = 'ok';
							ok_button_created = true;
							}
						break;
					case 'iconbutton':
						object.type = 'button';
						object.name = '['+args.type+']';
						break;
					case 'checkbox':
						object.type = 'check_box';
						break;
					case 'radiobutton':
						object.type = 'radio';
						object.group_id = parentArgs.Var+'_radio';
						break;
					case 'listbox':
						object.type = 'list_box';
						break;
					case 'treeview':
						object.type = 'hier_list_box';
						break;
					case 'statictext':
						object.type = 'static_text';
						break;
					case 'edittext':
						object.type = 'edit_text';
						object.PopupEdit = false;
						object.SpinEdit = false;
						break;
					case 'dropdownlist':
						object.type = 'popup';
						break;
					default: // not support
						object.type = 'static_text';
						object.name = '['+args.type+']';
					}
				// functions
				if( PREFS.code_createFunctions && parentArgs && !/^(cluster|view|static_text)$/.test(object.type) ){ // если parentArgs не определен - значит это диалог
					if( object.type == 'ok' )
						functs[object.item_id] = function(dialog){ dialog.end('ok') };
					else if( object.type == 'button' && /^cancel$/i.test(args.text) )
						functs[object.item_id] = function(dialog){ dialog.end('cancel') };
					else
						functs[object.item_id] = function(dialog){};
					}
				// items
				if( args.type == 'dropdownlist' || args.type == 'listbox' || args.type == 'treeview' ){
					var itemsArray = LIB.getItems( {args: args} );
					if( !itemsArray || !itemsArray.length )
						itemsArray = [{text:'item'},{text:'item1'},{text:'item2'}];
					var itemsObj = convertListItems( itemsArray, true );
					if( args.ItemsVar ){
						var id_variable = '_'+new Date().valueOf()+'_'+(ids_count++);
						ids_variables[id_variable] = args.ItemsVar;
						preVariables[args.ItemsVar] = itemsObj;
						dialog_load_object[object.item_id] = id_variable;
						}
					else
						dialog_load_object[object.item_id] = itemsObj;
					}
				// text
				if( !object.name && SUPPORT[args.type]['text'] && args.text ){ // диалог не поддерживает параметр name (title)
					if( args.textVar ){
						var id_variable = '_'+new Date().valueOf()+'_'+(ids_count++);
						ids_variables[id_variable] = args.text;
						preVariables[args.text] = "''";
						if( args.type == 'edittext' )
							dialog_load_object[object.item_id] = id_variable;
						else
							object.name = id_variable;
						}
					else{
						if( args.type == 'edittext' )
							dialog_load_object[object.item_id] = args.text;
						else
							object.name = args.text;
						}
					}
				// font
				if( args.graphics && args.graphics.font && (args.graphics.font.style || args.graphics.font.size) ){
					// style
					if( /bold/i.test(args.graphics.font.style) ) // Bold, BoldItalic
						object.bold = true;
					else if( args.graphics.font.style == 'Italic' )
						object.italic = true;
					// font size
					if( args.graphics.font.size && args.graphics.font.size < SETTINGS.Default.graphics.font.size )
						object.font = 'palette'; // Palette (small) Font
					}
				// readonly, multiline
				if( args.properties ){
					if( args.properties.readonly )
						object.readonly = true;
					if( args.properties.multiline )
						object.multiline = true;
					}
				if( args.Layout ){
					// size
					if( args.Layout.preferredSize ){
						if( args.Layout.preferredSize.width )
							object.width = args.Layout.preferredSize.width;
						if( args.Layout.preferredSize.height )
							object.height = args.Layout.preferredSize.height;
						}
					// layout
					if( args.Layout.alignment )
						object.alignment = getAlignment( args );
					}
				// children
				if( SUPPORT[args.type]['children'] && args.children && args.children.length ){
					// layout
					object.align_children = getAlignment( args, true, !parentArgs ); // align_children определяем в любом случае
					object.elements = [];
					for( var i = 0; i < args.children.length; i++ )
						object.elements.push( getElement(args.children[i], args) );
					}
				return object;
				}
			function convertListItems( itemsArray, isStart ){ // return object of items
				if( !this.idNum || isStart ) this.idNum = 1;
				var toObj = {};
				for( var z = 0; z <itemsArray.length; z++ ){
					if( itemsArray[z].subItems && itemsArray[z].subItems.length )
						toObj[itemsArray[z].text] = convertListItems( itemsArray[z].subItems );
					else
						toObj[itemsArray[z].text] = this.idNum++;
					}
				return toObj;
				}
			function getAlignment( args, forChildren, isWindow ){
				// INI
				if( args.Layout && args.Layout.alignment && args.Layout.alignment[0] == 'fill' && args.Layout.alignment[1] == 'fill' )
					return 'align_offscreen';
				// alignment
				var this_align = 'left'; // default
				if( !forChildren )
					var this_align = args.Layout && args.Layout.alignment ? args.Layout.alignment[0] : this_align; // используем только значение по ширине
				else
					var this_align = args.Layout && args.Layout.alignChildren ? args.Layout.alignChildren[0] : this_align; // используем только значение по ширине
				// orientation
				var this_orientation = 'column';
				if( args.Layout && args.Layout.orientation )
					this_orientation = args.Layout.orientation.toString();
				else if( args.type == 'group' && !isWindow )
					this_orientation = 'row';
				// EXE
				if( this_orientation == 'row' ){
					if( this_align == 'fill' )
						return 'align_fill';
					else
						return 'align_row'; // align_distribute
					}
				else{
					switch( this_align ){
						case 'left':
							return 'align_left';
							break;
						case 'right':
							return 'align_right';
							break;
						case 'fill':
							return 'align_fill';
							break;
						case 'center':
							return 'align_center';
							break;
						default:
							return 'align_left';
						}
					}
				}
			}catch(err){script.alertError(err); return ''; }
			},
		showCode: function( fullCode, automationLayout ){
			var obj = this.getSelectedObject();
			var code = this.getCode( (fullCode ? obj.project : obj), { varAdd: OUTPUT_SETTINGS.varAdd, tabCode: OUTPUT_SETTINGS.tabCode, code_varAsTree: OUTPUT_SETTINGS.code_varAsTree, code_createFunctions: OUTPUT_SETTINGS.code_createFunctions, automationLayout: automationLayout } );
			if( code )
				script.getReportWindow( code, 'Code', false, 600 );
			},
		showCodePlus: function( automationLayout ){
			var prefs = {};
			var LIB = this;
			var quickSettings = new Window("dialog", 'Output. Quick settings');
			quickSettings.preferredSize = [300,100];
			quickSettings.alignChildren = ['left', 'top'];
			quickSettings.margins = 10;
			quickSettings.spacing = 5;
			with(quickSettings){
				quickSettings.createFunctions = add( "checkbox", undefined, 'to create functions for objects' );
				quickSettings.code_Var = add( "checkbox", undefined, 'to declare variables through \'var\'' );
				quickSettings.varAsTree = add( "checkbox", undefined, 'tree variables' );
				quickSettings.tabLevels = add( "checkbox", undefined, 'to tabulate levels' );
				quickSettings.acrobatCode = add( "button", undefined, 'Get Acrobat code' );
				quickSettings.Ok = add( "button", undefined, 'OK' );
				quickSettings.Ok.alignment = ['right', 'top'];
				}
			
			quickSettings.createFunctions.value = OUTPUT_SETTINGS.code_createFunctions ? true : false;
			quickSettings.code_Var.value = OUTPUT_SETTINGS.varAdd ? true : false;
			quickSettings.varAsTree.value = OUTPUT_SETTINGS.code_varAsTree ? true : false;
			quickSettings.tabLevels.value = OUTPUT_SETTINGS.tabCode ? true : false;
			
			quickSettings.acrobatCode.onClick = function(){
				this.window.close();
				var obj = LIB.getSelectedObject();
				var code = LIB.getAcrobatCode( obj.project, { code_createFunctions: quickSettings.createFunctions.value } );
				if( code )
					script.getReportWindow( code, 'Code', false, 600 );
				}
			quickSettings.Ok.onClick = function(){
				this.window.close();
				var obj = LIB.getSelectedObject();
				var code = LIB.getCode( obj.project, { varAdd: quickSettings.code_Var.value, tabCode: quickSettings.tabLevels.value, code_varAsTree: quickSettings.varAsTree.value, code_createFunctions: quickSettings.createFunctions.value, automationLayout: automationLayout } );
				if( code )
					script.getReportWindow( code, 'Code', false, 600 );
				}
			quickSettings.center();
			quickSettings.show();
			},
		testCode: function( automationLayout ){
			try{
			var code = this.getCode( this.getSelectedObject().project, { varAdd: true, tabCode: true, code_varAsTree: true, code_createFunctions: false, withoutVariables: true, automationLayout: automationLayout } );
			if( code )
				eval( code );
			}catch(err){
				code = code.split(/[\r\n]/);
				for( var i = 0; i < code.length; i++ )
					code[i] = (i+1) + '\t' +code[i];
				script.getReportWindow( code.join('\r'), 'ERROR! '+err+' (Line: '+err.line+')', false, 600 );
				}
			},
		// ИНИЦИАЛИЗАЦИЯ
		initVarsBasa: function(){
			this.VarsBasa = {};
			for( var i in PREFERRED_NAMES )
				this.VarsBasa[PREFERRED_NAMES[i]] = true;
	//		for( var i in SUPPORT )
	//			LIB.VarsBasa[SUPPORT[i]['Var']] = true;
			},
		init: function(){
			//script.consol( 'init()' );
			var LIB = this;
			//===================================================================================================
			this.initVarsBasa();
			//===================================================================================================
			//для WORKS.testFontName()
			WORKS.testFontNameObject = win.add('statictext', [0,0,20,60], 'zzz');
			WORKS.testFontNameObject.visible = false;
			//===================================================================================================
			for( var i = 0; i < SETTINGS.projectsCount; i++ ){
				win.builder.listsbox.add(SETTINGS.explorerType, [0,0,win.builder.listsbox.size[0],win.builder.listsbox.size[1]], undefined );
				win.builder.listsbox.children[i].visible = false;
				script.addDynamicObject( { obj: win.builder.listsbox.children[i], moveCoefs: false, resizeCoefs: [1,1], isSeparator: false } );
				}
			//===================================================================================================
			var lightboxColor = APP_SETTINGS.highlightColor ? APP_SETTINGS.highlightColor : SETTINGS.lightboxColor;
			with(win.lightbox) graphics.backgroundColor = graphics.newBrush( graphics.BrushType.SOLID_COLOR, [SETTINGS.lightboxColor[0]/255, SETTINGS.lightboxColor[1]/255, SETTINGS.lightboxColor[2]/255, 1] );
			win.projects = [];
			for( var i = 0; i < SETTINGS.projectsCount; i++ ){
				win.projects[i] = win.lightbox.add("group", [0,0,SETTINGS.projectSize[0],SETTINGS.projectSize[1]], undefined, {name:i});
				win.projects[i].size = SETTINGS.projectSize;
				win.projects[i].slotIndex = i;
				script.addColor( win.projects[i], 0, SETTINGS.Default.graphics.backgroundColor.color );
				script.addMouseMove( { target: win.projects[i], direction: [1,1],  withFunct: false, notMoveTarget: false } ); 
				win.projects[i].visible = false;
				win.projects[i].saved = false;
				win.projects[i].watch('saved', project_saved_Listener);
				}
			function project_saved_Listener(){
				try{
				if( !arguments[1] || arguments[2] )
					return;
				if( this.file )
					this.projectsListItem.text = '['+this.projectsListItem.text+']';
				}catch(err){}
				}	
			function lightboxHandler(e){
				if( e.button != 0 ) // only left button
					return;
				if( e.target != win.lightbox && e.target != LIB.getSelectedObject() )
					LIB.setCurrentObject( e.target );
				}
			win.lightbox.addEventListener('mousedown', lightboxHandler);
			//===================================================================================================
			//===================================================================================================
			try{
			this.Select_init();
			this.moveListItem_init();
			this.Type_init();
			this.Properties_init();
			this.Var_init();
			this.Name_init();
			this.Location_init();
			this.Size_init();
			this.Visible_init();
			this.HelpTip_init();
			this.Text_init();
			this.Items_init();
			this.Font_init();
			this.Image_init();
			this.ShortcutKey_init();
			this.GroupLocation_init();
			this.Layout_init();
			this.Dynamic_init();
			//===================================================================================================
			//===================================================================================================
			function isSelected(){ return LIB.currentProject ? true : false }
			function isSelectedWithFile(){ return LIB.currentProject ? (LIB.currentProject.file ? true : false) : false }
			function notSaved(){ return LIB.currentProject ? (LIB.currentProject.saved ? false : true) : false }
			
			function isSelectedObject(){ return LIB.getSelectedObject() };
			function isSelectedObjectNotWindow(){ return LIB.getSelectedObject() && !LIB.isWindow(LIB.getSelectedObject()) };
			//===================================================================================================
			// контекстное меню projects
			function saveAsProject(){ LIB.saveProject(LIB.currentProject, true) }
			var contextMenuItems = [
				// LIB.setProject некорректно работает при вызове отсюда, видимо из-за того что главное окно на заднем плане и поэтому неправильно активируется новый проект (проблемы с enabled)
	//			{ name: script.localize("New..."), action: function(){LIB.setProject()}, activation: true, notCloseMenu: false, image: script.getInDesignIcon( 'UI/(CommandBar Resources)/idrc_PNGA/300.idrc' ) }, 
	//			{}, //empty separator
				{ name: script.localize("Save"), action: function(){LIB.saveProject(LIB.currentProject)}, activation: notSaved, notCloseMenu: false, image: script.getInDesignIcon( 'UI/(CommandBar Resources)/idrc_PNGA/302.idrc' ) },
				{ name: script.localize("Save As..."), action: saveAsProject, activation: isSelected, notCloseMenu: false, image: script.getInDesignIcon( '' ) },
				{ name: script.localize("Close"), action: closeProject, activation: isSelected, notCloseMenu: false, image: script.getInDesignIcon( '' ) },
				script.separatorMenuItem,
				{ name: script.localize("Open project folder"), action: function(){LIB.currentProject.file.parent.execute()}, activation: isSelectedWithFile, notCloseMenu: false, image: script.getInDesignIcon( 'XMedia/(XMedia UI Resources)/idrc_PNGA/272.idrc' ) },
				{ name: script.localize("Code"), action: function(){LIB.showCode( true )}, activation: isSelectedObject, notCloseMenu: false, image: script.getInDesignIcon( 'Script/(Support for Visual Basic Resources)/idrc_PNGA/129.idrc' ) },
				{ name: script.localize("Code+"), action: function(){ LIB.showCodePlus()}, activation: isSelectedObject, notCloseMenu: false, image: script.getInDesignIcon( '' ) },
				{ name: script.localize("Test"), action: function(){LIB.testCode()}, activation: isSelectedObject, notCloseMenu: false, image: script.getInDesignIcon( 'Interactive/(ButtonUI Resources)/idrc_PNGA/1513.idrc' ) },
				];
			script.addContextMenu( { target: win.builder.projects, menuItems: contextMenuItems,  preAction: false } ); // palette: false,
			//===================================================================================================
			// контекстное меню listsbox
			function isMovedListItem(){ 
				if( isSelectedObjectNotWindow() ){ 
					var listItem = LIB.getSelectedObject().listItem; 
					return listItem.type == 'node' && listItem.items.length ? false : true 
					}; 
				return false ;
				};
			function copyChildren( cut ){ // cut === true
				var obj = LIB.getSelectedObject();
				LIB.buffer = [];
				var childs = LIB.getChildrenArray( obj );
				for( var i = childs.length-1; i >-1; i-- ){
					LIB.buffer.unshift( LIB.getClearArgs( { obj: childs[i], withChildren: true } ) );
					if( cut === true )
						LIB.deleteObject( { obj: childs[i], withoutConfirm: true, notSelectParentOfCurrentObject: true } );
					}
				}
			function copyChildrenActivation(){
				var obj = LIB.getSelectedObject();
				return obj && LIB.isContainer( obj ) && obj.children && obj.children.length;
				}
			function pasteFromClipboard(){
				var parent = LIB.getSelectedObject();
				if( LIB.buffer.constructor == Array )
					for( var i = 0; i < LIB.buffer.length; i++ )
						LIB.setObject( false, LIB.buffer[i], { select: false, parent: parent } );
				else
					LIB.setObject( false, LIB.buffer, { select: true, parent: parent } );
				parent.project.saved = false;
				}
			function pasteActivation(){
				return LIB.buffer && LIB.isContainer(LIB.getSelectedObject());
				}
			//===================================================================================================
			// контекстное меню objects
			function duplicateSelectedObject( direction ){
				var obj = LIB.getSelectedObject();
				var newLocation = direction ? [obj.location[0], obj.bounds[3]+AUTO_SETTINGS.autoIndent[1]] :  [obj.bounds[2]+AUTO_SETTINGS.autoIndent[0], obj.location[1]];
				var args = LIB.getClearArgs( { obj: obj, withChildren: true } );
				LIB.setObject( false, args, {select:true, parent: obj.parent} );
				LIB.Location( LIB.getSelectedObject(), {location: newLocation}, true ); // obj, args, fitParentToContent
				obj.project.saved = false;
				}
			function fitToContentActivation(){
				var obj = LIB.getSelectedObject();
				return obj && ( (LIB.isContainer(obj) && obj.children.length) || LIB.containsImage(obj) );
				}
			function fitToContentAction(){
				var obj = LIB.getSelectedObject();
				if(LIB.isContainer(obj) )
					LIB.fitToContent(LIB.getSelectedObject(), [true,true]);
				// image и iconbutton
				else if(LIB.containsImage(obj) ){
					var padding = obj.type == 'image' ? [0,0] : [5,5];
					LIB.Size( obj, {size: [obj.image.size[0]+padding[0],obj.image.size[1]+padding[1]]}, true );
					}
				else
					return;
				obj.project.saved = false;
				}
			function moveToEdgeSelectedObject( direction ){ // сдвинуть к краю, direction = top / bottom / left / right
				try{
				var userAutoLocation = LAYOUT_SETTINGS.autoLocation;
				LAYOUT_SETTINGS.autoLocation = false;
				var obj = LIB.getSelectedObject();
				var newLocation = [obj.location[0], obj.location[1]];
				var directions = [false, false];// направление для fitToContent
				switch( direction ){
					case 'top':
						newLocation[1] = 0 + (!LIB.isWindow(obj.parent) && obj.parent.type=='group' ? 0 : AUTO_SETTINGS.autoIndent[1]);
						directions[1] = true;
					break;
					case 'bottom':
						newLocation[1] = obj.parent.size[1] - obj.size[1] - (!LIB.isWindow(obj.parent) && obj.parent.type=='group' ? 0 : AUTO_SETTINGS.autoIndent[1]+5);
						directions[1] = true;
						if( newLocation[1] < 0 )
							newLocation = false;
					break;
					case 'left':
						newLocation[0] = 0 + AUTO_SETTINGS.autoIndent[0];
						directions[0] = true;
					break;
					case 'right':
						newLocation[0] = obj.parent.size[0] - obj.size[0] - (!LIB.isWindow(obj.parent) && obj.parent.type=='group' ? 0 : AUTO_SETTINGS.autoIndent[0]+5);
						directions[0] = true;
						if( newLocation[0] < 0 )
							newLocation = false;
					break;
					case 'center':
						newLocation[0] = obj.parent.size[0]/2 - obj.size[0]/2;
						directions[0] = true;
						if( newLocation[0] < 0 )
							newLocation = false;
					break;
					}
				if( newLocation ){
					LIB.Location( obj, {location: newLocation} );
					obj.project.saved = false;
					}
				}catch(err){}
				finally{
					if( !newLocation )
						return;
					LAYOUT_SETTINGS.autoLocation = userAutoLocation;
					if( LAYOUT_SETTINGS.autoFitToContent ) 
						LIB.fitToContent( obj.parent, directions )
					}
				}
			// Copy Image
			function isContainsImage(){ 
				var obj = LIB.getSelectedObject();
				if( !obj )
					return false;
				return LIB.containsImage(obj) || (SUPPORT[obj.type]['items'] && obj.selection && obj.selection.image && obj.selection.image != script.images.zero && obj.selection.image.pathname != script.images.zero.pathname) ? true : false;
				};
			function canPasteImage(){ 
				var obj = LIB.getSelectedObject();
				return LIB.imageBuffer && (SUPPORT[obj.type]['image'] || (SUPPORT[obj.type]['items'] && obj.selection)) ? true : false;
				};
			function cutImage(){
				var obj = LIB.getSelectedObject();
				if( !obj )
					return false;
				LIB.imageBuffer = SUPPORT[obj.type]['items'] ? { pathname: obj.selection.image.pathname } : { pathname: obj.image.pathname };
				SUPPORT[obj.type]['items'] ? obj.selection.image = script.images.zero : obj.image = script.images.zero;
				}
			function copyImage(){
				try{
					var obj = LIB.getSelectedObject();
					LIB.imageBuffer = SUPPORT[obj.type]['items'] ? { pathname: obj.selection.image.pathname } : { pathname: obj.image.pathname };
				}catch(err){}
				}
			function pasteImage(){
				try{
					var obj = LIB.getSelectedObject();
					SUPPORT[obj.type]['items'] ? obj.selection.image = File(LIB.imageBuffer.pathname) : obj.image = File(LIB.imageBuffer.pathname);
					obj.project.saved = false;
				}catch(err){ LIB.alertError(err) }
				}
			
			
			var contextMenuItems = {
				Cut: { name: script.localize("Cut"), action: function(){LIB.buffer = LIB.getClearArgs({obj: LIB.getSelectedObject(), withChildren:true}); LIB.deleteObject( { obj: LIB.getSelectedObject(), withoutConfirm: true, notSelectParentOfCurrentObject: false } )}, activation: isSelectedObjectNotWindow, notCloseMenu: false, image: script.getInDesignIcon( 'UI/(CommandBar Resources)/idrc_PNGA/311.idrc' ) },
				CutChildren: { name: script.localize("Cut children"), action: function(){ copyChildren(true); }, activation: copyChildrenActivation, notCloseMenu: false },
				Copy: { name: script.localize("Copy"), action: function(){LIB.buffer = LIB.getClearArgs({obj: LIB.getSelectedObject(), withChildren:true})}, activation: isSelectedObject, notCloseMenu: false, image: script.getInDesignIcon( 'UI/(CommandBar Resources)/idrc_PNGA/310.idrc' ) },
				CopyChildren: { name: script.localize("Copy children"), action: copyChildren, activation: copyChildrenActivation, notCloseMenu: false },
				Paste: { name: script.localize("Paste"), action: pasteFromClipboard, activation: pasteActivation, notCloseMenu: false, image: script.getInDesignIcon( 'Tables/(TableStylesUI Resources)/idrc_PNGA/300.idrc' ) },
				Delete: { name: script.localize("Delete"), action: function(){LIB.deleteObject( {obj: LIB.getSelectedObject(), withoutConfirm: true, notSelectParentOfCurrentObject: false}) }, activation: isSelectedObjectNotWindow, notCloseMenu: false, image: script.getInDesignIcon( 'Text/(Find and Change Panel Resources)/idrc_PNGA/113.idrc' ) },
				//==
				"Duplicate to right": { name: script.localize("Duplicate to right"), action: function(){ duplicateSelectedObject(0) }, activation: isSelectedObjectNotWindow, notCloseMenu: false, image: script.getInDesignIcon( 'InCopyWorkflow/(Note Resources)/idrc_PNGA/308.idrc' ) },
				"Duplicate down": { name: script.localize("Duplicate down"), action: function(){ duplicateSelectedObject(1) }, activation: isSelectedObjectNotWindow, notCloseMenu: false, image: script.getInDesignIcon( 'InCopyWorkflow/(Note Resources)/idrc_PNGA/309.idrc' ) },
				"Fit to content": { name: script.localize("Fit to content"), action: fitToContentAction, activation: fitToContentActivation, notCloseMenu: false, image: script.getInDesignIcon( 'Interactive/(ButtonUI Resources)/idrc_PNGA/2904.idrc' ) },
				"Fill on width parent": { name: script.localize("Fill on width parent"), action: function(){ LIB.fill(LIB.getSelectedObject(), 0) }, activation: isSelectedObjectNotWindow, notCloseMenu: false, image: script.getInDesignIcon( 'Layout/(Control Panel Resources)/idrc_PNGA/2033.idrc' ) },
				"Fill on height parent": { name: script.localize("Fill on height parent"), action: function(){ LIB.fill(LIB.getSelectedObject(), 1) }, activation: isSelectedObjectNotWindow, notCloseMenu: false, image: script.getInDesignIcon( 'Layout/(Control Panel Resources)/idrc_PNGA/2008.idrc' ) },
				//==fill: function( obj, direction ){//растянуть, direction: 0=ширина / 1=высота
				"Move up": { name: script.localize("Move up"), action: function(){ moveToEdgeSelectedObject('top') }, activation: isSelectedObjectNotWindow, notCloseMenu: false, image: script.getInDesignIcon( 'Layout/(Text Wrap Panel Resources)/idrc_PNGA/134.idrc' ) },
				"Move down": { name: script.localize("Move down"), action: function(){ moveToEdgeSelectedObject('bottom') }, activation: isSelectedObjectNotWindow, notCloseMenu: false, image: script.getInDesignIcon( 'Layout/(Text Wrap Panel Resources)/idrc_PNGA/135.idrc' ) },
				"Move left": { name: script.localize("Move left"), action: function(){ moveToEdgeSelectedObject('left') }, activation: isSelectedObjectNotWindow, notCloseMenu: false, image: script.getInDesignIcon( 'Layout/(Text Wrap Panel Resources)/idrc_PNGA/136.idrc' ) },
				"Move right": { name: script.localize("Move right"), action: function(){ moveToEdgeSelectedObject('right') }, activation: isSelectedObjectNotWindow, notCloseMenu: false, image: script.getInDesignIcon( 'Layout/(Text Wrap Panel Resources)/idrc_PNGA/137.idrc' ) },
				"Move center": { name: script.localize("Move center"), action: function(){ moveToEdgeSelectedObject('center') }, activation: isSelectedObjectNotWindow, notCloseMenu: false },
				//==
	//			"Move up list": { name: script.localize("Move up list"), action: function(){ LIB.moveListItem( -1 ) }, activation: isMovedListItem, notCloseMenu: true, image: script.getInDesignIcon( 'Layout/(Index Panel Resources)/idrc_PNGA/173.idrc' ) },
	//			"Move down list": { name: script.localize("Move down list"), action: function(){ LIB.moveListItem( 1 ) }, activation: isMovedListItem, notCloseMenu: true, image: script.getInDesignIcon( 'Layout/(Index Panel Resources)/idrc_PNGA/172.idrc' ) },
				//==
				"Cut image": { name: script.localize("Cut image"), action: cutImage, activation: isContainsImage, notCloseMenu: false, image: script.getInDesignIcon( 'UI/(CommandBar Resources)/idrc_PNGA/311.idrc' ) },
				"Copy image": { name: script.localize("Copy image"), action: copyImage, activation: isContainsImage, notCloseMenu: false, image: script.getInDesignIcon( 'UI/(CommandBar Resources)/idrc_PNGA/310.idrc' ) },
				"Paste image": { name: script.localize("Paste image"), action: pasteImage, activation: canPasteImage, notCloseMenu: false, image: script.getInDesignIcon( 'Tables/(TableStylesUI Resources)/idrc_PNGA/300.idrc' ) },
				//==
				Code: { name: script.localize("Code"), action: function(){LIB.showCode()}, activation: isSelectedObject, notCloseMenu: false, image: script.getInDesignIcon( 'Script/(Support for Visual Basic Resources)/idrc_PNGA/129.idrc' ) },
	//			Uneval: { name: script.localize("uneval"), action: function(){ script.getReportWindow( uneval(LIB.getSelectedObject()), 'Code', false, 600 ); }, activation: isSelectedObject, notCloseMenu: false, image: script.getInDesignIcon( 'Script/(Support for Visual Basic Resources)/idrc_PNGA/129.idrc' ) },
	//			ToSource: { name: script.localize("ToSource"), action: function(){ script.getReportWindow( LIB.getSelectedObject().toSource(), 'Code', false, 600 ); }, activation: isSelectedObject, notCloseMenu: false, image: script.getInDesignIcon( 'Script/(Support for Visual Basic Resources)/idrc_PNGA/129.idrc' ) },
				Test: { name: script.localize("Test"), action: function(){LIB.testCode()}, activation: isSelectedObject, notCloseMenu: false, image: script.getInDesignIcon( 'Interactive/(ButtonUI Resources)/idrc_PNGA/1513.idrc' ) },
				};
			script.addContextMenu( {
				target: win.builder.listsbox, 
				menuItems: [
					contextMenuItems.Cut,
					contextMenuItems.CutChildren,
					contextMenuItems.Copy,
					contextMenuItems.CopyChildren,
					contextMenuItems.Paste,
					contextMenuItems.Delete,
	//				script.separatorMenuItem,
	//				contextMenuItems["Move up list"],
	//				contextMenuItems["Move down list"],
					script.separatorMenuItem,
					contextMenuItems.Code,
					contextMenuItems.Test
					],
				palette: false, 
				preAction: false 
				} );
			script.addContextMenu( {
				target: win.lightbox,
				menuItems: [
					contextMenuItems.Cut,
					contextMenuItems.CutChildren,
					contextMenuItems.Copy,
					contextMenuItems.CopyChildren,
					contextMenuItems.Paste,
					contextMenuItems.Delete,
					script.separatorMenuItem,
					contextMenuItems["Duplicate to right"],
					contextMenuItems["Duplicate down"],
					contextMenuItems["Fit to content"],
					contextMenuItems["Fill on width parent"],
					contextMenuItems["Fill on height parent"],
					script.separatorMenuItem,
					contextMenuItems["Move up"],
					contextMenuItems["Move left"],
					contextMenuItems["Move center"],
					contextMenuItems["Move right"],
					contextMenuItems["Move down"],
					script.separatorMenuItem,
					contextMenuItems["Cut image"],
					contextMenuItems["Copy image"],
					contextMenuItems["Paste image"],
					script.separatorMenuItem,
					contextMenuItems.Code,
	//				contextMenuItems.Uneval,
	//				contextMenuItems.ToSource,
					contextMenuItems.Test
					],
				palette: false, 
				preAction: preAction_lightbox 
				} );
			function preAction_lightbox( EVENT ){
				LIB.setCurrentObject( EVENT.target );
				return true;
				}
			//===================================================================================================
			win.builder.del.onClick = function(){
				var obj = LIB.getSelectedObject();
				if( obj && !LIB.isWindow(obj) )
					LIB.deleteObject( {obj: obj, withoutConfirm: false, notSelectParentOfCurrentObject: false});
				}
			//===================================================================================================
			//  MENU
			//===================================================================================================
			function getMenuList(){
				var menuItems = ['New...', '-', 'Open', 'Close', 'Save', 'Save as...', '-' ];
				if( APP_SETTINGS.recentProjectsList )
					menuItems.push( 'Recent documents', '', '', '', '', '-' );
				menuItems.push( 'Options', 'Info', '-', 'Exit' );
				return menuItems;
				}
			win.builder.menu = win.builder.add( "dropdownlist", [0,0,win.builder.size[0],22], undefined, {items: getMenuList() } );
			script.addDynamicObject( { obj: win.builder.menu, moveCoefs: false, resizeCoefs: [1,0], isSeparator: false } );
			// берем дефолтовое значение для настроек
			if( win.builder.menu.itemSize && win.builder.menu.itemSize[1] )
				SETTINGS.Default.itemSize[1] = win.builder.menu.itemSize[1];
			if( win.builder.projects.itemSize && win.builder.projects.itemSize[1] )
				SETTINGS.Default.itemSize_EmptyList[1] = win.builder.projects.itemSize[1];
			
			// Recent documents ============================
			var MENU = win.builder.menu;
			var recentDocuments = {
				serviceInitialized: false,
				INIT: function( recentDocItems ){
					if( !recentDocItems )
						return;
					this.recentDocItems = recentDocItems;
					// подгружаем из прошлой сесси
					var recentDocs_LastSession = script.userPrefs( 'recentDocuments' );
					script.userPrefs( 'recentDocuments', false ); // и сразу удаляем
					this.serviceInitialized = true;
					if( recentDocs_LastSession && recentDocs_LastSession.length ){
						for( var i = recentDocs_LastSession.length-1; i > -1; i-- ) // удаляем ненайденые
							if( !File(recentDocs_LastSession[i]).exists )
								recentDocs_LastSession.splice( i, 1 );
						for( var i = 0; i < this.recentDocItems.length; i++ ){
							if( recentDocs_LastSession[i] )
								this.writeRecentDocument( this.recentDocItems[i], File(recentDocs_LastSession[i]) );
							else break;
							}
						}
					},
				writeRecentDocument: function( item, file ){ // внутрення ф-ция
					item.file = file;
					item.text = '   ' + script.getNameOnly(item.file)/*.replace(/^(.{40}).+$/,'$1...')*/;
					},
				pushRecentDocument: function( file ){
					if( this.serviceInitialized && file.exists ){
						if( this.recentDocItems[0].file == file )
							return;
						for( var i = this.recentDocItems.length-1; i > 0; i-- ) // процеду на условии, что единовременно в массиве может быть только один дубль файла
							if( this.recentDocItems[i-1].file && this.recentDocItems[i-1].file != file )
								this.writeRecentDocument( this.recentDocItems[i], this.recentDocItems[i-1].file );
						this.writeRecentDocument( this.recentDocItems[0], file );
						}
					},
				rememberRecentDocuments: function(){
					if( !this.serviceInitialized )
						return;
					var res = [];
					for( var i = 0; i < recentDocItems.length; i++ )
						if( recentDocItems[i].file )
							res.push( recentDocItems[i].file );
					if( res.length )
						script.userPrefs( 'recentDocuments', res );
					},
				}
			if( APP_SETTINGS.recentProjectsList ){
				var _tittle = MENU.find('Recent documents');
				_tittle.enabled = false;
				var recentDocItems = [];
				for( var i = _tittle.index+1; i < MENU.items.length; i++ )
					if( MENU.items[i].text ) break; else recentDocItems.push(MENU.items[i]);
				recentDocuments.INIT( recentDocItems );
				}
			function closeProject(){
				if( LIB.currentProject ){
					var file = LIB.currentProject.file ? LIB.currentProject.file : false;
					LIB.closeProject( LIB.currentProject );
					if( APP_SETTINGS.recentProjectsList && file && file != LIB.currentProject.file ) // если закрытие произошло
						 recentDocuments.pushRecentDocument( file );
					}
				}
			// Menu handler ==============================
			MENU.onChange = function(){
				if( this.selection.file ){
					if( this.selection.file.exists )
						LIB.setProject( {file: this.selection.file} );
					else
						alert( script.localize('File not found') + ':\r' + this.selection.file.fsName );
					}
				else
					switch( this.selection.text ){
						case 'New...':
							LIB.setProject();
						break;
						case 'Open':
							LIB.openProject();
						break;
						case 'Close':
							closeProject();
						break;
						case 'Save':
							if( LIB.currentProject )
								LIB.saveProject( LIB.currentProject );
						break;
						case 'Save as...':
							if( LIB.currentProject )
								saveAsProject();
						break;
						case 'Options':
							pref();
						break;
						case 'Info':
							script.getWinInfo();
						break;
						case 'Exit':
							this.window.close();
							exit();
						break;
						}
				this.selection = null;
				}
			//=================================================================
			//=================================================================
			win.builder.projects.onChange = function(){
				if( !LIB.selectingStatus )
					LIB.setCurrentProject( this.selection.project );
				}
			//=================================================================
			//=================================================================
			// accuracy
			win.obj.Global.Points.accuracy.onClick = win.obj.Controls.moveChildren.accuracy.onClick = function(){
				SETTINGS.accuracy = win.obj.Global.Points.accuracy.value = win.obj.Controls.moveChildren.accuracy.value = this.value;
				}
			// Global / Local / Dynamic / Layout
			win.obj.but_Global.onClick = win.obj.but_Local.onClick = win.obj.but_Layout.onClick = win.obj.but_Dynamic.onClick = function(){
				win.obj.but_Global.enabled = win.obj.but_Local.enabled = win.obj.but_Layout.enabled = win.obj.but_Dynamic.enabled = true;
				win.obj.Global.visible = win.obj.Local.visible = win.obj.Layout.visible = win.obj.Dynamic.visible = false;
				win.obj[this.properties.name.replace(/_/g,'')].visible = true;
				win.obj.Controls.visible = !win.obj.Layout.visible;
				this.enabled = false;
				LIB.setObject( LIB.getSelectedObject() );
				}
			script.addGroupListener( { objs: [win.obj.Global, win.obj.Local, win.obj.Layout, win.obj.Dynamic, win.obj.Controls.moveChildren], listener: Edit_Listener } );
			function Edit_Listener(e){
				var obj = LIB.getSelectedObject_forInterface();
				if( !obj || !obj.project.saved )
					return;
				obj.project.saved = false;
				}
			win.obj.but_Global.onClick();// показываем
			// addObject
			win.obj.addObject.selection = 0;
			win.obj.addObject.onChange = function(){
				if( !this.selection || !this.selection.index )// если выделен первый пункт (название меню) - пропускаем
					return;
				var parent = LIB.currentProject ? LIB.currentProject.currentObject : LIB.setProject();
				if( parent ){
					LIB.setObject(false, {type:this.selection.text}, {select:true, parent: parent});
					parent.project.saved = false;
					}
				this.selection = 0;
				}
			// Move children / Auto Layout
			win.obj.Controls.but_moveChildren.onClick = win.obj.Controls.but_autoLayout.onClick = function(){
				 win.obj.Controls.but_autoLayout.enabled = win.obj.Controls.moveChildren.visible = ( this.text == 'Move children' );
				 win.obj.Controls.but_moveChildren.enabled = win.obj.Controls.autoLayout.visible = ( this.text == 'Auto Layout' );
				}
			if( script.userPrefs('viewMoveChildren') )
				win.obj.Controls.but_moveChildren.onClick();
			else
				win.obj.Controls.but_autoLayout.onClick();
			
			win.obj.Controls.autoLayout.autofitWindowProject.value = LAYOUT_SETTINGS.autofitWindowProject ? true : false;
			win.obj.Controls.autoLayout.autofitWindowProject.enabled = LAYOUT_SETTINGS.autoFitToContent ? false : true;
			win.obj.Controls.autoLayout.autoFitToContent.value = LAYOUT_SETTINGS.autoFitToContent ? true : false;
			win.obj.Controls.autoLayout.autoLocation.value = LAYOUT_SETTINGS.autoLocation ? true : false;
			win.obj.Controls.autoLayout.autoLocationWithinIndent.value = LAYOUT_SETTINGS.autoLocationWithinIndent ? true : false;
			win.obj.Controls.autoLayout.autoLocation_restoreIndent.value = LAYOUT_SETTINGS.autoLocation_restoreIndent ? true : false;
			
			win.obj.Controls.autoLayout.autoLocationWithinIndent.enabled = win.obj.Controls.autoLayout.autoLocation.value;
			win.obj.Controls.autoLayout.autoLocation_restoreIndent.enabled = win.obj.Controls.autoLayout.autoLocationWithinIndent.value && win.obj.Controls.autoLayout.autoLocationWithinIndent.enabled;
			
			win.obj.Controls.autoLayout.autofitWindowProject.onClick = function(){
				LAYOUT_SETTINGS.autofitWindowProject = this.value;
				SETTINGS.saveLayoutSettings = true;
				}
			win.obj.Controls.autoLayout.autoFitToContent.onClick = function(){
				LAYOUT_SETTINGS.autoFitToContent = this.value;
				if( this.value ){
					win.obj.Controls.autoLayout.autofitWindowProject.enabled = false;
					win.obj.Controls.autoLayout.autofitWindowProject.value = LAYOUT_SETTINGS.autofitWindowProject = true;
					}
				else
					win.obj.Controls.autoLayout.autofitWindowProject.enabled = true;
				SETTINGS.saveLayoutSettings = true;
				}
			win.obj.Controls.autoLayout.autoLocation.onClick = function(){
				LAYOUT_SETTINGS.autoLocation = win.obj.Controls.autoLayout.autoLocationWithinIndent.enabled = this.value;
				if( !this.value )
					win.obj.Controls.autoLayout.autoLocation_restoreIndent.enabled = false;
				else if( win.obj.Controls.autoLayout.autoLocationWithinIndent.value )
					win.obj.Controls.autoLayout.autoLocation_restoreIndent.enabled = true;
				SETTINGS.saveLayoutSettings = true;
				}
			win.obj.Controls.autoLayout.autoLocationWithinIndent.onClick = function(){
				LAYOUT_SETTINGS.autoLocationWithinIndent = this.value;
				win.obj.Controls.autoLayout.autoLocation_restoreIndent.enabled = this.value && this.enabled;
				SETTINGS.saveLayoutSettings = true;
				}
			win.obj.Controls.autoLayout.autoLocation_restoreIndent.onClick = function(){
				LAYOUT_SETTINGS.autoLocation_restoreIndent = this.value;
				SETTINGS.saveLayoutSettings = true;
				}
			//=================================================================
			//============== restoreLastSession ===================================
			var projectIsRestored = false; // флаг успешного восстановления проекта
			if( APP_SETTINGS.restoreLastSession ){
				var lastSession = script.userPrefs( 'lastSession' );
				if( lastSession && lastSession.constructor == Array )
					for( var i = 0; i < lastSession.length; i++ ){
						if( lastSession[i].constructor == Object ){
							LIB.setObject( LIB.setProject(), lastSession[i] );
							projectIsRestored = true;
							}
						else{
							var file = lastSession[i].constructor == File ? lastSession[i] : File( lastSession[i] );
							if( file.exists ){
								LIB.setProject( {file: file} );
								projectIsRestored = true;
								}
							}
						}
				}
			if( !projectIsRestored ) // если ни один документ не восстановлен
				LIB.setProject(); // создаем пустой документ, дабы инициализировать все диалоги
			//=================================================================
			win.onClose = function(){
				var items = win.builder.projects.items;
				var lastSession = script.userPrefs( 'lastSession', [] ); // обнуляем lastSession в настройках
				try{
				for( var i = items.length-1; i > -1; i-- ){
					// visible не используется, поэтому это делать необязательно
	//				LIB.setCurrentProject( items[i].project );// активируем, чтобы корректно сохранились значения visible
					if( items[i].project.file ){
						lastSession.unshift( items[i].project.file/*.absoluteURI*/ );
						if( SETTINGS.confirmBeforeExit && !LIB.closeProject(items[i].project) )
							return false;
						}
					else{
						if( APP_SETTINGS.restoreLastSession )
							lastSession.unshift( LIB.getArgsOfProject(items[i].project) ); // записываем, но не закрываем
						else if( SETTINGS.confirmBeforeExit && !LIB.closeProject(items[i].project) )
							return false;
						}
					}
				}catch(err){script.alertError(err)}
				if( lastSession.length )
					script.userPrefs( 'lastSession', lastSession );
					
				script.userPrefs( 'APP_SETTINGS', SETTINGS.saveAppSettings ? APP_SETTINGS : false );
				script.userPrefs( 'LAYOUT_SETTINGS', SETTINGS.saveLayoutSettings ? LAYOUT_SETTINGS : false );
				script.userPrefs( 'AUTO_SETTINGS', SETTINGS.saveAutoSettings ? AUTO_SETTINGS : false );
				script.userPrefs( 'OUTPUT_SETTINGS', SETTINGS.saveOutputSettings ? OUTPUT_SETTINGS : false );
				script.userPrefs( 'PREFERRED_NAMES', SETTINGS.savePreferredNames ? PREFERRED_NAMES : false );
				script.userPrefs( 'viewMoveChildren', win.obj.Controls.moveChildren.visible );
				recentDocuments.rememberRecentDocuments();
				// СОХРАНЯЕМ НАСТРОЙКИ
				script.saveScriptPrefs();
				}
			//=================================================================
			//script.consol( 'end init()' );
			}catch(err){script.alertError(err);}
			},
		}
	return uiBuilderLibrary;
	}
// ДИАЛОГ НАСТРОЙКИ СКРИПТА ===================================
function pref(){
	try{
	var fontsList = win.obj.Local.Font.Name;
	//======================================================
	var winPref = new Window("dialog", script.name + ' Settings', [0,0,485,470], );
	with(winPref){
		winPref.listBox = add( "listbox", [5,5,205,440], undefined, {items: ['Program settings','Auto settings','Preferred names','Output settings'], } );
		winPref.programSettings = add( "panel", [210,0,480,465], 'Program settings' );
		with(winPref.programSettings){
			winPref.programSettings.restoreLastSession = add( "checkbox", [5,21,205,41], 'restore last session', {name: 'restoreLastSession', } );
			winPref.programSettings.recentProjectsList = add( "checkbox", [5,46,250,66], 'recent projects list (afte reboot)', {name: 'recentProjectsList', } );
			winPref.programSettings.highlightCurrentObject = add( "checkbox", [5,71,205,91], 'highlight current object', {name: 'highlightCurrentObject', } );
			winPref.programSettings.Color = add( "group", [25,96,245,118], undefined );
			with(winPref.programSettings.Color){
				winPref.programSettings.Color.Picker = add( "button", [0,0,70,22], 'Color' );
				winPref.programSettings.Color.Preview = add( "panel", [75,0,145,22], undefined );
				winPref.programSettings.Color.Default = add( "button", [150,0,220,22], 'Default' );
				}
			winPref.programSettings.modelessDialog = add( "checkbox", [5,123,230,143], 'modeless dialog (after reboot)', {name: 'modelessDialog', } );
			winPref.programSettings.panel = add( "panel", [5,153,260,155], undefined );
			winPref.programSettings.step = add( "group", [5,165,170,186], undefined );
			with(winPref.programSettings.step){
				winPref.programSettings.step.edit = add( "edittext", [0,0,40,20], undefined, {name: 'userStep', } );
				winPref.programSettings.step.item = add( "statictext", [45,1,165,21], 'step of keys' );
				}
			winPref.programSettings.panel = add( "panel", [5,196,260,198], undefined );
			winPref.programSettings.fonts = add( "group", [5,203,245,279], undefined );
			with(winPref.programSettings.fonts){
				winPref.programSettings.fonts.list = add( "dropdownlist", [0,21,145,43], undefined, {items: fontsList.items.toString().split(','), } );
				winPref.programSettings.fonts.del = add( "button", [155,20,240,42], 'delete' );
				winPref.programSettings.fonts.editName = add( "edittext", [0,55,145,75], undefined );
				winPref.programSettings.fonts.Add = add( "button", [155,54,240,76], 'add font' );
				winPref.programSettings.fonts.sText = add( "statictext", [0,0,210,20], 'Fonts:' );
				winPref.programSettings.fonts.sText.graphics.font = ScriptUI.newFont(winPref.programSettings.fonts.sText.graphics.font.name, 'Bold', winPref.programSettings.fonts.sText.graphics.font.size);
				}
			winPref.programSettings.workingDirectory = add( "button", [110,428,260,450], 'Working directory' );
			}
		winPref.autoSettings = add( "panel", [210,0,480,465], 'Auto settings' );
		with(winPref.autoSettings){
			winPref.autoSettings.PreferredSize = add( "group", [5,15,250,272], undefined );
			with(winPref.autoSettings.PreferredSize){
				winPref.autoSettings.PreferredSize.sText = add( "statictext", [0,0,150,20], 'Preferred size:' );
				winPref.autoSettings.PreferredSize.sText.graphics.font = ScriptUI.newFont(winPref.autoSettings.PreferredSize.sText.graphics.font.name, 'Bold', winPref.autoSettings.PreferredSize.sText.graphics.font.size);
				winPref.autoSettings.PreferredSize.item = add( "statictext", [205,5,245,25], 'height' );
				winPref.autoSettings.PreferredSize.item = add( "statictext", [155,5,195,25], 'width' );
				winPref.autoSettings.PreferredSize.H_but = add( "edittext", [205,25,245,45], undefined, {name: 'autoSizeH_button', } );
				winPref.autoSettings.PreferredSize.W_but = add( "edittext", [155,25,195,45], undefined, {name: 'autoSizeW_button', } );
				winPref.autoSettings.PreferredSize.item = add( "statictext", [5,27,145,47], 'button / iconButton' );
				winPref.autoSettings.PreferredSize.item.justify = "right";
				winPref.autoSettings.PreferredSize.H_cBox = add( "edittext", [205,55,245,75], undefined, {name: 'autoSizeH_checkbox', } );
				winPref.autoSettings.PreferredSize.W_cBox = add( "edittext", [155,55,195,75], undefined, {name: 'autoSizeW_checkbox', } );
				winPref.autoSettings.PreferredSize.item = add( "statictext", [5,57,145,77], 'checkBox' );
				winPref.autoSettings.PreferredSize.item.justify = "right";
				winPref.autoSettings.PreferredSize.H_rBut = add( "edittext", [205,85,245,105], undefined, {name: 'autoSizeH_radiobutton', } );
				winPref.autoSettings.PreferredSize.W_rBut = add( "edittext", [155,85,195,105], undefined, {name: 'autoSizeW_radiobutton', } );
				winPref.autoSettings.PreferredSize.item = add( "statictext", [5,87,145,107], 'radioButton' );
				winPref.autoSettings.PreferredSize.item.justify = "right";
				winPref.autoSettings.PreferredSize.H_sText = add( "edittext", [205,115,245,135], undefined, {name: 'autoSizeH_statictext', } );
				winPref.autoSettings.PreferredSize.W_sText = add( "edittext", [155,115,195,135], undefined, {name: 'autoSizeW_statictext', } );
				winPref.autoSettings.PreferredSize.item = add( "statictext", [5,117,145,137], 'staticText' );
				winPref.autoSettings.PreferredSize.item.justify = "right";
				winPref.autoSettings.PreferredSize.H_eText = add( "edittext", [205,145,245,165], undefined, {name: 'autoSizeH_edittext', } );
				winPref.autoSettings.PreferredSize.W_eText = add( "edittext", [155,145,195,165], undefined, {name: 'autoSizeW_edittext', } );
				winPref.autoSettings.PreferredSize.item = add( "statictext", [5,147,145,167], 'editText' );
				winPref.autoSettings.PreferredSize.item.justify = "right";
				winPref.autoSettings.PreferredSize.H_ddList = add( "edittext", [205,180,245,200], undefined, {name: 'autoSizeH_ddList', } );
				winPref.autoSettings.PreferredSize.item = add( "statictext", [5,182,195,217], 'dropDownList, scrollBar, slider, progressBar', {multiline: 'true', } );
				winPref.autoSettings.PreferredSize.item.justify = "right";
				winPref.autoSettings.PreferredSize.H_panel = add( "edittext", [205,215,245,235], undefined, {name: 'autoSizeH_panel', } );
				winPref.autoSettings.PreferredSize.item = add( "statictext", [15,217,195,252], 'panel, group, listBox, treeView, flashPlayer, image', {multiline: 'true', } );
				winPref.autoSettings.PreferredSize.item.justify = "right";
				}
			winPref.autoSettings.autoIndent = add( "group", [5,287,250,328], undefined );
			with(winPref.autoSettings.autoIndent){
				winPref.autoSettings.autoIndent.onWidth = add( "edittext", [0,20,40,40], undefined, {name: 'autoIndentW', } );
				winPref.autoSettings.autoIndent.item = add( "statictext", [45,21,120,41], 'on width' );
				winPref.autoSettings.autoIndent.onHeight = add( "edittext", [125,20,165,40], undefined, {name: 'autoIndentH', } );
				winPref.autoSettings.autoIndent.item = add( "statictext", [170,21,250,41], 'on height' );
				winPref.autoSettings.autoIndent.sText = add( "statictext", [0,0,150,20], 'Auto indent:' );
				winPref.autoSettings.autoIndent.sText.graphics.font = ScriptUI.newFont(winPref.autoSettings.autoIndent.sText.graphics.font.name, 'Bold', winPref.autoSettings.autoIndent.sText.graphics.font.size);
				}
			winPref.autoSettings.panel = add( "panel", [5,274,250,276], undefined );
			winPref.autoSettings.Default = add( "button", [180,340,250,362], 'Default' );
			}
		winPref.outputSettings = add( "panel", [210,0,480,465], 'Output settings' );
		with(winPref.outputSettings){
			winPref.outputSettings.createFunctions = add( "checkbox", [5,20,245,40], ' to create functions for objects' );
			winPref.outputSettings.code_Var = add( "checkbox", [5,45,245,65], ' to declare variables through \'var\'' );
			winPref.outputSettings.varAsTree = add( "checkbox", [5,70,245,90], ' tree variables' );
			winPref.outputSettings.tabLevels = add( "checkbox", [5,95,175,115], ' to tabulate levels' );
			winPref.outputSettings.Default = add( "button", [190,115,260,137], 'Default' );
			}
		winPref.preferredNames = add( "panel", [210,0,480,465], 'Preferred names' );
		with(winPref.preferredNames){
			winPref.preferredNames.panel = add( "edittext", [115,15,260,35], undefined, {name: 'panel', } );
			winPref.preferredNames.group = add( "edittext", [115,40,260,60], undefined, {name: 'group', } );
			winPref.preferredNames.line = add( "panel", [5,65,260,67], undefined );
			winPref.preferredNames.dropdownlist = add( "edittext", [115,70,260,90], undefined, {name: 'dropdownlist', } );
			winPref.preferredNames.listbox = add( "edittext", [115,95,260,115], undefined, {name: 'listbox', } );
			winPref.preferredNames.treeview = add( "edittext", [115,120,260,140], undefined, {name: 'treeview', } );
			winPref.preferredNames.line = add( "panel", [5,145,260,147], undefined );
			winPref.preferredNames.edittext = add( "edittext", [115,150,260,170], undefined, {name: 'edittext', } );
			winPref.preferredNames.checkbox = add( "edittext", [115,175,260,195], undefined, {name: 'checkbox', } );
			winPref.preferredNames.radiobutton = add( "edittext", [115,200,260,220], undefined, {name: 'radiobutton', } );
			winPref.preferredNames.button = add( "edittext", [115,225,260,245], undefined, {name: 'button', } );
			winPref.preferredNames.iconbutton = add( "edittext", [115,250,260,270], undefined, {name: 'iconbutton', } );
			winPref.preferredNames.scrollbar = add( "edittext", [115,275,260,295], undefined, {name: 'scrollbar', } );
			winPref.preferredNames.slider = add( "edittext", [115,300,260,320], undefined, {name: 'slider', } );
			winPref.preferredNames.line = add( "panel", [5,325,260,327], undefined );
			winPref.preferredNames.statictext = add( "edittext", [115,330,260,350], undefined, {name: 'statictext', } );
			winPref.preferredNames.progressbar = add( "edittext", [115,355,260,375], undefined, {name: 'progressbar', } );
			winPref.preferredNames.flashplayer = add( "edittext", [115,380,260,400], undefined, {name: 'flashplayer', } );
			winPref.preferredNames.image = add( "edittext", [115,405,260,425], undefined, {name: 'image', } );
			winPref.preferredNames.item = add( "statictext", [0,17,105,37], 'panel' );
			winPref.preferredNames.item.justify = "right";
			winPref.preferredNames.item = add( "statictext", [0,42,105,62], 'group' );
			winPref.preferredNames.item.justify = "right";
			winPref.preferredNames.item = add( "statictext", [0,72,105,92], 'dropdownlist' );
			winPref.preferredNames.item.justify = "right";
			winPref.preferredNames.item = add( "statictext", [0,97,105,117], 'listbox' );
			winPref.preferredNames.item.justify = "right";
			winPref.preferredNames.item = add( "statictext", [0,122,105,142], 'treeview' );
			winPref.preferredNames.item.justify = "right";
			winPref.preferredNames.item = add( "statictext", [0,152,105,172], 'edittext' );
			winPref.preferredNames.item.justify = "right";
			winPref.preferredNames.item = add( "statictext", [0,177,105,197], 'checkbox' );
			winPref.preferredNames.item.justify = "right";
			winPref.preferredNames.item = add( "statictext", [0,202,105,222], 'radiobutton' );
			winPref.preferredNames.item.justify = "right";
			winPref.preferredNames.item = add( "statictext", [0,227,105,247], 'button' );
			winPref.preferredNames.item.justify = "right";
			winPref.preferredNames.item = add( "statictext", [0,252,105,272], 'iconbutton' );
			winPref.preferredNames.item.justify = "right";
			winPref.preferredNames.item = add( "statictext", [0,277,105,297], 'scrollbar' );
			winPref.preferredNames.item.justify = "right";
			winPref.preferredNames.item = add( "statictext", [0,302,105,322], 'slider' );
			winPref.preferredNames.item.justify = "right";
			winPref.preferredNames.item = add( "statictext", [0,332,105,352], 'statictext' );
			winPref.preferredNames.item.justify = "right";
			winPref.preferredNames.item = add( "statictext", [0,357,105,377], 'progressbar' );
			winPref.preferredNames.item.justify = "right";
			winPref.preferredNames.item = add( "statictext", [0,382,105,402], 'flashplayer' );
			winPref.preferredNames.item.justify = "right";
			winPref.preferredNames.item = add( "statictext", [0,407,105,427], 'image' );
			winPref.preferredNames.item.justify = "right";
			winPref.preferredNames.Default = add( "button", [5,430,75,452], 'Default' );
			}
		winPref.Close = add( "button", [5,444,75,466], 'Close' );
		}
	//================ winPref.listBox ======================
	winPref.listBox.onChange = function(){
		if( !this.selection )
			return;
		winPref.programSettings.visible =
		winPref.autoSettings.visible =
		winPref.preferredNames.visible = 
		winPref.outputSettings.visible = false;
		switch( this.selection.text ){
			case 'Program settings':
				return winPref.programSettings.visible = true;
			case 'Auto settings':
				return winPref.autoSettings.visible = true;
			case 'Preferred names':
				return winPref.preferredNames.visible = true;
			case 'Output settings':
				return winPref.outputSettings.visible = true;
			}
		}
	winPref.listBox.selection = 0;
	winPref.listBox.onChange();
	//================AUTO SETTINGS ======================
	var loadAutoSettings = function(){
		winPref.autoSettings.PreferredSize.H_but.text = AUTO_SETTINGS.autoSize['button'][1];
		winPref.autoSettings.PreferredSize.W_but.text = AUTO_SETTINGS.autoSize['button'][0];
		winPref.autoSettings.PreferredSize.H_cBox.text = AUTO_SETTINGS.autoSize['checkbox'][1];
		winPref.autoSettings.PreferredSize.W_cBox.text = AUTO_SETTINGS.autoSize['checkbox'][0];
		winPref.autoSettings.PreferredSize.H_rBut.text = AUTO_SETTINGS.autoSize['radiobutton'][1];
		winPref.autoSettings.PreferredSize.W_rBut.text = AUTO_SETTINGS.autoSize['radiobutton'][0];
		winPref.autoSettings.PreferredSize.H_sText.text = AUTO_SETTINGS.autoSize['statictext'][1];
		winPref.autoSettings.PreferredSize.W_sText.text = AUTO_SETTINGS.autoSize['statictext'][0];
		winPref.autoSettings.PreferredSize.H_eText.text = AUTO_SETTINGS.autoSize['edittext'][1];
		winPref.autoSettings.PreferredSize.W_eText.text = AUTO_SETTINGS.autoSize['edittext'][0];
		winPref.autoSettings.PreferredSize.H_ddList.text = AUTO_SETTINGS.autoSize['dropdownlist'][1];
		winPref.autoSettings.PreferredSize.H_panel.text = AUTO_SETTINGS.autoSize['panel'][1];
		winPref.autoSettings.autoIndent.onHeight.text = AUTO_SETTINGS.autoIndent[1];
		winPref.autoSettings.autoIndent.onWidth.text = AUTO_SETTINGS.autoIndent[0];
		}
	winPref.autoSettings.PreferredSize.H_but.onChanging = 
	winPref.autoSettings.PreferredSize.W_but.onChanging = 
	winPref.autoSettings.PreferredSize.H_cBox.onChanging = 
	winPref.autoSettings.PreferredSize.W_cBox.onChanging = 
	winPref.autoSettings.PreferredSize.H_rBut.onChanging = 
	winPref.autoSettings.PreferredSize.W_rBut.onChanging = 
	winPref.autoSettings.PreferredSize.H_sText.onChanging = 
	winPref.autoSettings.PreferredSize.W_sText.onChanging = 
	winPref.autoSettings.PreferredSize.H_eText.onChanging = 
	winPref.autoSettings.PreferredSize.W_eText.onChanging = 
	winPref.autoSettings.PreferredSize.H_ddList.onChanging = 
	winPref.autoSettings.PreferredSize.H_panel.onChanging = 
	winPref.autoSettings.autoIndent.onHeight.onChanging = 
	winPref.autoSettings.autoIndent.onWidth.onChanging = CORRECTS.dataCorrectEnter_forInterface;
	
	winPref.autoSettings.PreferredSize.H_but.onChange = 
	winPref.autoSettings.PreferredSize.W_but.onChange = 
	winPref.autoSettings.PreferredSize.H_cBox.onChange = 
	winPref.autoSettings.PreferredSize.W_cBox.onChange = 
	winPref.autoSettings.PreferredSize.H_rBut.onChange = 
	winPref.autoSettings.PreferredSize.W_rBut.onChange = 
	winPref.autoSettings.PreferredSize.H_sText.onChange = 
	winPref.autoSettings.PreferredSize.W_sText.onChange = 
	winPref.autoSettings.PreferredSize.H_eText.onChange = 
	winPref.autoSettings.PreferredSize.W_eText.onChange = 
	winPref.autoSettings.PreferredSize.H_ddList.onChange = 
	winPref.autoSettings.PreferredSize.H_panel.onChange = 
	winPref.autoSettings.autoIndent.onHeight.onChange = 
	winPref.autoSettings.autoIndent.onWidth.onChange = function(){
		var num = parseInt( CORRECTS.dataCorrect(this.text) );//запрет на отрицательное значение
		switch( this.properties.name ){
			case 'autoSizeH_button':
				this.text = AUTO_SETTINGS.autoSize['button'][1] = num > 0 ? num : AUTO_SETTINGS.autoSize['button'][1];
			break;
			case 'autoSizeW_button':
				this.text = AUTO_SETTINGS.autoSize['button'][0] = num > 0 ? num : AUTO_SETTINGS.autoSize['button'][0];
			break;
			case 'autoSizeH_checkbox':
				this.text = AUTO_SETTINGS.autoSize['checkbox'][1] = num > 0 ? num : AUTO_SETTINGS.autoSize['checkbox'][1];
			break;
			case 'autoSizeW_checkbox':
				this.text = AUTO_SETTINGS.autoSize['checkbox'][0] = num > 0 ? num : AUTO_SETTINGS.autoSize['checkbox'][0];
			break;
			case 'autoSizeH_radiobutton':
				this.text = AUTO_SETTINGS.autoSize['radiobutton'][1] = num > 0 ? num : AUTO_SETTINGS.autoSize['radiobutton'][1];
			break;
			case 'autoSizeW_radiobutton':
				this.text = AUTO_SETTINGS.autoSize['radiobutton'][0] = num > 0 ? num : AUTO_SETTINGS.autoSize['radiobutton'][0];
			break;
			case 'autoSizeH_statictext':
				this.text = AUTO_SETTINGS.autoSize['statictext'][1] = num > 0 ? num : AUTO_SETTINGS.autoSize['statictext'][1];
			break;
			case 'autoSizeW_statictext':
				this.text = AUTO_SETTINGS.autoSize['statictext'][0] = num > 0 ? num : AUTO_SETTINGS.autoSize['statictext'][0];
			break;
			case 'autoSizeH_edittext':
				this.text = AUTO_SETTINGS.autoSize['edittext'][1] = num > 0 ? num : AUTO_SETTINGS.autoSize['edittext'][1];
			break;
			case 'autoSizeW_edittext':
				this.text = AUTO_SETTINGS.autoSize['edittext'][0] = num > 0 ? num : AUTO_SETTINGS.autoSize['edittext'][0];
			break;
			case 'autoSizeH_ddList':
				this.text = 
				AUTO_SETTINGS.autoSize['dropdownlist'][1] = 
				AUTO_SETTINGS.autoSize['progressbar'][1] = 
				AUTO_SETTINGS.autoSize['scrollbar'][1] = 
				AUTO_SETTINGS.autoSize['slider'][1] = 
				num > 0 ? num : AUTO_SETTINGS.autoSize['dropdownlist'][1];
			break;
			case 'autoSizeH_panel':
				this.text = 
				AUTO_SETTINGS.autoSize['panel'][1] = 
				AUTO_SETTINGS.autoSize['listbox'][1] = 
				AUTO_SETTINGS.autoSize['treeview'][1] = 
				AUTO_SETTINGS.autoSize['group'][1] = 
				AUTO_SETTINGS.autoSize['flashplayer'][1] = 
				AUTO_SETTINGS.autoSize['image'][1] = 
				num > 0 ? num : AUTO_SETTINGS.autoSize['panel'][1];
			break;
			case 'autoIndentH':
				AUTO_SETTINGS.autoIndent[1] = num;
			break;
			case 'autoIndentW':
				AUTO_SETTINGS.autoIndent[0] = num;
			break;
			}
		SETTINGS.saveAutoSettings = true;
		}
	winPref.autoSettings.Default.onClick = function(){
		SETTINGS.setAutoSettings();
		loadAutoSettings();
		}
	loadAutoSettings(); // покзываем
	//================ OUTPUT SETTINGS ======================
	var loadOutputSettings  = function(){
		winPref.outputSettings.createFunctions.value = OUTPUT_SETTINGS.code_createFunctions;
		winPref.outputSettings.tabLevels.value = OUTPUT_SETTINGS.tabCode;
		winPref.outputSettings.varAsTree.value = OUTPUT_SETTINGS.code_varAsTree;
		winPref.outputSettings.code_Var.value = OUTPUT_SETTINGS.varAdd ? true : false;
//		winPref.outputSettings.code_Var.enabled = !winPref.outputSettings.varAsTree.value;
		}
	loadOutputSettings();
	
	winPref.outputSettings.createFunctions.onClick = function(){
		OUTPUT_SETTINGS.code_createFunctions = this.value;
		SETTINGS.saveOutputSettings = true;
		}
	winPref.outputSettings.tabLevels.onClick = function(){
		OUTPUT_SETTINGS.tabCode = this.value;
		SETTINGS.saveOutputSettings = true;
		}
	winPref.outputSettings.code_Var.onClick = function(){
		OUTPUT_SETTINGS.varAdd = this.value ? 'var ' : '';
		SETTINGS.saveOutputSettings = true;
		}
	winPref.outputSettings.varAsTree.onClick = function(){
		OUTPUT_SETTINGS.code_varAsTree = this.value;
		SETTINGS.saveOutputSettings = true;
		}
	winPref.outputSettings.Default.onClick = function(){
		SETTINGS.setOutputSettings();
		loadOutputSettings();
		}
	//================ PREFERRED NAMES ========================
	var loadPreferredNames  = function(){
		winPref.preferredNames.panel.text = PREFERRED_NAMES.panel;
		winPref.preferredNames.group.text = PREFERRED_NAMES.group;
		
		winPref.preferredNames.dropdownlist.text = PREFERRED_NAMES.dropdownlist;
		winPref.preferredNames.listbox.text = PREFERRED_NAMES.listbox;
		winPref.preferredNames.treeview.text = PREFERRED_NAMES.treeview;

		winPref.preferredNames.edittext.text = PREFERRED_NAMES.edittext;
		winPref.preferredNames.checkbox.text = PREFERRED_NAMES.checkbox;
		winPref.preferredNames.radiobutton.text = PREFERRED_NAMES.radiobutton;
		winPref.preferredNames.button.text = PREFERRED_NAMES.button;
		winPref.preferredNames.iconbutton.text = PREFERRED_NAMES.iconbutton;
		winPref.preferredNames.scrollbar.text = PREFERRED_NAMES.scrollbar;
		winPref.preferredNames.slider.text = PREFERRED_NAMES.slider;
		
		winPref.preferredNames.statictext.text = PREFERRED_NAMES.statictext;
		winPref.preferredNames.progressbar.text = PREFERRED_NAMES.progressbar;
		winPref.preferredNames.flashplayer.text = PREFERRED_NAMES.flashplayer;
		winPref.preferredNames.image.text = PREFERRED_NAMES.image;
		}
	loadPreferredNames();
	var reInitVarsBasa = false;
	
	winPref.preferredNames.panel.onChanging = 
	winPref.preferredNames.group.onChanging = 
	winPref.preferredNames.dropdownlist.onChanging = 
	winPref.preferredNames.listbox.onChanging = 
	winPref.preferredNames.treeview.onChanging = 
	winPref.preferredNames.edittext.onChanging = 
	winPref.preferredNames.checkbox.onChanging = 
	winPref.preferredNames.radiobutton.onChanging = 
	winPref.preferredNames.button.onChanging = 
	winPref.preferredNames.iconbutton.onChanging = 
	winPref.preferredNames.scrollbar.onChanging = 
	winPref.preferredNames.slider.onChanging = 
	winPref.preferredNames.statictext.onChanging = 
	winPref.preferredNames.progressbar.onChanging = 
	winPref.preferredNames.flashplayer.onChanging = 
	winPref.preferredNames.image.onChanging = CORRECTS.varCorrectChanging_forInterface;
	
	winPref.preferredNames.panel.onChange = 
	winPref.preferredNames.group.onChange = 
	winPref.preferredNames.dropdownlist.onChange = 
	winPref.preferredNames.listbox.onChange = 
	winPref.preferredNames.treeview.onChange = 
	winPref.preferredNames.edittext.onChange = 
	winPref.preferredNames.checkbox.onChange = 
	winPref.preferredNames.radiobutton.onChange = 
	winPref.preferredNames.button.onChange = 
	winPref.preferredNames.iconbutton.onChange = 
	winPref.preferredNames.scrollbar.onChange = 
	winPref.preferredNames.slider.onChange = 
	winPref.preferredNames.statictext.onChange = 
	winPref.preferredNames.progressbar.onChange = 
	winPref.preferredNames.flashplayer.onChange = 
	winPref.preferredNames.image.onChange = function(){
		if( !this.properties || !this.properties.name )
			return;
		if( !this.text )
			this.text = PREFERRED_NAMES[this.properties.name];
		else{
			this.text = CORRECTS.varCorrect( this.text );
			PREFERRED_NAMES[this.properties.name] = this.text;
			}
		SETTINGS.savePreferredNames = true;
		reInitVarsBasa = true;
		}
	winPref.addEventListener( 'close', function(){if(reInitVarsBasa) uiBuilderLibrary.initVarsBasa()} );
	winPref.preferredNames.Default.onClick = function(){
		reInitVarsBasa = true;
		SETTINGS.setPreferredNames();
		loadPreferredNames();
		}
	//================ PROGRAMM SETTINGS ======================
	// FONTS ======================
	// закрываем доступ к первым трем
	winPref.programSettings.fonts.list.children[0].enabled = false;
	winPref.programSettings.fonts.list.children[1].enabled = false;
	winPref.programSettings.fonts.list.children[2].enabled = false;
	
	winPref.programSettings.fonts.editName.onChange = function(){
		if(/^\s+$/.test(this.text))
			this.text = '';
		}
	winPref.programSettings.fonts.del.onClick = function(){
		if( !winPref.programSettings.fonts.list.selection )
			return;
		var NAME = winPref.programSettings.fonts.list.selection.text;
		if( fontsList.selection && fontsList.selection.text == NAME )
			return alert( 'This font is used' );
		winPref.programSettings.fonts.list.remove( NAME );
		fontsList.remove( NAME );
		for( var i = 3; i < APP_SETTINGS.fonts.length; i++ )
			if( APP_SETTINGS.fonts[i] == NAME ){
				APP_SETTINGS.fonts.splice( i, 1 );
				break;
				}
		SETTINGS.saveAppSettings = true;
		}
	winPref.programSettings.fonts.Add.onClick = function(){
		try{
		var NAME = winPref.programSettings.fonts.editName.text;
		if( /^\s*?$/.test(NAME) )
			return;
		if( NAME=='[none]' ){
			alert('Incorrect name!');
			winPref.programSettings.fonts.editName.text='';
			return;
			}
		if( winPref.programSettings.fonts.list.find(NAME) ){
			alert('This name already is present.');
			return;
			}
		if( !WORKS.testFontName(NAME) ){
			var res = confirm('Incorrect name!\rYou are assured?');
			if(!res)
				return;
			}
		winPref.programSettings.fonts.list.selection = winPref.programSettings.fonts.list.add( 'item', NAME );
		winPref.programSettings.fonts.editName.text='';
		
		fontsList.add( 'item', NAME );
		APP_SETTINGS.fonts.push( NAME );
		SETTINGS.saveAppSettings = true;
		}catch(err){script.alertError(err);}
		}
	//  Working directory
	winPref.programSettings.workingDirectory.onClick = function(){
		var dir = script.getWorkingDirectory();
		if( dir )
			dir.execute();
		}
	// STEP ======================
	winPref.programSettings.step.edit.text = APP_SETTINGS.userStep;
	winPref.programSettings.step.edit.onChanging = CORRECTS.dataCorrectEnter_forInterface;
	winPref.programSettings.step.edit.onChange = function(){
		 this.text = APP_SETTINGS.userStep = +this.text > 0 ? +this.text : APP_SETTINGS.userStep;
		 SETTINGS.saveAppSettings = true;
		}
	// OTHER ======================
	if( File.fs != 'Windows' || (script.getAppName('photoshop') && script.appVersionCS() > 4) )
		winPref.programSettings.highlightCurrentObject.enabled = false;
	if( File.fs != 'Windows' || !script.getAppName('indesign') )
		winPref.programSettings.modelessDialog.enabled = false;
	if( script.getAppName('photoshop') )
		winPref.programSettings.recentProjectsList.enabled = false;
	winPref.programSettings.restoreLastSession.value = APP_SETTINGS.restoreLastSession;
	winPref.programSettings.recentProjectsList.value = APP_SETTINGS.recentProjectsList;
	winPref.programSettings.highlightCurrentObject.value = winPref.programSettings.Color.enabled = APP_SETTINGS.highlightCurrentObject;
	winPref.programSettings.modelessDialog.value = APP_SETTINGS.modelessDialog;
	
	winPref.programSettings.restoreLastSession.onClick = 
	winPref.programSettings.recentProjectsList.onClick = 
	winPref.programSettings.highlightCurrentObject.onClick = 
	winPref.programSettings.modelessDialog.onClick = function(){
		APP_SETTINGS[this.properties.name] = this.value;
		SETTINGS.saveAppSettings = true;
		if( this.properties.name == 'highlightCurrentObject' ){
			 winPref.programSettings.Color.enabled = APP_SETTINGS[this.properties.name];
			var items = win.builder.projects.items;
			for( var i = 0; i < items.length; i++ )
				APP_SETTINGS.highlightCurrentObject ? uiBuilderLibrary.highlightObject( items[i].project.currentObject ) : uiBuilderLibrary.unHighlightObject( items[i].project.currentObject );
			}
		}
	// highlightColor
	script.addColor( winPref.programSettings.Color.Preview, 0, APP_SETTINGS.highlightColor ? APP_SETTINGS.highlightColor : SETTINGS.highlightColor, 1 );
	winPref.programSettings.Color.Default.enabled = ( APP_SETTINGS.highlightColor );
	winPref.programSettings.Color.Default.onClick = function(){
		APP_SETTINGS.highlightColor = undefined;
		script.addColor( winPref.programSettings.Color.Preview, 0, SETTINGS.highlightColor, 1 );
		this.enabled = false;
		}
	winPref.programSettings.Color.Picker.onClick = function(){
		var RGB = script.getColorPicker( APP_SETTINGS.highlightColor );
		if( !RGB )
			return;
		APP_SETTINGS.highlightColor = RGB;
		script.addColor( winPref.programSettings.Color.Preview, 0, APP_SETTINGS.highlightColor, 1 );
		winPref.programSettings.Color.Default.enabled = true;
		}
	//===========================================================
	//===========================================================
	winPref.Close.onClick = function(){
		this.window.close();
		}
	winPref.center();
	winPref.show();
	}catch(err){script.alertError(err);}
	}